#![allow(clippy::module_inception)]
#![allow(clippy::upper_case_acronyms)]
#![allow(clippy::large_enum_variant)]
#![allow(clippy::wrong_self_convention)]
#![allow(clippy::should_implement_trait)]
#![allow(clippy::blacklisted_name)]
#![allow(clippy::vec_init_then_push)]
#![allow(rustdoc::bare_urls)]
//! <p>The AWS Budgets API enables you to use AWS Budgets to plan your service usage, service costs, and instance reservations. The API reference provides descriptions, syntax, and usage examples for each of the actions and data types for AWS Budgets. </p>
//! <p>Budgets provide you with a way to see the following information:</p>
//! <ul>
//! <li>
//! <p>How close your plan is to your budgeted amount or to the free tier limits</p>
//! </li>
//! <li>
//! <p>Your usage-to-date, including how much you've used of your Reserved Instances (RIs)</p>
//! </li>
//! <li>
//! <p>Your current estimated charges from AWS, and how much your predicted usage will accrue in charges by the end of the month</p>
//! </li>
//! <li>
//! <p>How much of your budget has been used</p>
//! </li>
//! </ul>
//! <p>AWS updates your budget status several times a day. Budgets track your unblended costs, subscriptions, refunds, and RIs. You can create the following types of budgets:</p>
//! <ul>
//! <li>
//! <p>
//! <b>Cost budgets</b> - Plan how much you want to spend on a service.</p>
//! </li>
//! <li>
//! <p>
//! <b>Usage budgets</b> - Plan how much you want to use one or more services.</p>
//! </li>
//! <li>
//! <p>
//! <b>RI utilization budgets</b> - Define a utilization threshold, and receive alerts when your RI usage falls below that threshold. This lets you see if your RIs are unused or under-utilized.</p>
//! </li>
//! <li>
//! <p>
//! <b>RI coverage budgets</b> - Define a coverage threshold, and receive alerts when the number of your instance hours that are covered by RIs fall below that threshold. This lets you see how much of your instance usage is covered by a reservation.</p>
//! </li>
//! </ul>
//! <p>Service Endpoint</p>
//! <p>The AWS Budgets API provides the following endpoint:</p>
//! <ul>
//! <li>
//! <p>https://budgets.amazonaws.com</p>
//! </li>
//! </ul>
//! <p>For information about costs that are associated with the AWS Budgets API, see <a href="https://aws.amazon.com/aws-cost-management/pricing/">AWS Cost Management Pricing</a>.</p>

// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
pub use error_meta::Error;

pub use config::Config;

mod aws_endpoint;
#[cfg(feature = "client")]
pub mod client;
pub mod config;
pub mod error;
mod error_meta;
pub mod input;
mod json_deser;
mod json_errors;
mod json_ser;
pub mod model;
mod no_credentials;
pub mod operation;
mod operation_deser;
mod operation_ser;
pub mod output;
pub static PKG_VERSION: &str = env!("CARGO_PKG_VERSION");
pub use smithy_http::byte_stream::ByteStream;
pub use smithy_http::result::SdkError;
pub use smithy_types::Blob;
static API_METADATA: aws_http::user_agent::ApiMetadata =
    aws_http::user_agent::ApiMetadata::new("budgets", PKG_VERSION);
pub use aws_types::region::Region;
pub use aws_types::Credentials;
#[cfg(feature = "client")]
pub use client::Client;
pub use smithy_http::endpoint::Endpoint;
pub use smithy_types::retry::RetryConfig;
