// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
use std::fmt::Write;
/// See [`SearchInput`](crate::input::SearchInput)
pub mod search_input {
    /// A builder for [`SearchInput`](crate::input::SearchInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) cursor: std::option::Option<std::string::String>,
        pub(crate) expr: std::option::Option<std::string::String>,
        pub(crate) facet: std::option::Option<std::string::String>,
        pub(crate) filter_query: std::option::Option<std::string::String>,
        pub(crate) highlight: std::option::Option<std::string::String>,
        pub(crate) partial: std::option::Option<bool>,
        pub(crate) query: std::option::Option<std::string::String>,
        pub(crate) query_options: std::option::Option<std::string::String>,
        pub(crate) query_parser: std::option::Option<crate::model::QueryParser>,
        pub(crate) r#return: std::option::Option<std::string::String>,
        pub(crate) size: std::option::Option<i64>,
        pub(crate) sort: std::option::Option<std::string::String>,
        pub(crate) start: std::option::Option<i64>,
        pub(crate) stats: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Retrieves a cursor value you can use to page through large result sets.
        /// Use the <code>size</code> parameter to control the number of hits to include in each response. You can specify either the <code>cursor</code> or
        /// <code>start</code> parameter in a request; they are mutually exclusive. To get the first cursor, set the cursor value to <code>initial</code>. In subsequent requests, specify the cursor value returned in the hits section of the response. </p>
        /// <p>For more
        /// information, see <a href="http://docs.aws.amazon.com/cloudsearch/latest/developerguide/paginating-results.html">Paginating Results</a> in the <i>Amazon CloudSearch Developer Guide</i>.</p>
        pub fn cursor(mut self, input: impl Into<std::string::String>) -> Self {
            self.cursor = Some(input.into());
            self
        }
        pub fn set_cursor(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.cursor = input;
            self
        }
        /// <p>Defines one or more numeric expressions that can be used to sort results or specify search or filter
        /// criteria. You can also specify expressions as return fields. </p>
        /// <p>You specify the expressions in JSON using the form <code>{"EXPRESSIONNAME":"EXPRESSION"}</code>. You can define and use multiple expressions in a search request. For example:</p>
        /// <p><code>
        /// {"expression1":"_score*rating", "expression2":"(1/rank)*year"}
        /// </code> </p>
        /// <p>For information about the variables, operators, and functions you can use in expressions, see <a href="http://docs.aws.amazon.com/cloudsearch/latest/developerguide/configuring-expressions.html#writing-expressions">Writing Expressions</a>
        /// in the <i>Amazon CloudSearch Developer Guide</i>.</p>
        pub fn expr(mut self, input: impl Into<std::string::String>) -> Self {
            self.expr = Some(input.into());
            self
        }
        pub fn set_expr(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.expr = input;
            self
        }
        /// <p>Specifies one or more fields for which to get facet information, and options that control how the facet information is returned. Each specified field must be facet-enabled in the domain configuration. The fields and options are specified in JSON using the form <code>{"FIELD":{"OPTION":VALUE,"OPTION:"STRING"},"FIELD":{"OPTION":VALUE,"OPTION":"STRING"}}</code>.</p>
        /// <p>You can specify the following faceting options:</p>
        /// <ul>
        /// <li>
        /// <p><code>buckets</code> specifies an array of the facet values or
        /// ranges to count. Ranges are specified using the same syntax that you use to search for a range of values.
        /// For more information, see <a href="http://docs.aws.amazon.com/cloudsearch/latest/developerguide/searching-ranges.html">
        /// Searching for a Range of Values</a> in the <i>Amazon CloudSearch Developer Guide</i>. Buckets are returned in the order they
        /// are specified in the request. The <code>sort</code> and <code>size</code> options are
        /// not valid if you specify <code>buckets</code>.</p>
        /// </li>
        /// <li>
        /// <p><code>size</code> specifies the maximum number of facets to include in the results. By
        /// default, Amazon CloudSearch returns counts for the top 10. The
        /// <code>size</code> parameter is only valid when you specify
        /// the <code>sort</code> option; it cannot be used in conjunction
        /// with <code>buckets</code>.</p>
        /// </li>
        /// <li>
        /// <p><code>sort</code> specifies how you want to sort the facets in
        /// the results: <code>bucket</code> or <code>count</code>. Specify
        /// <code>bucket</code> to sort alphabetically or numerically by
        /// facet value (in ascending order). Specify <code>count</code> to
        /// sort by the facet counts computed for each facet value (in
        /// descending order). To retrieve facet counts for particular
        /// values or ranges of values, use the <code>buckets</code> option
        /// instead of <code>sort</code>. </p>
        /// </li>
        /// </ul>
        /// <p>If no facet options are specified, facet counts are computed for all field values, the facets are sorted by facet count, and the top 10 facets are returned in the results.</p>
        /// <p>To count particular buckets of values, use the <code>buckets</code> option. For example, the following request uses the <code>buckets</code> option to calculate and return facet counts by decade.</p>
        /// <p><code>
        /// {"year":{"buckets":["[1970,1979]","[1980,1989]","[1990,1999]","[2000,2009]","[2010,}"]}}
        /// </code></p>
        /// <p>To sort facets by facet count, use the <code>count</code> option. For example, the following request sets the <code>sort</code> option to <code>count</code> to sort the facet values by facet count, with the facet
        /// values that have the most matching documents listed first. Setting the <code>size</code> option to 3 returns only the top three facet values.</p>
        /// <p><code>
        /// {"year":{"sort":"count","size":3}}
        /// </code></p>
        /// <p>To sort the facets by value, use the <code>bucket</code> option. For example, the following  request sets the <code>sort</code> option to <code>bucket</code> to sort the facet values numerically by year, with earliest year listed first. </p>
        /// <p><code>
        /// {"year":{"sort":"bucket"}}
        /// </code></p>
        /// <p>For more
        /// information, see <a href="http://docs.aws.amazon.com/cloudsearch/latest/developerguide/faceting.html">Getting and Using Facet Information</a>
        /// in the <i>Amazon CloudSearch Developer Guide</i>.</p>
        pub fn facet(mut self, input: impl Into<std::string::String>) -> Self {
            self.facet = Some(input.into());
            self
        }
        pub fn set_facet(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.facet = input;
            self
        }
        /// <p>Specifies a structured query that filters the results of a search without affecting how the results are scored and sorted. You use <code>filterQuery</code> in conjunction with the <code>query</code> parameter to filter the documents that match the constraints specified in the <code>query</code> parameter. Specifying a filter controls only which matching documents are included in the results, it has no effect on how they are scored and sorted. The <code>filterQuery</code> parameter supports the full structured query syntax. </p>
        /// <p>For more information about using filters, see <a href="http://docs.aws.amazon.com/cloudsearch/latest/developerguide/filtering-results.html">Filtering Matching Documents</a>
        /// in the <i>Amazon CloudSearch Developer Guide</i>.</p>
        pub fn filter_query(mut self, input: impl Into<std::string::String>) -> Self {
            self.filter_query = Some(input.into());
            self
        }
        pub fn set_filter_query(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.filter_query = input;
            self
        }
        /// <p>Retrieves highlights for matches in the specified <code>text</code> or
        /// <code>text-array</code> fields. Each specified field must be highlight enabled in the domain configuration. The fields and options are specified in JSON using the form <code>{"FIELD":{"OPTION":VALUE,"OPTION:"STRING"},"FIELD":{"OPTION":VALUE,"OPTION":"STRING"}}</code>.</p>
        /// <p>You can specify the following highlight options:</p>
        /// <ul>
        /// <li>
        /// <code>format</code>: specifies the format of the data in the
        /// text field: <code>text</code> or <code>html</code>. When data is
        /// returned as HTML, all non-alphanumeric characters are encoded.
        /// The default is <code>html</code>.
        /// </li>
        /// <li>
        /// <code>max_phrases</code>: specifies the maximum number of
        /// occurrences of the search term(s) you want to highlight. By
        /// default, the first occurrence is highlighted.
        /// </li>
        /// <li>
        /// <code>pre_tag</code>: specifies the string to prepend to an
        /// occurrence of a search term. The default for HTML highlights is
        /// <code>&lt;em&gt;</code>. The default for text highlights is
        /// <code>*</code>.
        /// </li>
        /// <li>
        /// <code>post_tag</code>: specifies the string to append to an
        /// occurrence of a search term. The default for HTML highlights is
        /// <code>&lt;/em&gt;</code>. The default for text highlights is
        /// <code>*</code>.
        /// </li>
        /// </ul>
        /// <p>If no highlight options are specified for a field, the returned field text is treated as HTML and the first match is
        /// highlighted with emphasis tags:  <code>&lt;em>search-term&lt;/em&gt;</code>.</p>
        /// <p>For example, the following request retrieves highlights for the <code>actors</code> and <code>title</code> fields.</p>
        /// <p> <code>{
        /// "actors": {},
        /// "title": {"format": "text","max_phrases": 2,"pre_tag": "<b>","post_tag": "</b>"}
        /// }</code></p>
        pub fn highlight(mut self, input: impl Into<std::string::String>) -> Self {
            self.highlight = Some(input.into());
            self
        }
        pub fn set_highlight(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.highlight = input;
            self
        }
        /// <p>Enables partial results to be returned if one or more index partitions are unavailable. When your search index is partitioned across multiple search instances, by default Amazon CloudSearch only returns results if every partition can be queried. This means that the failure of a single search instance can result in 5xx (internal server) errors. When you enable partial results, Amazon CloudSearch returns whatever results are available and includes the percentage of documents searched in the search results (percent-searched). This enables you to more gracefully degrade your users' search experience. For example, rather than displaying no results, you could display the partial results and a message indicating that the results might be incomplete due to a temporary system outage.</p>
        pub fn partial(mut self, input: bool) -> Self {
            self.partial = Some(input);
            self
        }
        pub fn set_partial(mut self, input: std::option::Option<bool>) -> Self {
            self.partial = input;
            self
        }
        /// <p>Specifies the search criteria for the request. How you specify the search
        /// criteria depends on the query parser used for the request and the parser options
        /// specified in the <code>queryOptions</code> parameter. By default,
        /// the <code>simple</code> query parser is used to process requests. To use
        /// the <code>structured</code>, <code>lucene</code>, or <code>dismax</code> query parser,
        /// you must also specify the <code>queryParser</code> parameter. </p>
        /// <p>For more information about specifying search criteria, see <a href="http://docs.aws.amazon.com/cloudsearch/latest/developerguide/searching.html">Searching Your Data</a> in the <i>Amazon CloudSearch Developer Guide</i>.</p>
        pub fn query(mut self, input: impl Into<std::string::String>) -> Self {
            self.query = Some(input.into());
            self
        }
        pub fn set_query(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.query = input;
            self
        }
        /// <p>Configures options for the query parser specified in the <code>queryParser</code> parameter. You specify the options in JSON using the following form <code>{"OPTION1":"VALUE1","OPTION2":VALUE2"..."OPTIONN":"VALUEN"}.</code></p>
        /// <p>The options you can configure vary according to which parser you use:</p>
        /// <ul>
        /// <li><code>defaultOperator</code>: The default operator used to combine individual terms in the search string. For example: <code>defaultOperator: 'or'</code>. For the <code>dismax</code> parser, you specify a percentage that represents the percentage of terms in the search string (rounded down) that must match, rather than a default operator. A value of <code>0%</code> is the equivalent to OR, and a value of <code>100%</code> is equivalent to AND. The percentage must be specified as a value in the range 0-100 followed by the percent (%) symbol. For example, <code>defaultOperator: 50%</code>. Valid values: <code>and</code>, <code>or</code>, a percentage in the range 0%-100% (<code>dismax</code>). Default: <code>and</code> (<code>simple</code>, <code>structured</code>, <code>lucene</code>) or <code>100</code> (<code>dismax</code>). Valid for: <code>simple</code>, <code>structured</code>, <code>lucene</code>, and <code>dismax</code>.</li>
        /// <li><code>fields</code>: An array of the fields to search when no fields are specified in a search. If no fields are specified in a search and this option is not specified, all text and text-array fields are searched. You can specify a weight for each field to control the relative importance of each field when Amazon CloudSearch calculates relevance scores. To specify a field weight, append a caret (<code>^</code>) symbol and the weight to the field name. For example, to boost the importance of the <code>title</code> field over the <code>description</code> field you could specify: <code>"fields":["title^5","description"]</code>.  Valid values: The name of any configured field and an optional numeric value greater than zero. Default: All <code>text</code> and <code>text-array</code> fields. Valid for: <code>simple</code>, <code>structured</code>, <code>lucene</code>, and <code>dismax</code>.</li>
        /// <li><code>operators</code>: An array of the operators or special characters you want to
        /// disable for the simple query parser. If you disable the
        /// <code>and</code>, <code>or</code>, or <code>not</code>
        /// operators, the corresponding operators (<code>+</code>,
        /// <code>|</code>, <code>-</code>) have no special meaning and
        /// are dropped from the search string. Similarly, disabling
        /// <code>prefix</code> disables the wildcard operator
        /// (<code>*</code>) and disabling <code>phrase</code> disables
        /// the ability to search for phrases by enclosing phrases in double
        /// quotes. Disabling precedence disables the ability to control
        /// order of precedence using parentheses. Disabling <code>near</code> disables
        /// the ability to use the ~ operator to perform a sloppy phrase search.
        /// Disabling the <code>fuzzy</code> operator disables the ability to use the ~ operator to perform a fuzzy search.
        /// <code>escape</code> disables the ability to use a backslash
        /// (<code>\</code>) to escape special characters within the
        /// search string. Disabling whitespace is an advanced option that
        /// prevents the parser from tokenizing on whitespace, which can be
        /// useful for Vietnamese. (It prevents Vietnamese words from being
        /// split incorrectly.) For example, you could disable all operators
        /// other than the phrase operator to support just simple term and
        /// phrase queries: <code>"operators":["and","not","or",
        /// "prefix"]</code>. Valid values: <code>and</code>, <code>escape</code>,
        /// <code>fuzzy</code>, <code>near</code>, <code>not</code>, <code>or</code>,
        /// <code>phrase</code>, <code>precedence</code>, <code>prefix</code>,
        /// <code>whitespace</code>. Default: All
        /// operators and special characters are enabled. Valid for:
        /// <code>simple</code>.</li>
        /// <li><code>phraseFields</code>: An array of the <code>text</code> or <code>text-array</code> fields you want to use for
        /// phrase searches. When the terms in the search string appear in
        /// close proximity within a field, the field scores higher. You can
        /// specify a weight for each field to boost that score. The
        /// <code>phraseSlop</code> option controls how much the matches
        /// can deviate from the search string and still be boosted. To
        /// specify a field weight, append a caret (<code>^</code>) symbol
        /// and the weight to the field name. For example, to boost phrase
        /// matches in the <code>title</code> field over the
        /// <code>abstract</code> field, you could specify:
        /// <code>"phraseFields":["title^3",
        /// "plot"]</code>
        /// Valid values: The name of any <code>text</code> or
        /// <code>text-array</code> field and an optional numeric value greater than zero. Default: No fields. If you don't specify any fields with <code>phraseFields</code>, proximity scoring is disabled even if <code>phraseSlop</code> is specified. Valid
        /// for: <code>dismax</code>.</li>
        /// <li><code>phraseSlop</code>: An integer value that specifies how much matches can deviate from the search phrase and still be boosted according to the weights specified in the <code>phraseFields</code> option; for example, <code>phraseSlop: 2</code>. You must also specify <code>phraseFields</code> to enable proximity scoring. Valid values: positive integers. Default: 0. Valid for: <code>dismax</code>.</li>
        /// <li><code>explicitPhraseSlop</code>: An integer value that specifies how much a match can deviate from the search phrase when the phrase is enclosed in double quotes in the search string. (Phrases that exceed this proximity distance are not considered a match.) For example, to specify a slop of three for dismax phrase queries, you would specify <code>"explicitPhraseSlop":3</code>. Valid values: positive integers. Default: 0. Valid for: <code>dismax</code>.</li>
        /// <li><code>tieBreaker</code>: When a term in the search string is found in a document's field, a score is calculated for that field based on how common the word is in that field compared to other documents. If the term occurs in multiple fields within a document, by default only the highest scoring field contributes to the document's overall score. You can specify a <code>tieBreaker</code> value to enable the matches in lower-scoring fields to contribute to the document's score. That way, if two documents have the same max field score for a particular term, the score for the document that has matches in more fields will be higher. The formula for calculating the score with a tieBreaker is <code>(max field score) + (tieBreaker) * (sum of the scores for the rest of the matching fields)</code>.
        /// Set <code>tieBreaker</code> to 0 to disregard all but the highest scoring field (pure max): <code>"tieBreaker":0</code>. Set to 1 to sum the scores from all fields (pure sum): <code>"tieBreaker":1</code>. Valid values: 0.0 to 1.0. Default: 0.0. Valid for: <code>dismax</code>.
        /// </li>
        /// </ul>
        pub fn query_options(mut self, input: impl Into<std::string::String>) -> Self {
            self.query_options = Some(input.into());
            self
        }
        pub fn set_query_options(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.query_options = input;
            self
        }
        /// <p>Specifies which
        /// query parser to use to process the request. If <code>queryParser</code> is not specified, Amazon CloudSearch
        /// uses the <code>simple</code> query parser. </p>
        /// <p>Amazon CloudSearch supports four query parsers:</p>
        /// <ul>
        /// <li>
        /// <code>simple</code>: perform simple searches of <code>text</code> and
        /// <code>text-array</code> fields. By default, the
        /// <code>simple</code> query parser searches all
        /// <code>text</code> and <code>text-array</code> fields. You
        /// can specify which fields to search by with the
        /// <code>queryOptions</code> parameter. If you prefix a search
        /// term with a plus sign (+) documents must contain the term to be considered a match.
        /// (This is the default, unless you configure the default operator with the <code>queryOptions</code> parameter.)
        /// You can use the <code>-</code> (NOT), <code>|</code>
        /// (OR), and <code>*</code> (wildcard) operators to exclude
        /// particular terms, find results that match any of the specified
        /// terms, or search for a prefix. To search for a phrase rather
        /// than individual terms, enclose the phrase in double quotes. For
        /// more information, see <a href="http://docs.aws.amazon.com/cloudsearch/latest/developerguide/searching-text.html">Searching for Text</a> in the <i>Amazon CloudSearch Developer Guide</i>.
        /// </li>
        /// <li>
        /// <code>structured</code>: perform advanced searches by combining
        /// multiple expressions to define the search criteria. You can also search
        /// within particular fields, search for values and ranges of values, and use
        /// advanced options such as term boosting, <code>matchall</code>, and <code>near</code>.
        /// For more information, see <a href="http://docs.aws.amazon.com/cloudsearch/latest/developerguide/searching-compound-queries.html">Constructing Compound Queries</a> in the <i>Amazon CloudSearch Developer Guide</i>.
        /// </li>
        /// <li>
        /// <code>lucene</code>: search using the Apache Lucene query parser syntax.
        /// For more information, see <a href="http://lucene.apache.org/core/4_6_0/queryparser/org/apache/lucene/queryparser/classic/package-summary.html#package_description">Apache Lucene Query Parser Syntax</a>.
        /// </li>
        /// <li>
        /// <code>dismax</code>: search using the simplified subset of the Apache Lucene query parser syntax
        /// defined by the DisMax query parser.
        /// For more information, see <a href="http://wiki.apache.org/solr/DisMaxQParserPlugin#Query_Syntax">DisMax Query Parser Syntax</a>.
        /// </li>
        /// </ul>
        pub fn query_parser(mut self, input: crate::model::QueryParser) -> Self {
            self.query_parser = Some(input);
            self
        }
        pub fn set_query_parser(
            mut self,
            input: std::option::Option<crate::model::QueryParser>,
        ) -> Self {
            self.query_parser = input;
            self
        }
        /// <p>Specifies the field and expression values to include in the response. Multiple fields or expressions are specified as a comma-separated list. By default, a search response includes all
        /// return enabled fields (<code>_all_fields</code>).
        /// To  return only the document IDs for the matching documents,
        /// specify <code>_no_fields</code>.
        /// To retrieve the relevance score calculated for each document,
        /// specify <code>_score</code>.  </p>
        pub fn r#return(mut self, input: impl Into<std::string::String>) -> Self {
            self.r#return = Some(input.into());
            self
        }
        pub fn set_return(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.r#return = input;
            self
        }
        /// <p>Specifies the maximum number of search hits to include in the response. </p>
        pub fn size(mut self, input: i64) -> Self {
            self.size = Some(input);
            self
        }
        pub fn set_size(mut self, input: std::option::Option<i64>) -> Self {
            self.size = input;
            self
        }
        /// <p>Specifies the fields or custom expressions to use to sort the search
        /// results. Multiple fields or expressions are specified as a comma-separated list.
        /// You must specify the sort direction (<code>asc</code> or
        /// <code>desc</code>) for each field; for example, <code>year
        /// desc,title asc</code>. To use a field to sort results, the field must be sort-enabled in
        /// the domain configuration. Array type fields cannot be used for sorting.
        /// If no <code>sort</code> parameter is specified, results are sorted by
        /// their default relevance scores in descending order: <code>_score
        /// desc</code>. You can also sort by document ID
        /// (<code>_id asc</code>) and version (<code>_version desc</code>).</p>
        /// <p>For more information, see <a href="http://docs.aws.amazon.com/cloudsearch/latest/developerguide/sorting-results.html">Sorting Results</a> in the <i>Amazon CloudSearch Developer Guide</i>.</p>
        pub fn sort(mut self, input: impl Into<std::string::String>) -> Self {
            self.sort = Some(input.into());
            self
        }
        pub fn set_sort(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.sort = input;
            self
        }
        /// <p>Specifies the offset of the first search hit you want to return. Note that the result set is zero-based; the first result is at index 0. You can specify either the <code>start</code> or <code>cursor</code> parameter in a request, they are mutually exclusive.  </p>
        /// <p>For more information, see <a href="http://docs.aws.amazon.com/cloudsearch/latest/developerguide/paginating-results.html">Paginating Results</a> in the <i>Amazon CloudSearch Developer Guide</i>.</p>
        pub fn start(mut self, input: i64) -> Self {
            self.start = Some(input);
            self
        }
        pub fn set_start(mut self, input: std::option::Option<i64>) -> Self {
            self.start = input;
            self
        }
        /// <p>Specifies one or more fields for which to get statistics information. Each specified field must be facet-enabled in the domain configuration. The fields are specified in JSON using the form:</p>
        /// <code>{"FIELD-A":{},"FIELD-B":{}}</code>
        /// <p>There are currently no options supported for statistics.</p>
        pub fn stats(mut self, input: impl Into<std::string::String>) -> Self {
            self.stats = Some(input.into());
            self
        }
        pub fn set_stats(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.stats = input;
            self
        }
        /// Consumes the builder and constructs a [`SearchInput`](crate::input::SearchInput)
        pub fn build(
            self,
        ) -> std::result::Result<crate::input::SearchInput, smithy_http::operation::BuildError>
        {
            Ok(crate::input::SearchInput {
                cursor: self.cursor,
                expr: self.expr,
                facet: self.facet,
                filter_query: self.filter_query,
                highlight: self.highlight,
                partial: self.partial.unwrap_or_default(),
                query: self.query,
                query_options: self.query_options,
                query_parser: self.query_parser,
                r#return: self.r#return,
                size: self.size.unwrap_or_default(),
                sort: self.sort,
                start: self.start.unwrap_or_default(),
                stats: self.stats,
            })
        }
    }
}
#[doc(hidden)]
pub type SearchInputOperationOutputAlias = crate::operation::Search;
#[doc(hidden)]
pub type SearchInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl SearchInput {
    /// Consumes the builder and constructs an Operation<[`Search`](crate::operation::Search)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<crate::operation::Search, aws_http::AwsErrorRetryPolicy>,
        smithy_http::operation::BuildError,
    > {
        fn uri_base(
            _input: &crate::input::SearchInput,
            output: &mut String,
        ) -> Result<(), smithy_http::operation::BuildError> {
            write!(output, "/2013-01-01/search").expect("formatting should succeed");
            Ok(())
        }
        fn uri_query(_input: &crate::input::SearchInput, mut output: &mut String) {
            let mut query = smithy_http::query::Writer::new(&mut output);
            query.push_kv("format", "sdk");
            query.push_kv("pretty", "true");
            if let Some(inner_1) = &_input.cursor {
                query.push_kv("cursor", &smithy_http::query::fmt_string(&inner_1));
            }
            if let Some(inner_2) = &_input.expr {
                query.push_kv("expr", &smithy_http::query::fmt_string(&inner_2));
            }
            if let Some(inner_3) = &_input.facet {
                query.push_kv("facet", &smithy_http::query::fmt_string(&inner_3));
            }
            if let Some(inner_4) = &_input.filter_query {
                query.push_kv("fq", &smithy_http::query::fmt_string(&inner_4));
            }
            if let Some(inner_5) = &_input.highlight {
                query.push_kv("highlight", &smithy_http::query::fmt_string(&inner_5));
            }
            if _input.partial {
                query.push_kv(
                    "partial",
                    &smithy_types::primitive::Encoder::from(_input.partial).encode(),
                );
            }
            if let Some(inner_6) = &_input.query {
                query.push_kv("q", &smithy_http::query::fmt_string(&inner_6));
            }
            if let Some(inner_7) = &_input.query_options {
                query.push_kv("q.options", &smithy_http::query::fmt_string(&inner_7));
            }
            if let Some(inner_8) = &_input.query_parser {
                query.push_kv("q.parser", &smithy_http::query::fmt_string(&inner_8));
            }
            if let Some(inner_9) = &_input.r#return {
                query.push_kv("return", &smithy_http::query::fmt_string(&inner_9));
            }
            if _input.size != 0 {
                query.push_kv(
                    "size",
                    &smithy_types::primitive::Encoder::from(_input.size).encode(),
                );
            }
            if let Some(inner_10) = &_input.sort {
                query.push_kv("sort", &smithy_http::query::fmt_string(&inner_10));
            }
            if _input.start != 0 {
                query.push_kv(
                    "start",
                    &smithy_types::primitive::Encoder::from(_input.start).encode(),
                );
            }
            if let Some(inner_11) = &_input.stats {
                query.push_kv("stats", &smithy_http::query::fmt_string(&inner_11));
            }
        }
        #[allow(clippy::unnecessary_wraps)]
        fn update_http_builder(
            input: &crate::input::SearchInput,
            builder: http::request::Builder,
        ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError>
        {
            let mut uri = String::new();
            uri_base(input, &mut uri)?;
            uri_query(input, &mut uri);
            Ok(builder.method("GET").uri(uri))
        }
        #[allow(clippy::unnecessary_wraps)]
        fn request_builder_base(
            input: &crate::input::SearchInput,
        ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError>
        {
            let mut builder = update_http_builder(input, http::request::Builder::new())?;
            builder = smithy_http::header::set_header_if_absent(
                builder,
                http::header::HeaderName::from_static("content-type"),
                "application/json",
            );
            Ok(builder)
        }
        let properties = smithy_http::property_bag::SharedPropertyBag::new();
        let request = request_builder_base(&self)?;
        let body = smithy_http::body::SdkBody::from("");
        let request = Self::assemble(request, body);
        #[allow(unused_mut)]
        let mut request = smithy_http::operation::Request::from_parts(
            request.map(smithy_http::body::SdkBody::from),
            properties,
        );
        request
            .properties_mut()
            .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                crate::API_METADATA.clone(),
            ));
        #[allow(unused_mut)]
        let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
        request.properties_mut().insert(signing_config);
        request
            .properties_mut()
            .insert(aws_types::SigningService::from_static(
                _config.signing_service(),
            ));
        aws_endpoint::set_endpoint_resolver(
            &mut request.properties_mut(),
            _config.endpoint_resolver.clone(),
        );
        if let Some(region) = &_config.region {
            request.properties_mut().insert(region.clone());
        }
        aws_auth::set_provider(
            &mut request.properties_mut(),
            _config.credentials_provider.clone(),
        );
        let op = smithy_http::operation::Operation::new(request, crate::operation::Search::new())
            .with_metadata(smithy_http::operation::Metadata::new(
                "Search",
                "cloudsearchdomain",
            ));
        let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
        Ok(op)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = smithy_http::header::set_header_if_absent(
                builder,
                http::header::CONTENT_LENGTH,
                content_length,
            );
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`SearchInput`](crate::input::SearchInput)
    pub fn builder() -> crate::input::search_input::Builder {
        crate::input::search_input::Builder::default()
    }
}

/// See [`SuggestInput`](crate::input::SuggestInput)
pub mod suggest_input {
    /// A builder for [`SuggestInput`](crate::input::SuggestInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) query: std::option::Option<std::string::String>,
        pub(crate) suggester: std::option::Option<std::string::String>,
        pub(crate) size: std::option::Option<i64>,
    }
    impl Builder {
        /// <p>Specifies the string for which you want to get suggestions.</p>
        pub fn query(mut self, input: impl Into<std::string::String>) -> Self {
            self.query = Some(input.into());
            self
        }
        pub fn set_query(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.query = input;
            self
        }
        /// <p>Specifies the name of the suggester to use to find suggested matches.</p>
        pub fn suggester(mut self, input: impl Into<std::string::String>) -> Self {
            self.suggester = Some(input.into());
            self
        }
        pub fn set_suggester(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.suggester = input;
            self
        }
        /// <p>Specifies the maximum number of suggestions to return. </p>
        pub fn size(mut self, input: i64) -> Self {
            self.size = Some(input);
            self
        }
        pub fn set_size(mut self, input: std::option::Option<i64>) -> Self {
            self.size = input;
            self
        }
        /// Consumes the builder and constructs a [`SuggestInput`](crate::input::SuggestInput)
        pub fn build(
            self,
        ) -> std::result::Result<crate::input::SuggestInput, smithy_http::operation::BuildError>
        {
            Ok(crate::input::SuggestInput {
                query: self.query,
                suggester: self.suggester,
                size: self.size.unwrap_or_default(),
            })
        }
    }
}
#[doc(hidden)]
pub type SuggestInputOperationOutputAlias = crate::operation::Suggest;
#[doc(hidden)]
pub type SuggestInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl SuggestInput {
    /// Consumes the builder and constructs an Operation<[`Suggest`](crate::operation::Suggest)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<crate::operation::Suggest, aws_http::AwsErrorRetryPolicy>,
        smithy_http::operation::BuildError,
    > {
        fn uri_base(
            _input: &crate::input::SuggestInput,
            output: &mut String,
        ) -> Result<(), smithy_http::operation::BuildError> {
            write!(output, "/2013-01-01/suggest").expect("formatting should succeed");
            Ok(())
        }
        fn uri_query(_input: &crate::input::SuggestInput, mut output: &mut String) {
            let mut query = smithy_http::query::Writer::new(&mut output);
            query.push_kv("format", "sdk");
            query.push_kv("pretty", "true");
            if let Some(inner_12) = &_input.query {
                query.push_kv("q", &smithy_http::query::fmt_string(&inner_12));
            }
            if let Some(inner_13) = &_input.suggester {
                query.push_kv("suggester", &smithy_http::query::fmt_string(&inner_13));
            }
            if _input.size != 0 {
                query.push_kv(
                    "size",
                    &smithy_types::primitive::Encoder::from(_input.size).encode(),
                );
            }
        }
        #[allow(clippy::unnecessary_wraps)]
        fn update_http_builder(
            input: &crate::input::SuggestInput,
            builder: http::request::Builder,
        ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError>
        {
            let mut uri = String::new();
            uri_base(input, &mut uri)?;
            uri_query(input, &mut uri);
            Ok(builder.method("GET").uri(uri))
        }
        #[allow(clippy::unnecessary_wraps)]
        fn request_builder_base(
            input: &crate::input::SuggestInput,
        ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError>
        {
            let mut builder = update_http_builder(input, http::request::Builder::new())?;
            builder = smithy_http::header::set_header_if_absent(
                builder,
                http::header::HeaderName::from_static("content-type"),
                "application/json",
            );
            Ok(builder)
        }
        let properties = smithy_http::property_bag::SharedPropertyBag::new();
        let request = request_builder_base(&self)?;
        let body = smithy_http::body::SdkBody::from("");
        let request = Self::assemble(request, body);
        #[allow(unused_mut)]
        let mut request = smithy_http::operation::Request::from_parts(
            request.map(smithy_http::body::SdkBody::from),
            properties,
        );
        request
            .properties_mut()
            .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                crate::API_METADATA.clone(),
            ));
        #[allow(unused_mut)]
        let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
        request.properties_mut().insert(signing_config);
        request
            .properties_mut()
            .insert(aws_types::SigningService::from_static(
                _config.signing_service(),
            ));
        aws_endpoint::set_endpoint_resolver(
            &mut request.properties_mut(),
            _config.endpoint_resolver.clone(),
        );
        if let Some(region) = &_config.region {
            request.properties_mut().insert(region.clone());
        }
        aws_auth::set_provider(
            &mut request.properties_mut(),
            _config.credentials_provider.clone(),
        );
        let op = smithy_http::operation::Operation::new(request, crate::operation::Suggest::new())
            .with_metadata(smithy_http::operation::Metadata::new(
                "Suggest",
                "cloudsearchdomain",
            ));
        let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
        Ok(op)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = smithy_http::header::set_header_if_absent(
                builder,
                http::header::CONTENT_LENGTH,
                content_length,
            );
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`SuggestInput`](crate::input::SuggestInput)
    pub fn builder() -> crate::input::suggest_input::Builder {
        crate::input::suggest_input::Builder::default()
    }
}

/// See [`UploadDocumentsInput`](crate::input::UploadDocumentsInput)
pub mod upload_documents_input {
    /// A builder for [`UploadDocumentsInput`](crate::input::UploadDocumentsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) documents: std::option::Option<smithy_http::byte_stream::ByteStream>,
        pub(crate) content_type: std::option::Option<crate::model::ContentType>,
    }
    impl Builder {
        /// <p>A batch of documents formatted in JSON or HTML.</p>
        pub fn documents(mut self, input: smithy_http::byte_stream::ByteStream) -> Self {
            self.documents = Some(input);
            self
        }
        pub fn set_documents(
            mut self,
            input: std::option::Option<smithy_http::byte_stream::ByteStream>,
        ) -> Self {
            self.documents = input;
            self
        }
        /// <p>The format of the batch you are uploading. Amazon CloudSearch supports two document batch formats:</p>
        /// <ul>
        /// <li>application/json</li>
        /// <li>application/xml</li>
        /// </ul>
        pub fn content_type(mut self, input: crate::model::ContentType) -> Self {
            self.content_type = Some(input);
            self
        }
        pub fn set_content_type(
            mut self,
            input: std::option::Option<crate::model::ContentType>,
        ) -> Self {
            self.content_type = input;
            self
        }
        /// Consumes the builder and constructs a [`UploadDocumentsInput`](crate::input::UploadDocumentsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::UploadDocumentsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::UploadDocumentsInput {
                documents: self.documents.unwrap_or_default(),
                content_type: self.content_type,
            })
        }
    }
}
#[doc(hidden)]
pub type UploadDocumentsInputOperationOutputAlias = crate::operation::UploadDocuments;
#[doc(hidden)]
pub type UploadDocumentsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl UploadDocumentsInput {
    /// Consumes the builder and constructs an Operation<[`UploadDocuments`](crate::operation::UploadDocuments)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::UploadDocuments,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        fn uri_base(
            _input: &crate::input::UploadDocumentsInput,
            output: &mut String,
        ) -> Result<(), smithy_http::operation::BuildError> {
            write!(output, "/2013-01-01/documents/batch").expect("formatting should succeed");
            Ok(())
        }
        fn add_headers(
            _input: &crate::input::UploadDocumentsInput,
            mut builder: http::request::Builder,
        ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError>
        {
            if let Some(inner_14) = &_input.content_type {
                let formatted_15 = AsRef::<str>::as_ref(inner_14);
                if !formatted_15.is_empty() {
                    use std::convert::TryFrom;
                    let header_value = formatted_15;
                    let header_value = http::header::HeaderValue::try_from(&*header_value)
                        .map_err(|err| smithy_http::operation::BuildError::InvalidField {
                            field: "content_type",
                            details: format!(
                                "`{}` cannot be used as a header value: {}",
                                &header_value, err
                            ),
                        })?;
                    builder = builder.header("Content-Type", header_value);
                }
            }
            Ok(builder)
        }
        fn uri_query(_input: &crate::input::UploadDocumentsInput, mut output: &mut String) {
            let mut query = smithy_http::query::Writer::new(&mut output);
            query.push_kv("format", "sdk");
        }
        #[allow(clippy::unnecessary_wraps)]
        fn update_http_builder(
            input: &crate::input::UploadDocumentsInput,
            builder: http::request::Builder,
        ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError>
        {
            let mut uri = String::new();
            uri_base(input, &mut uri)?;
            uri_query(input, &mut uri);
            let builder = add_headers(input, builder)?;
            Ok(builder.method("POST").uri(uri))
        }
        #[allow(clippy::unnecessary_wraps)]
        fn request_builder_base(
            input: &crate::input::UploadDocumentsInput,
        ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError>
        {
            let mut builder = update_http_builder(input, http::request::Builder::new())?;
            builder = smithy_http::header::set_header_if_absent(
                builder,
                http::header::HeaderName::from_static("content-type"),
                "application/octet-stream",
            );
            Ok(builder)
        }
        let properties = smithy_http::property_bag::SharedPropertyBag::new();
        let request = request_builder_base(&self)?;
        let body = crate::operation_ser::ser_payload_upload_documents_input(self.documents)?;
        let request = Self::assemble(request, body);
        #[allow(unused_mut)]
        let mut request = smithy_http::operation::Request::from_parts(
            request.map(smithy_http::body::SdkBody::from),
            properties,
        );
        request
            .properties_mut()
            .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                crate::API_METADATA.clone(),
            ));
        #[allow(unused_mut)]
        let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
        request.properties_mut().insert(signing_config);
        request
            .properties_mut()
            .insert(aws_types::SigningService::from_static(
                _config.signing_service(),
            ));
        aws_endpoint::set_endpoint_resolver(
            &mut request.properties_mut(),
            _config.endpoint_resolver.clone(),
        );
        if let Some(region) = &_config.region {
            request.properties_mut().insert(region.clone());
        }
        aws_auth::set_provider(
            &mut request.properties_mut(),
            _config.credentials_provider.clone(),
        );
        let op = smithy_http::operation::Operation::new(
            request,
            crate::operation::UploadDocuments::new(),
        )
        .with_metadata(smithy_http::operation::Metadata::new(
            "UploadDocuments",
            "cloudsearchdomain",
        ));
        let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
        Ok(op)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = smithy_http::header::set_header_if_absent(
                builder,
                http::header::CONTENT_LENGTH,
                content_length,
            );
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`UploadDocumentsInput`](crate::input::UploadDocumentsInput)
    pub fn builder() -> crate::input::upload_documents_input::Builder {
        crate::input::upload_documents_input::Builder::default()
    }
}

/// <p>Container for the parameters to the <code>UploadDocuments</code> request.</p>
#[non_exhaustive]
pub struct UploadDocumentsInput {
    /// <p>A batch of documents formatted in JSON or HTML.</p>
    pub documents: smithy_http::byte_stream::ByteStream,
    /// <p>The format of the batch you are uploading. Amazon CloudSearch supports two document batch formats:</p>
    /// <ul>
    /// <li>application/json</li>
    /// <li>application/xml</li>
    /// </ul>
    pub content_type: std::option::Option<crate::model::ContentType>,
}
impl std::fmt::Debug for UploadDocumentsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("UploadDocumentsInput");
        formatter.field("documents", &self.documents);
        formatter.field("content_type", &self.content_type);
        formatter.finish()
    }
}

/// <p>Container for the parameters to the <code>Suggest</code> request.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct SuggestInput {
    /// <p>Specifies the string for which you want to get suggestions.</p>
    pub query: std::option::Option<std::string::String>,
    /// <p>Specifies the name of the suggester to use to find suggested matches.</p>
    pub suggester: std::option::Option<std::string::String>,
    /// <p>Specifies the maximum number of suggestions to return. </p>
    pub size: i64,
}
impl std::fmt::Debug for SuggestInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("SuggestInput");
        formatter.field("query", &self.query);
        formatter.field("suggester", &self.suggester);
        formatter.field("size", &self.size);
        formatter.finish()
    }
}

/// <p>Container for the parameters to the <code>Search</code> request.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct SearchInput {
    /// <p>Retrieves a cursor value you can use to page through large result sets.
    /// Use the <code>size</code> parameter to control the number of hits to include in each response. You can specify either the <code>cursor</code> or
    /// <code>start</code> parameter in a request; they are mutually exclusive. To get the first cursor, set the cursor value to <code>initial</code>. In subsequent requests, specify the cursor value returned in the hits section of the response. </p>
    /// <p>For more
    /// information, see <a href="http://docs.aws.amazon.com/cloudsearch/latest/developerguide/paginating-results.html">Paginating Results</a> in the <i>Amazon CloudSearch Developer Guide</i>.</p>
    pub cursor: std::option::Option<std::string::String>,
    /// <p>Defines one or more numeric expressions that can be used to sort results or specify search or filter
    /// criteria. You can also specify expressions as return fields. </p>
    /// <p>You specify the expressions in JSON using the form <code>{"EXPRESSIONNAME":"EXPRESSION"}</code>. You can define and use multiple expressions in a search request. For example:</p>
    /// <p><code>
    /// {"expression1":"_score*rating", "expression2":"(1/rank)*year"}
    /// </code> </p>
    /// <p>For information about the variables, operators, and functions you can use in expressions, see <a href="http://docs.aws.amazon.com/cloudsearch/latest/developerguide/configuring-expressions.html#writing-expressions">Writing Expressions</a>
    /// in the <i>Amazon CloudSearch Developer Guide</i>.</p>
    pub expr: std::option::Option<std::string::String>,
    /// <p>Specifies one or more fields for which to get facet information, and options that control how the facet information is returned. Each specified field must be facet-enabled in the domain configuration. The fields and options are specified in JSON using the form <code>{"FIELD":{"OPTION":VALUE,"OPTION:"STRING"},"FIELD":{"OPTION":VALUE,"OPTION":"STRING"}}</code>.</p>
    /// <p>You can specify the following faceting options:</p>
    /// <ul>
    /// <li>
    /// <p><code>buckets</code> specifies an array of the facet values or
    /// ranges to count. Ranges are specified using the same syntax that you use to search for a range of values.
    /// For more information, see <a href="http://docs.aws.amazon.com/cloudsearch/latest/developerguide/searching-ranges.html">
    /// Searching for a Range of Values</a> in the <i>Amazon CloudSearch Developer Guide</i>. Buckets are returned in the order they
    /// are specified in the request. The <code>sort</code> and <code>size</code> options are
    /// not valid if you specify <code>buckets</code>.</p>
    /// </li>
    /// <li>
    /// <p><code>size</code> specifies the maximum number of facets to include in the results. By
    /// default, Amazon CloudSearch returns counts for the top 10. The
    /// <code>size</code> parameter is only valid when you specify
    /// the <code>sort</code> option; it cannot be used in conjunction
    /// with <code>buckets</code>.</p>
    /// </li>
    /// <li>
    /// <p><code>sort</code> specifies how you want to sort the facets in
    /// the results: <code>bucket</code> or <code>count</code>. Specify
    /// <code>bucket</code> to sort alphabetically or numerically by
    /// facet value (in ascending order). Specify <code>count</code> to
    /// sort by the facet counts computed for each facet value (in
    /// descending order). To retrieve facet counts for particular
    /// values or ranges of values, use the <code>buckets</code> option
    /// instead of <code>sort</code>. </p>
    /// </li>
    /// </ul>
    /// <p>If no facet options are specified, facet counts are computed for all field values, the facets are sorted by facet count, and the top 10 facets are returned in the results.</p>
    /// <p>To count particular buckets of values, use the <code>buckets</code> option. For example, the following request uses the <code>buckets</code> option to calculate and return facet counts by decade.</p>
    /// <p><code>
    /// {"year":{"buckets":["[1970,1979]","[1980,1989]","[1990,1999]","[2000,2009]","[2010,}"]}}
    /// </code></p>
    /// <p>To sort facets by facet count, use the <code>count</code> option. For example, the following request sets the <code>sort</code> option to <code>count</code> to sort the facet values by facet count, with the facet
    /// values that have the most matching documents listed first. Setting the <code>size</code> option to 3 returns only the top three facet values.</p>
    /// <p><code>
    /// {"year":{"sort":"count","size":3}}
    /// </code></p>
    /// <p>To sort the facets by value, use the <code>bucket</code> option. For example, the following  request sets the <code>sort</code> option to <code>bucket</code> to sort the facet values numerically by year, with earliest year listed first. </p>
    /// <p><code>
    /// {"year":{"sort":"bucket"}}
    /// </code></p>
    /// <p>For more
    /// information, see <a href="http://docs.aws.amazon.com/cloudsearch/latest/developerguide/faceting.html">Getting and Using Facet Information</a>
    /// in the <i>Amazon CloudSearch Developer Guide</i>.</p>
    pub facet: std::option::Option<std::string::String>,
    /// <p>Specifies a structured query that filters the results of a search without affecting how the results are scored and sorted. You use <code>filterQuery</code> in conjunction with the <code>query</code> parameter to filter the documents that match the constraints specified in the <code>query</code> parameter. Specifying a filter controls only which matching documents are included in the results, it has no effect on how they are scored and sorted. The <code>filterQuery</code> parameter supports the full structured query syntax. </p>
    /// <p>For more information about using filters, see <a href="http://docs.aws.amazon.com/cloudsearch/latest/developerguide/filtering-results.html">Filtering Matching Documents</a>
    /// in the <i>Amazon CloudSearch Developer Guide</i>.</p>
    pub filter_query: std::option::Option<std::string::String>,
    /// <p>Retrieves highlights for matches in the specified <code>text</code> or
    /// <code>text-array</code> fields. Each specified field must be highlight enabled in the domain configuration. The fields and options are specified in JSON using the form <code>{"FIELD":{"OPTION":VALUE,"OPTION:"STRING"},"FIELD":{"OPTION":VALUE,"OPTION":"STRING"}}</code>.</p>
    /// <p>You can specify the following highlight options:</p>
    /// <ul>
    /// <li>
    /// <code>format</code>: specifies the format of the data in the
    /// text field: <code>text</code> or <code>html</code>. When data is
    /// returned as HTML, all non-alphanumeric characters are encoded.
    /// The default is <code>html</code>.
    /// </li>
    /// <li>
    /// <code>max_phrases</code>: specifies the maximum number of
    /// occurrences of the search term(s) you want to highlight. By
    /// default, the first occurrence is highlighted.
    /// </li>
    /// <li>
    /// <code>pre_tag</code>: specifies the string to prepend to an
    /// occurrence of a search term. The default for HTML highlights is
    /// <code>&lt;em&gt;</code>. The default for text highlights is
    /// <code>*</code>.
    /// </li>
    /// <li>
    /// <code>post_tag</code>: specifies the string to append to an
    /// occurrence of a search term. The default for HTML highlights is
    /// <code>&lt;/em&gt;</code>. The default for text highlights is
    /// <code>*</code>.
    /// </li>
    /// </ul>
    /// <p>If no highlight options are specified for a field, the returned field text is treated as HTML and the first match is
    /// highlighted with emphasis tags:  <code>&lt;em>search-term&lt;/em&gt;</code>.</p>
    /// <p>For example, the following request retrieves highlights for the <code>actors</code> and <code>title</code> fields.</p>
    /// <p> <code>{
    /// "actors": {},
    /// "title": {"format": "text","max_phrases": 2,"pre_tag": "<b>","post_tag": "</b>"}
    /// }</code></p>
    pub highlight: std::option::Option<std::string::String>,
    /// <p>Enables partial results to be returned if one or more index partitions are unavailable. When your search index is partitioned across multiple search instances, by default Amazon CloudSearch only returns results if every partition can be queried. This means that the failure of a single search instance can result in 5xx (internal server) errors. When you enable partial results, Amazon CloudSearch returns whatever results are available and includes the percentage of documents searched in the search results (percent-searched). This enables you to more gracefully degrade your users' search experience. For example, rather than displaying no results, you could display the partial results and a message indicating that the results might be incomplete due to a temporary system outage.</p>
    pub partial: bool,
    /// <p>Specifies the search criteria for the request. How you specify the search
    /// criteria depends on the query parser used for the request and the parser options
    /// specified in the <code>queryOptions</code> parameter. By default,
    /// the <code>simple</code> query parser is used to process requests. To use
    /// the <code>structured</code>, <code>lucene</code>, or <code>dismax</code> query parser,
    /// you must also specify the <code>queryParser</code> parameter. </p>
    /// <p>For more information about specifying search criteria, see <a href="http://docs.aws.amazon.com/cloudsearch/latest/developerguide/searching.html">Searching Your Data</a> in the <i>Amazon CloudSearch Developer Guide</i>.</p>
    pub query: std::option::Option<std::string::String>,
    /// <p>Configures options for the query parser specified in the <code>queryParser</code> parameter. You specify the options in JSON using the following form <code>{"OPTION1":"VALUE1","OPTION2":VALUE2"..."OPTIONN":"VALUEN"}.</code></p>
    /// <p>The options you can configure vary according to which parser you use:</p>
    /// <ul>
    /// <li><code>defaultOperator</code>: The default operator used to combine individual terms in the search string. For example: <code>defaultOperator: 'or'</code>. For the <code>dismax</code> parser, you specify a percentage that represents the percentage of terms in the search string (rounded down) that must match, rather than a default operator. A value of <code>0%</code> is the equivalent to OR, and a value of <code>100%</code> is equivalent to AND. The percentage must be specified as a value in the range 0-100 followed by the percent (%) symbol. For example, <code>defaultOperator: 50%</code>. Valid values: <code>and</code>, <code>or</code>, a percentage in the range 0%-100% (<code>dismax</code>). Default: <code>and</code> (<code>simple</code>, <code>structured</code>, <code>lucene</code>) or <code>100</code> (<code>dismax</code>). Valid for: <code>simple</code>, <code>structured</code>, <code>lucene</code>, and <code>dismax</code>.</li>
    /// <li><code>fields</code>: An array of the fields to search when no fields are specified in a search. If no fields are specified in a search and this option is not specified, all text and text-array fields are searched. You can specify a weight for each field to control the relative importance of each field when Amazon CloudSearch calculates relevance scores. To specify a field weight, append a caret (<code>^</code>) symbol and the weight to the field name. For example, to boost the importance of the <code>title</code> field over the <code>description</code> field you could specify: <code>"fields":["title^5","description"]</code>.  Valid values: The name of any configured field and an optional numeric value greater than zero. Default: All <code>text</code> and <code>text-array</code> fields. Valid for: <code>simple</code>, <code>structured</code>, <code>lucene</code>, and <code>dismax</code>.</li>
    /// <li><code>operators</code>: An array of the operators or special characters you want to
    /// disable for the simple query parser. If you disable the
    /// <code>and</code>, <code>or</code>, or <code>not</code>
    /// operators, the corresponding operators (<code>+</code>,
    /// <code>|</code>, <code>-</code>) have no special meaning and
    /// are dropped from the search string. Similarly, disabling
    /// <code>prefix</code> disables the wildcard operator
    /// (<code>*</code>) and disabling <code>phrase</code> disables
    /// the ability to search for phrases by enclosing phrases in double
    /// quotes. Disabling precedence disables the ability to control
    /// order of precedence using parentheses. Disabling <code>near</code> disables
    /// the ability to use the ~ operator to perform a sloppy phrase search.
    /// Disabling the <code>fuzzy</code> operator disables the ability to use the ~ operator to perform a fuzzy search.
    /// <code>escape</code> disables the ability to use a backslash
    /// (<code>\</code>) to escape special characters within the
    /// search string. Disabling whitespace is an advanced option that
    /// prevents the parser from tokenizing on whitespace, which can be
    /// useful for Vietnamese. (It prevents Vietnamese words from being
    /// split incorrectly.) For example, you could disable all operators
    /// other than the phrase operator to support just simple term and
    /// phrase queries: <code>"operators":["and","not","or",
    /// "prefix"]</code>. Valid values: <code>and</code>, <code>escape</code>,
    /// <code>fuzzy</code>, <code>near</code>, <code>not</code>, <code>or</code>,
    /// <code>phrase</code>, <code>precedence</code>, <code>prefix</code>,
    /// <code>whitespace</code>. Default: All
    /// operators and special characters are enabled. Valid for:
    /// <code>simple</code>.</li>
    /// <li><code>phraseFields</code>: An array of the <code>text</code> or <code>text-array</code> fields you want to use for
    /// phrase searches. When the terms in the search string appear in
    /// close proximity within a field, the field scores higher. You can
    /// specify a weight for each field to boost that score. The
    /// <code>phraseSlop</code> option controls how much the matches
    /// can deviate from the search string and still be boosted. To
    /// specify a field weight, append a caret (<code>^</code>) symbol
    /// and the weight to the field name. For example, to boost phrase
    /// matches in the <code>title</code> field over the
    /// <code>abstract</code> field, you could specify:
    /// <code>"phraseFields":["title^3",
    /// "plot"]</code>
    /// Valid values: The name of any <code>text</code> or
    /// <code>text-array</code> field and an optional numeric value greater than zero. Default: No fields. If you don't specify any fields with <code>phraseFields</code>, proximity scoring is disabled even if <code>phraseSlop</code> is specified. Valid
    /// for: <code>dismax</code>.</li>
    /// <li><code>phraseSlop</code>: An integer value that specifies how much matches can deviate from the search phrase and still be boosted according to the weights specified in the <code>phraseFields</code> option; for example, <code>phraseSlop: 2</code>. You must also specify <code>phraseFields</code> to enable proximity scoring. Valid values: positive integers. Default: 0. Valid for: <code>dismax</code>.</li>
    /// <li><code>explicitPhraseSlop</code>: An integer value that specifies how much a match can deviate from the search phrase when the phrase is enclosed in double quotes in the search string. (Phrases that exceed this proximity distance are not considered a match.) For example, to specify a slop of three for dismax phrase queries, you would specify <code>"explicitPhraseSlop":3</code>. Valid values: positive integers. Default: 0. Valid for: <code>dismax</code>.</li>
    /// <li><code>tieBreaker</code>: When a term in the search string is found in a document's field, a score is calculated for that field based on how common the word is in that field compared to other documents. If the term occurs in multiple fields within a document, by default only the highest scoring field contributes to the document's overall score. You can specify a <code>tieBreaker</code> value to enable the matches in lower-scoring fields to contribute to the document's score. That way, if two documents have the same max field score for a particular term, the score for the document that has matches in more fields will be higher. The formula for calculating the score with a tieBreaker is <code>(max field score) + (tieBreaker) * (sum of the scores for the rest of the matching fields)</code>.
    /// Set <code>tieBreaker</code> to 0 to disregard all but the highest scoring field (pure max): <code>"tieBreaker":0</code>. Set to 1 to sum the scores from all fields (pure sum): <code>"tieBreaker":1</code>. Valid values: 0.0 to 1.0. Default: 0.0. Valid for: <code>dismax</code>.
    /// </li>
    /// </ul>
    pub query_options: std::option::Option<std::string::String>,
    /// <p>Specifies which
    /// query parser to use to process the request. If <code>queryParser</code> is not specified, Amazon CloudSearch
    /// uses the <code>simple</code> query parser. </p>
    /// <p>Amazon CloudSearch supports four query parsers:</p>
    /// <ul>
    /// <li>
    /// <code>simple</code>: perform simple searches of <code>text</code> and
    /// <code>text-array</code> fields. By default, the
    /// <code>simple</code> query parser searches all
    /// <code>text</code> and <code>text-array</code> fields. You
    /// can specify which fields to search by with the
    /// <code>queryOptions</code> parameter. If you prefix a search
    /// term with a plus sign (+) documents must contain the term to be considered a match.
    /// (This is the default, unless you configure the default operator with the <code>queryOptions</code> parameter.)
    /// You can use the <code>-</code> (NOT), <code>|</code>
    /// (OR), and <code>*</code> (wildcard) operators to exclude
    /// particular terms, find results that match any of the specified
    /// terms, or search for a prefix. To search for a phrase rather
    /// than individual terms, enclose the phrase in double quotes. For
    /// more information, see <a href="http://docs.aws.amazon.com/cloudsearch/latest/developerguide/searching-text.html">Searching for Text</a> in the <i>Amazon CloudSearch Developer Guide</i>.
    /// </li>
    /// <li>
    /// <code>structured</code>: perform advanced searches by combining
    /// multiple expressions to define the search criteria. You can also search
    /// within particular fields, search for values and ranges of values, and use
    /// advanced options such as term boosting, <code>matchall</code>, and <code>near</code>.
    /// For more information, see <a href="http://docs.aws.amazon.com/cloudsearch/latest/developerguide/searching-compound-queries.html">Constructing Compound Queries</a> in the <i>Amazon CloudSearch Developer Guide</i>.
    /// </li>
    /// <li>
    /// <code>lucene</code>: search using the Apache Lucene query parser syntax.
    /// For more information, see <a href="http://lucene.apache.org/core/4_6_0/queryparser/org/apache/lucene/queryparser/classic/package-summary.html#package_description">Apache Lucene Query Parser Syntax</a>.
    /// </li>
    /// <li>
    /// <code>dismax</code>: search using the simplified subset of the Apache Lucene query parser syntax
    /// defined by the DisMax query parser.
    /// For more information, see <a href="http://wiki.apache.org/solr/DisMaxQParserPlugin#Query_Syntax">DisMax Query Parser Syntax</a>.
    /// </li>
    /// </ul>
    pub query_parser: std::option::Option<crate::model::QueryParser>,
    /// <p>Specifies the field and expression values to include in the response. Multiple fields or expressions are specified as a comma-separated list. By default, a search response includes all
    /// return enabled fields (<code>_all_fields</code>).
    /// To  return only the document IDs for the matching documents,
    /// specify <code>_no_fields</code>.
    /// To retrieve the relevance score calculated for each document,
    /// specify <code>_score</code>.  </p>
    pub r#return: std::option::Option<std::string::String>,
    /// <p>Specifies the maximum number of search hits to include in the response. </p>
    pub size: i64,
    /// <p>Specifies the fields or custom expressions to use to sort the search
    /// results. Multiple fields or expressions are specified as a comma-separated list.
    /// You must specify the sort direction (<code>asc</code> or
    /// <code>desc</code>) for each field; for example, <code>year
    /// desc,title asc</code>. To use a field to sort results, the field must be sort-enabled in
    /// the domain configuration. Array type fields cannot be used for sorting.
    /// If no <code>sort</code> parameter is specified, results are sorted by
    /// their default relevance scores in descending order: <code>_score
    /// desc</code>. You can also sort by document ID
    /// (<code>_id asc</code>) and version (<code>_version desc</code>).</p>
    /// <p>For more information, see <a href="http://docs.aws.amazon.com/cloudsearch/latest/developerguide/sorting-results.html">Sorting Results</a> in the <i>Amazon CloudSearch Developer Guide</i>.</p>
    pub sort: std::option::Option<std::string::String>,
    /// <p>Specifies the offset of the first search hit you want to return. Note that the result set is zero-based; the first result is at index 0. You can specify either the <code>start</code> or <code>cursor</code> parameter in a request, they are mutually exclusive.  </p>
    /// <p>For more information, see <a href="http://docs.aws.amazon.com/cloudsearch/latest/developerguide/paginating-results.html">Paginating Results</a> in the <i>Amazon CloudSearch Developer Guide</i>.</p>
    pub start: i64,
    /// <p>Specifies one or more fields for which to get statistics information. Each specified field must be facet-enabled in the domain configuration. The fields are specified in JSON using the form:</p>
    /// <code>{"FIELD-A":{},"FIELD-B":{}}</code>
    /// <p>There are currently no options supported for statistics.</p>
    pub stats: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for SearchInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("SearchInput");
        formatter.field("cursor", &self.cursor);
        formatter.field("expr", &self.expr);
        formatter.field("facet", &self.facet);
        formatter.field("filter_query", &self.filter_query);
        formatter.field("highlight", &self.highlight);
        formatter.field("partial", &self.partial);
        formatter.field("query", &self.query);
        formatter.field("query_options", &self.query_options);
        formatter.field("query_parser", &self.query_parser);
        formatter.field("r#return", &self.r#return);
        formatter.field("size", &self.size);
        formatter.field("sort", &self.sort);
        formatter.field("start", &self.start);
        formatter.field("stats", &self.stats);
        formatter.finish()
    }
}
