// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
/// <p>Adds one or more tags to a trail, up to a limit of 50. Overwrites an existing tag's value when a new value is specified for an existing tag key.
/// Tag key names must be unique for a trail; you cannot have two keys with the same name but different values.
/// If you specify a key without a value, the tag will be created with the specified key and a value of null.
/// You can tag a trail that applies to all Amazon Web Services Regions only from the Region in which the trail was created (also known as its home region).</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct AddTags {
    _private: (),
}
impl AddTags {
    /// Creates a new builder-style object to manufacture [`AddTagsInput`](crate::input::AddTagsInput)
    pub fn builder() -> crate::input::add_tags_input::Builder {
        crate::input::add_tags_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for AddTags {
    type Output = std::result::Result<crate::output::AddTagsOutput, crate::error::AddTagsError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_add_tags_error(response)
        } else {
            crate::operation_deser::parse_add_tags_response(response)
        }
    }
}

/// <p>Creates a trail that specifies the settings for delivery of log data to an Amazon S3 bucket.
/// </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateTrail {
    _private: (),
}
impl CreateTrail {
    /// Creates a new builder-style object to manufacture [`CreateTrailInput`](crate::input::CreateTrailInput)
    pub fn builder() -> crate::input::create_trail_input::Builder {
        crate::input::create_trail_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateTrail {
    type Output =
        std::result::Result<crate::output::CreateTrailOutput, crate::error::CreateTrailError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_trail_error(response)
        } else {
            crate::operation_deser::parse_create_trail_response(response)
        }
    }
}

/// <p>Deletes a trail. This operation must be called from the region in which the trail was
/// created. <code>DeleteTrail</code> cannot be called on the shadow trails (replicated trails
/// in other regions) of a trail that is enabled in all regions.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteTrail {
    _private: (),
}
impl DeleteTrail {
    /// Creates a new builder-style object to manufacture [`DeleteTrailInput`](crate::input::DeleteTrailInput)
    pub fn builder() -> crate::input::delete_trail_input::Builder {
        crate::input::delete_trail_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteTrail {
    type Output =
        std::result::Result<crate::output::DeleteTrailOutput, crate::error::DeleteTrailError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_trail_error(response)
        } else {
            crate::operation_deser::parse_delete_trail_response(response)
        }
    }
}

/// <p>Retrieves settings for one or more trails associated with the current region for your account.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeTrails {
    _private: (),
}
impl DescribeTrails {
    /// Creates a new builder-style object to manufacture [`DescribeTrailsInput`](crate::input::DescribeTrailsInput)
    pub fn builder() -> crate::input::describe_trails_input::Builder {
        crate::input::describe_trails_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeTrails {
    type Output =
        std::result::Result<crate::output::DescribeTrailsOutput, crate::error::DescribeTrailsError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_trails_error(response)
        } else {
            crate::operation_deser::parse_describe_trails_response(response)
        }
    }
}

/// <p>Describes the settings for the event selectors that you configured for your trail.
/// The information returned for your event selectors includes the following:</p>
/// <ul>
/// <li>
/// <p>If your event selector includes read-only events, write-only events, or
/// all events. This applies to both management events and data events.</p>
/// </li>
/// <li>
/// <p>If your event selector includes management events.</p>
/// </li>
/// <li>
/// <p>If your event selector includes data events, the resources on which you are logging data
/// events.</p>
/// </li>
/// </ul>
/// <p>For more information, see <a href="https://docs.aws.amazon.com/awscloudtrail/latest/userguide/logging-management-and-data-events-with-cloudtrail.html">Logging Data and Management Events for Trails
/// </a> in the <i>CloudTrail User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetEventSelectors {
    _private: (),
}
impl GetEventSelectors {
    /// Creates a new builder-style object to manufacture [`GetEventSelectorsInput`](crate::input::GetEventSelectorsInput)
    pub fn builder() -> crate::input::get_event_selectors_input::Builder {
        crate::input::get_event_selectors_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetEventSelectors {
    type Output = std::result::Result<
        crate::output::GetEventSelectorsOutput,
        crate::error::GetEventSelectorsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_event_selectors_error(response)
        } else {
            crate::operation_deser::parse_get_event_selectors_response(response)
        }
    }
}

/// <p>Describes the settings for the Insights event selectors that you configured for your trail. <code>GetInsightSelectors</code> shows
/// if CloudTrail Insights event logging is enabled on the trail, and if it is, which insight types are enabled.
/// If you run <code>GetInsightSelectors</code> on a trail that does not have Insights events enabled, the operation throws the exception
/// <code>InsightNotEnabledException</code>
/// </p>
/// <p>For more information, see <a href="https://docs.aws.amazon.com/awscloudtrail/latest/userguide/logging-insights-events-with-cloudtrail.html">Logging CloudTrail Insights Events for Trails
/// </a> in the <i>CloudTrail User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetInsightSelectors {
    _private: (),
}
impl GetInsightSelectors {
    /// Creates a new builder-style object to manufacture [`GetInsightSelectorsInput`](crate::input::GetInsightSelectorsInput)
    pub fn builder() -> crate::input::get_insight_selectors_input::Builder {
        crate::input::get_insight_selectors_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetInsightSelectors {
    type Output = std::result::Result<
        crate::output::GetInsightSelectorsOutput,
        crate::error::GetInsightSelectorsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_insight_selectors_error(response)
        } else {
            crate::operation_deser::parse_get_insight_selectors_response(response)
        }
    }
}

/// <p>Returns settings information for a specified trail.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetTrail {
    _private: (),
}
impl GetTrail {
    /// Creates a new builder-style object to manufacture [`GetTrailInput`](crate::input::GetTrailInput)
    pub fn builder() -> crate::input::get_trail_input::Builder {
        crate::input::get_trail_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetTrail {
    type Output = std::result::Result<crate::output::GetTrailOutput, crate::error::GetTrailError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_trail_error(response)
        } else {
            crate::operation_deser::parse_get_trail_response(response)
        }
    }
}

/// <p>Returns a JSON-formatted list of information about the specified trail. Fields include information on delivery errors, Amazon SNS and Amazon S3 errors, and start and stop logging times for each trail. This operation returns trail status from a single region. To return trail status from all regions, you must call the operation on each region.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetTrailStatus {
    _private: (),
}
impl GetTrailStatus {
    /// Creates a new builder-style object to manufacture [`GetTrailStatusInput`](crate::input::GetTrailStatusInput)
    pub fn builder() -> crate::input::get_trail_status_input::Builder {
        crate::input::get_trail_status_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetTrailStatus {
    type Output =
        std::result::Result<crate::output::GetTrailStatusOutput, crate::error::GetTrailStatusError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_trail_status_error(response)
        } else {
            crate::operation_deser::parse_get_trail_status_response(response)
        }
    }
}

/// <p>Returns all public keys whose private keys were used to sign the digest files within the specified time range. The public key is needed to validate digest files that were signed with its corresponding private key.</p>
/// <note>
/// <p>CloudTrail uses different private and public key pairs per region. Each digest file is signed with a private key
/// unique to its region. When you validate a digest file from a specific region, you must look in the same region for its
/// corresponding public key.</p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListPublicKeys {
    _private: (),
}
impl ListPublicKeys {
    /// Creates a new builder-style object to manufacture [`ListPublicKeysInput`](crate::input::ListPublicKeysInput)
    pub fn builder() -> crate::input::list_public_keys_input::Builder {
        crate::input::list_public_keys_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListPublicKeys {
    type Output =
        std::result::Result<crate::output::ListPublicKeysOutput, crate::error::ListPublicKeysError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_public_keys_error(response)
        } else {
            crate::operation_deser::parse_list_public_keys_response(response)
        }
    }
}

/// <p>Lists the tags for the trail in the current region.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListTags {
    _private: (),
}
impl ListTags {
    /// Creates a new builder-style object to manufacture [`ListTagsInput`](crate::input::ListTagsInput)
    pub fn builder() -> crate::input::list_tags_input::Builder {
        crate::input::list_tags_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListTags {
    type Output = std::result::Result<crate::output::ListTagsOutput, crate::error::ListTagsError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_tags_error(response)
        } else {
            crate::operation_deser::parse_list_tags_response(response)
        }
    }
}

/// <p>Lists trails that are in the current account.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListTrails {
    _private: (),
}
impl ListTrails {
    /// Creates a new builder-style object to manufacture [`ListTrailsInput`](crate::input::ListTrailsInput)
    pub fn builder() -> crate::input::list_trails_input::Builder {
        crate::input::list_trails_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListTrails {
    type Output =
        std::result::Result<crate::output::ListTrailsOutput, crate::error::ListTrailsError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_trails_error(response)
        } else {
            crate::operation_deser::parse_list_trails_response(response)
        }
    }
}

/// <p>Looks up <a href="https://docs.aws.amazon.com/awscloudtrail/latest/userguide/cloudtrail-concepts.html#cloudtrail-concepts-management-events">management events</a> or
/// <a href="https://docs.aws.amazon.com/awscloudtrail/latest/userguide/cloudtrail-concepts.html#cloudtrail-concepts-insights-events">CloudTrail Insights events</a> that are captured by CloudTrail.
/// You can look up events that occurred in a region within the last 90 days. Lookup supports the following attributes for management events:</p>
/// <ul>
/// <li>
/// <p>Amazon Web Services access key</p>
/// </li>
/// <li>
/// <p>Event ID</p>
/// </li>
/// <li>
/// <p>Event name</p>
/// </li>
/// <li>
/// <p>Event source</p>
/// </li>
/// <li>
/// <p>Read only</p>
/// </li>
/// <li>
/// <p>Resource name</p>
/// </li>
/// <li>
/// <p>Resource type</p>
/// </li>
/// <li>
/// <p>User name</p>
/// </li>
/// </ul>
/// <p>Lookup supports the following attributes for Insights events:</p>
/// <ul>
/// <li>
/// <p>Event ID</p>
/// </li>
/// <li>
/// <p>Event name</p>
/// </li>
/// <li>
/// <p>Event source</p>
/// </li>
/// </ul>
/// <p>All attributes are optional. The default number of results returned is 50, with a
/// maximum of 50 possible. The response includes a token that you can use to get the next page
/// of results.</p>
/// <important>
/// <p>The rate of lookup requests is limited to two per second, per account, per region. If this
/// limit is exceeded, a throttling error occurs.</p>
/// </important>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct LookupEvents {
    _private: (),
}
impl LookupEvents {
    /// Creates a new builder-style object to manufacture [`LookupEventsInput`](crate::input::LookupEventsInput)
    pub fn builder() -> crate::input::lookup_events_input::Builder {
        crate::input::lookup_events_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for LookupEvents {
    type Output =
        std::result::Result<crate::output::LookupEventsOutput, crate::error::LookupEventsError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_lookup_events_error(response)
        } else {
            crate::operation_deser::parse_lookup_events_response(response)
        }
    }
}

/// <p>Configures an event selector or advanced event selectors for your trail.
/// Use event selectors or advanced event selectors to specify management and data event settings for your trail. By
/// default, trails created without specific event selectors are configured to log all read and
/// write management events, and no data events.</p>
/// <p>When an event occurs in your account, CloudTrail
/// evaluates the event selectors or advanced event selectors in all trails. For each trail, if the event matches
/// any event selector, the trail processes and logs the event. If the event doesn't match any event
/// selector, the trail doesn't log the event.</p>
/// <p>Example</p>
/// <ol>
/// <li>
/// <p>You create an event selector for a trail and specify that you want
/// write-only events.</p>
/// </li>
/// <li>
/// <p>The EC2 <code>GetConsoleOutput</code> and <code>RunInstances</code> API
/// operations occur in your account.</p>
/// </li>
/// <li>
/// <p>CloudTrail evaluates whether the events match your event
/// selectors.</p>
/// </li>
/// <li>
/// <p>The <code>RunInstances</code> is a write-only event and it matches your
/// event selector. The trail logs the event.</p>
/// </li>
/// <li>
/// <p>The <code>GetConsoleOutput</code> is a read-only event that doesn't
/// match your event selector. The trail doesn't log the event.
/// </p>
/// </li>
/// </ol>
/// <p>The <code>PutEventSelectors</code> operation must be called from the region in which
/// the trail was created; otherwise, an <code>InvalidHomeRegionException</code> exception is
/// thrown.</p>
/// <p>You can configure up to five event selectors for each trail. For more information, see <a href="https://docs.aws.amazon.com/awscloudtrail/latest/userguide/logging-management-and-data-events-with-cloudtrail.html">Logging data and management events for trails
/// </a> and <a href="https://docs.aws.amazon.com/awscloudtrail/latest/userguide/WhatIsCloudTrail-Limits.html">Quotas in CloudTrail</a>
/// in the <i>CloudTrail User Guide</i>.</p>
/// <p>You can add advanced event selectors, and conditions for your advanced
/// event selectors, up to a maximum of 500 values for all conditions and selectors on a trail.
/// You can use either <code>AdvancedEventSelectors</code> or <code>EventSelectors</code>, but not both. If you apply <code>AdvancedEventSelectors</code>
/// to a trail, any existing <code>EventSelectors</code> are overwritten. For more information about
/// advanced event selectors, see
/// <a href="https://docs.aws.amazon.com/awscloudtrail/latest/userguide/logging-data-events-with-cloudtrail.html">Logging
/// data events for trails</a> in the <i>CloudTrail User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct PutEventSelectors {
    _private: (),
}
impl PutEventSelectors {
    /// Creates a new builder-style object to manufacture [`PutEventSelectorsInput`](crate::input::PutEventSelectorsInput)
    pub fn builder() -> crate::input::put_event_selectors_input::Builder {
        crate::input::put_event_selectors_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for PutEventSelectors {
    type Output = std::result::Result<
        crate::output::PutEventSelectorsOutput,
        crate::error::PutEventSelectorsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_put_event_selectors_error(response)
        } else {
            crate::operation_deser::parse_put_event_selectors_response(response)
        }
    }
}

/// <p>Lets you enable Insights event logging by specifying the Insights
/// selectors that you want to enable on an existing trail. You also use
/// <code>PutInsightSelectors</code> to turn off Insights event logging, by passing an empty list of insight types.
/// The valid Insights event type in this release is <code>ApiCallRateInsight</code>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct PutInsightSelectors {
    _private: (),
}
impl PutInsightSelectors {
    /// Creates a new builder-style object to manufacture [`PutInsightSelectorsInput`](crate::input::PutInsightSelectorsInput)
    pub fn builder() -> crate::input::put_insight_selectors_input::Builder {
        crate::input::put_insight_selectors_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for PutInsightSelectors {
    type Output = std::result::Result<
        crate::output::PutInsightSelectorsOutput,
        crate::error::PutInsightSelectorsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_put_insight_selectors_error(response)
        } else {
            crate::operation_deser::parse_put_insight_selectors_response(response)
        }
    }
}

/// <p>Removes the specified tags from a trail.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct RemoveTags {
    _private: (),
}
impl RemoveTags {
    /// Creates a new builder-style object to manufacture [`RemoveTagsInput`](crate::input::RemoveTagsInput)
    pub fn builder() -> crate::input::remove_tags_input::Builder {
        crate::input::remove_tags_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for RemoveTags {
    type Output =
        std::result::Result<crate::output::RemoveTagsOutput, crate::error::RemoveTagsError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_remove_tags_error(response)
        } else {
            crate::operation_deser::parse_remove_tags_response(response)
        }
    }
}

/// <p>Starts the recording of Amazon Web Services API calls and log file delivery for a trail. For a trail that is enabled in all regions, this operation must be called from the region in which the trail was created. This operation cannot be called on the shadow trails (replicated trails in other regions) of a trail that is enabled in all regions.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct StartLogging {
    _private: (),
}
impl StartLogging {
    /// Creates a new builder-style object to manufacture [`StartLoggingInput`](crate::input::StartLoggingInput)
    pub fn builder() -> crate::input::start_logging_input::Builder {
        crate::input::start_logging_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for StartLogging {
    type Output =
        std::result::Result<crate::output::StartLoggingOutput, crate::error::StartLoggingError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_start_logging_error(response)
        } else {
            crate::operation_deser::parse_start_logging_response(response)
        }
    }
}

/// <p>Suspends the recording of Amazon Web Services API calls and log file delivery for the specified trail.
/// Under most circumstances, there is no need to use this action. You can update a trail
/// without stopping it first. This action is the only way to stop recording. For a trail
/// enabled in all regions, this operation must be called from the region in which the trail
/// was created, or an <code>InvalidHomeRegionException</code> will occur. This operation
/// cannot be called on the shadow trails (replicated trails in other regions) of a trail
/// enabled in all regions.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct StopLogging {
    _private: (),
}
impl StopLogging {
    /// Creates a new builder-style object to manufacture [`StopLoggingInput`](crate::input::StopLoggingInput)
    pub fn builder() -> crate::input::stop_logging_input::Builder {
        crate::input::stop_logging_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for StopLogging {
    type Output =
        std::result::Result<crate::output::StopLoggingOutput, crate::error::StopLoggingError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_stop_logging_error(response)
        } else {
            crate::operation_deser::parse_stop_logging_response(response)
        }
    }
}

/// <p>Updates trail settings that control what events you are logging, and how to handle log files. Changes to a trail do not require
/// stopping the CloudTrail service. Use this action to designate an existing bucket for log
/// delivery. If the existing bucket has previously been a target for CloudTrail log files,
/// an IAM policy exists for the bucket. <code>UpdateTrail</code> must be called from the
/// region in which the trail was created; otherwise, an
/// <code>InvalidHomeRegionException</code> is thrown.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UpdateTrail {
    _private: (),
}
impl UpdateTrail {
    /// Creates a new builder-style object to manufacture [`UpdateTrailInput`](crate::input::UpdateTrailInput)
    pub fn builder() -> crate::input::update_trail_input::Builder {
        crate::input::update_trail_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UpdateTrail {
    type Output =
        std::result::Result<crate::output::UpdateTrailOutput, crate::error::UpdateTrailError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_update_trail_error(response)
        } else {
            crate::operation_deser::parse_update_trail_response(response)
        }
    }
}
