// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
/// <p>Adds a new client ID (also known as audience) to the list of client IDs already
/// registered for the specified IAM OpenID Connect (OIDC) provider resource.</p>
/// <p>This operation is idempotent; it does not fail or return an error if you add an
/// existing client ID to the provider.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct AddClientIDToOpenIDConnectProvider {
    _private: (),
}
impl AddClientIDToOpenIDConnectProvider {
    /// Creates a new builder-style object to manufacture [`AddClientIdToOpenIdConnectProviderInput`](crate::input::AddClientIdToOpenIdConnectProviderInput)
    pub fn builder() -> crate::input::add_client_id_to_open_id_connect_provider_input::Builder {
        crate::input::add_client_id_to_open_id_connect_provider_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for AddClientIDToOpenIDConnectProvider {
    type Output = std::result::Result<
        crate::output::AddClientIdToOpenIdConnectProviderOutput,
        crate::error::AddClientIDToOpenIDConnectProviderError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_add_client_id_to_open_id_connect_provider_error(response)
        } else {
            crate::operation_deser::parse_add_client_id_to_open_id_connect_provider_response(
                response,
            )
        }
    }
}

/// <p>Adds the specified IAM role to the specified instance profile. An instance profile
/// can contain only one role, and this quota cannot be increased. You can remove the
/// existing role and then add a different role to an instance profile. You must then wait
/// for the change to appear across all of Amazon Web Services because of <a href="https://en.wikipedia.org/wiki/Eventual_consistency">eventual
/// consistency</a>. To force the change, you must <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_DisassociateIamInstanceProfile.html">disassociate the instance profile</a> and then <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_AssociateIamInstanceProfile.html">associate the
/// instance profile</a>, or you can stop your instance and then restart it.</p>
/// <note>
/// <p>The caller of this operation must be granted the <code>PassRole</code> permission
/// on the IAM role by a permissions policy.</p>
/// </note>
/// <p>For more information about roles, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/WorkingWithRoles.html">Working with roles</a>. For more
/// information about instance profiles, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/AboutInstanceProfiles.html">About instance
/// profiles</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct AddRoleToInstanceProfile {
    _private: (),
}
impl AddRoleToInstanceProfile {
    /// Creates a new builder-style object to manufacture [`AddRoleToInstanceProfileInput`](crate::input::AddRoleToInstanceProfileInput)
    pub fn builder() -> crate::input::add_role_to_instance_profile_input::Builder {
        crate::input::add_role_to_instance_profile_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for AddRoleToInstanceProfile {
    type Output = std::result::Result<
        crate::output::AddRoleToInstanceProfileOutput,
        crate::error::AddRoleToInstanceProfileError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_add_role_to_instance_profile_error(response)
        } else {
            crate::operation_deser::parse_add_role_to_instance_profile_response(response)
        }
    }
}

/// <p>Adds the specified user to the specified group.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct AddUserToGroup {
    _private: (),
}
impl AddUserToGroup {
    /// Creates a new builder-style object to manufacture [`AddUserToGroupInput`](crate::input::AddUserToGroupInput)
    pub fn builder() -> crate::input::add_user_to_group_input::Builder {
        crate::input::add_user_to_group_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for AddUserToGroup {
    type Output =
        std::result::Result<crate::output::AddUserToGroupOutput, crate::error::AddUserToGroupError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_add_user_to_group_error(response)
        } else {
            crate::operation_deser::parse_add_user_to_group_response(response)
        }
    }
}

/// <p>Attaches the specified managed policy to the specified IAM group.</p>
/// <p>You use this operation to attach a managed policy to a group. To embed an inline
/// policy in a group, use <a>PutGroupPolicy</a>.</p>
/// <p>As a best practice, you can validate your IAM policies.
/// To learn more, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/access_policies_policy-validator.html">Validating IAM policies</a>
/// in the <i>IAM User Guide</i>.</p>
/// <p>For more information about policies, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/policies-managed-vs-inline.html">Managed policies and inline
/// policies</a> in the <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct AttachGroupPolicy {
    _private: (),
}
impl AttachGroupPolicy {
    /// Creates a new builder-style object to manufacture [`AttachGroupPolicyInput`](crate::input::AttachGroupPolicyInput)
    pub fn builder() -> crate::input::attach_group_policy_input::Builder {
        crate::input::attach_group_policy_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for AttachGroupPolicy {
    type Output = std::result::Result<
        crate::output::AttachGroupPolicyOutput,
        crate::error::AttachGroupPolicyError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_attach_group_policy_error(response)
        } else {
            crate::operation_deser::parse_attach_group_policy_response(response)
        }
    }
}

/// <p>Attaches the specified managed policy to the specified IAM role. When you attach a
/// managed policy to a role, the managed policy becomes part of the role's permission
/// (access) policy.</p>
/// <note>
/// <p>You cannot use a managed policy as the role's trust policy. The role's trust
/// policy is created at the same time as the role, using <a>CreateRole</a>.
/// You can update a role's trust policy using <a>UpdateAssumeRolePolicy</a>.</p>
/// </note>
/// <p>Use this operation to attach a <i>managed</i> policy to a role. To embed
/// an inline policy in a role, use <a>PutRolePolicy</a>. For more information
/// about policies, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/policies-managed-vs-inline.html">Managed policies and inline
/// policies</a> in the <i>IAM User Guide</i>.</p>
/// <p>As a best practice, you can validate your IAM policies.
/// To learn more, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/access_policies_policy-validator.html">Validating IAM policies</a>
/// in the <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct AttachRolePolicy {
    _private: (),
}
impl AttachRolePolicy {
    /// Creates a new builder-style object to manufacture [`AttachRolePolicyInput`](crate::input::AttachRolePolicyInput)
    pub fn builder() -> crate::input::attach_role_policy_input::Builder {
        crate::input::attach_role_policy_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for AttachRolePolicy {
    type Output = std::result::Result<
        crate::output::AttachRolePolicyOutput,
        crate::error::AttachRolePolicyError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_attach_role_policy_error(response)
        } else {
            crate::operation_deser::parse_attach_role_policy_response(response)
        }
    }
}

/// <p>Attaches the specified managed policy to the specified user.</p>
/// <p>You use this operation to attach a <i>managed</i> policy to a user. To
/// embed an inline policy in a user, use <a>PutUserPolicy</a>.</p>
/// <p>As a best practice, you can validate your IAM policies.
/// To learn more, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/access_policies_policy-validator.html">Validating IAM policies</a>
/// in the <i>IAM User Guide</i>.</p>
/// <p>For more information about policies, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/policies-managed-vs-inline.html">Managed policies and inline
/// policies</a> in the <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct AttachUserPolicy {
    _private: (),
}
impl AttachUserPolicy {
    /// Creates a new builder-style object to manufacture [`AttachUserPolicyInput`](crate::input::AttachUserPolicyInput)
    pub fn builder() -> crate::input::attach_user_policy_input::Builder {
        crate::input::attach_user_policy_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for AttachUserPolicy {
    type Output = std::result::Result<
        crate::output::AttachUserPolicyOutput,
        crate::error::AttachUserPolicyError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_attach_user_policy_error(response)
        } else {
            crate::operation_deser::parse_attach_user_policy_response(response)
        }
    }
}

/// <p>Changes the password of the IAM user who is calling this operation. This operation
/// can be performed using the CLI, the Amazon Web Services API, or the <b>My
/// Security Credentials</b> page in the Amazon Web Services Management Console. The Amazon Web Services account root user
/// password is not affected by this operation.</p>
/// <p>Use <a>UpdateLoginProfile</a> to use the CLI, the Amazon Web Services API, or the
/// <b>Users</b> page in the IAM console to change the
/// password for any IAM user. For more information about modifying passwords, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/Using_ManagingLogins.html">Managing
/// passwords</a> in the <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ChangePassword {
    _private: (),
}
impl ChangePassword {
    /// Creates a new builder-style object to manufacture [`ChangePasswordInput`](crate::input::ChangePasswordInput)
    pub fn builder() -> crate::input::change_password_input::Builder {
        crate::input::change_password_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ChangePassword {
    type Output =
        std::result::Result<crate::output::ChangePasswordOutput, crate::error::ChangePasswordError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_change_password_error(response)
        } else {
            crate::operation_deser::parse_change_password_response(response)
        }
    }
}

/// <p> Creates a new Amazon Web Services secret access key and corresponding Amazon Web Services access key ID for the
/// specified user. The default status for new keys is <code>Active</code>.</p>
/// <p>If you do not specify a user name, IAM determines the user name implicitly based on
/// the Amazon Web Services access key ID signing the request. This operation works for access keys under
/// the Amazon Web Services account. Consequently, you can use this operation to manage Amazon Web Services account root
/// user credentials. This is true even if the Amazon Web Services account has no associated users.</p>
/// <p> For information about quotas on the number of keys you can create, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/reference_iam-quotas.html">IAM and STS
/// quotas</a> in the <i>IAM User Guide</i>.</p>
/// <important>
/// <p>To ensure the security of your Amazon Web Services account, the secret access key is accessible
/// only during key and user creation. You must save the key (for example, in a text
/// file) if you want to be able to access it again. If a secret key is lost, you can
/// delete the access keys for the associated user and then create new keys.</p>
/// </important>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateAccessKey {
    _private: (),
}
impl CreateAccessKey {
    /// Creates a new builder-style object to manufacture [`CreateAccessKeyInput`](crate::input::CreateAccessKeyInput)
    pub fn builder() -> crate::input::create_access_key_input::Builder {
        crate::input::create_access_key_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateAccessKey {
    type Output = std::result::Result<
        crate::output::CreateAccessKeyOutput,
        crate::error::CreateAccessKeyError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_access_key_error(response)
        } else {
            crate::operation_deser::parse_create_access_key_response(response)
        }
    }
}

/// <p>Creates an alias for your Amazon Web Services account. For information about using an Amazon Web Services account
/// alias, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/AccountAlias.html">Using an
/// alias for your Amazon Web Services account ID</a> in the
/// <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateAccountAlias {
    _private: (),
}
impl CreateAccountAlias {
    /// Creates a new builder-style object to manufacture [`CreateAccountAliasInput`](crate::input::CreateAccountAliasInput)
    pub fn builder() -> crate::input::create_account_alias_input::Builder {
        crate::input::create_account_alias_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateAccountAlias {
    type Output = std::result::Result<
        crate::output::CreateAccountAliasOutput,
        crate::error::CreateAccountAliasError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_account_alias_error(response)
        } else {
            crate::operation_deser::parse_create_account_alias_response(response)
        }
    }
}

/// <p>Creates a new group.</p>
/// <p> For information about the number of groups you can create, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/reference_iam-quotas.html">IAM and STS
/// quotas</a> in the <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateGroup {
    _private: (),
}
impl CreateGroup {
    /// Creates a new builder-style object to manufacture [`CreateGroupInput`](crate::input::CreateGroupInput)
    pub fn builder() -> crate::input::create_group_input::Builder {
        crate::input::create_group_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateGroup {
    type Output =
        std::result::Result<crate::output::CreateGroupOutput, crate::error::CreateGroupError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_group_error(response)
        } else {
            crate::operation_deser::parse_create_group_response(response)
        }
    }
}

/// <p> Creates a new instance profile. For information about instance profiles, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_roles_use_switch-role-ec2.html">Using
/// roles for applications on Amazon EC2</a> in the
/// <i>IAM User Guide</i>, and <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/iam-roles-for-amazon-ec2.html#ec2-instance-profile">Instance profiles</a> in the <i>Amazon EC2 User Guide</i>.</p>
/// <p> For information about the number of instance profiles you can create, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/reference_iam-quotas.html">IAM object
/// quotas</a> in the <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateInstanceProfile {
    _private: (),
}
impl CreateInstanceProfile {
    /// Creates a new builder-style object to manufacture [`CreateInstanceProfileInput`](crate::input::CreateInstanceProfileInput)
    pub fn builder() -> crate::input::create_instance_profile_input::Builder {
        crate::input::create_instance_profile_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateInstanceProfile {
    type Output = std::result::Result<
        crate::output::CreateInstanceProfileOutput,
        crate::error::CreateInstanceProfileError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_instance_profile_error(response)
        } else {
            crate::operation_deser::parse_create_instance_profile_response(response)
        }
    }
}

/// <p>Creates a password for the specified IAM user. A password allows an IAM user to
/// access Amazon Web Services services through the Amazon Web Services Management Console.</p>
/// <p>You can use the CLI, the Amazon Web Services API, or the <b>Users</b> page in the IAM console to create a password for any IAM user.
/// Use <a>ChangePassword</a> to update your own existing password in the
/// <b>My Security Credentials</b> page in the
/// Amazon Web Services Management Console.</p>
/// <p>For more information about managing passwords, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/Using_ManagingLogins.html">Managing passwords</a> in the
/// <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateLoginProfile {
    _private: (),
}
impl CreateLoginProfile {
    /// Creates a new builder-style object to manufacture [`CreateLoginProfileInput`](crate::input::CreateLoginProfileInput)
    pub fn builder() -> crate::input::create_login_profile_input::Builder {
        crate::input::create_login_profile_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateLoginProfile {
    type Output = std::result::Result<
        crate::output::CreateLoginProfileOutput,
        crate::error::CreateLoginProfileError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_login_profile_error(response)
        } else {
            crate::operation_deser::parse_create_login_profile_response(response)
        }
    }
}

/// <p>Creates an IAM entity to describe an identity provider (IdP) that supports <a href="http://openid.net/connect/">OpenID Connect (OIDC)</a>.</p>
/// <p>The OIDC provider that you create with this operation can be used as a principal in a
/// role's trust policy. Such a policy establishes a trust relationship between Amazon Web Services and
/// the OIDC provider.</p>
/// <p>If you are using an OIDC identity provider from Google, Facebook, or Amazon Cognito, you don't
/// need to create a separate IAM identity provider. These OIDC identity providers are
/// already built-in to Amazon Web Services and are available for your use. Instead, you can move directly
/// to creating new roles using your identity provider. To learn more, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_roles_create_for-idp_oidc.html">Creating
/// a role for web identity or OpenID connect federation</a> in the <i>IAM
/// User Guide</i>.</p>
/// <p>When you create the IAM OIDC provider, you specify the following:</p>
/// <ul>
/// <li>
/// <p>The URL of the OIDC identity provider (IdP) to trust</p>
/// </li>
/// <li>
/// <p>A list of client IDs (also known as audiences) that identify the application
/// or applications  allowed to authenticate using the OIDC provider</p>
/// </li>
/// <li>
/// <p>A list of thumbprints of one or more server certificates that the IdP
/// uses</p>
/// </li>
/// </ul>
/// <p>You get all of this information from the OIDC IdP you want to use to access
/// Amazon Web Services.</p>
/// <note>
/// <p>Amazon Web Services secures communication with some OIDC identity providers (IdPs) through our
/// library of trusted certificate authorities (CAs) instead of using a certificate
/// thumbprint to verify your IdP server certificate. These OIDC IdPs include Google, and
/// those that use an Amazon S3 bucket to host a JSON Web Key Set (JWKS) endpoint. In these
/// cases, your legacy thumbprint remains in your configuration, but is no longer used for validation.</p>
/// </note>
/// <note>
/// <p>The trust for the OIDC provider is derived from the IAM provider that this
/// operation creates. Therefore, it is best to limit access to the <a>CreateOpenIDConnectProvider</a> operation to highly privileged
/// users.</p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateOpenIDConnectProvider {
    _private: (),
}
impl CreateOpenIDConnectProvider {
    /// Creates a new builder-style object to manufacture [`CreateOpenIdConnectProviderInput`](crate::input::CreateOpenIdConnectProviderInput)
    pub fn builder() -> crate::input::create_open_id_connect_provider_input::Builder {
        crate::input::create_open_id_connect_provider_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateOpenIDConnectProvider {
    type Output = std::result::Result<
        crate::output::CreateOpenIdConnectProviderOutput,
        crate::error::CreateOpenIDConnectProviderError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_open_id_connect_provider_error(response)
        } else {
            crate::operation_deser::parse_create_open_id_connect_provider_response(response)
        }
    }
}

/// <p>Creates a new managed policy for your Amazon Web Services account.</p>
/// <p>This operation creates a policy version with a version identifier of <code>v1</code>
/// and sets v1 as the policy's default version. For more information about policy versions,
/// see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/policies-managed-versions.html">Versioning for managed policies</a> in the
/// <i>IAM User Guide</i>.</p>
/// <p>As a best practice, you can validate your IAM policies.
/// To learn more, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/access_policies_policy-validator.html">Validating IAM policies</a>
/// in the <i>IAM User Guide</i>.</p>
/// <p>For more information about managed policies in general, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/policies-managed-vs-inline.html">Managed
/// policies and inline policies</a> in the
/// <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreatePolicy {
    _private: (),
}
impl CreatePolicy {
    /// Creates a new builder-style object to manufacture [`CreatePolicyInput`](crate::input::CreatePolicyInput)
    pub fn builder() -> crate::input::create_policy_input::Builder {
        crate::input::create_policy_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreatePolicy {
    type Output =
        std::result::Result<crate::output::CreatePolicyOutput, crate::error::CreatePolicyError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_policy_error(response)
        } else {
            crate::operation_deser::parse_create_policy_response(response)
        }
    }
}

/// <p>Creates a new version of the specified managed policy. To update a managed policy, you
/// create a new policy version. A managed policy can have up to five versions. If the
/// policy has five versions, you must delete an existing version using <a>DeletePolicyVersion</a> before you create a new version.</p>
/// <p>Optionally, you can set the new version as the policy's default version. The default
/// version is the version that is in effect for the IAM users, groups, and roles to which
/// the policy is attached.</p>
/// <p>For more information about managed policy versions, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/policies-managed-versions.html">Versioning for managed
/// policies</a> in the <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreatePolicyVersion {
    _private: (),
}
impl CreatePolicyVersion {
    /// Creates a new builder-style object to manufacture [`CreatePolicyVersionInput`](crate::input::CreatePolicyVersionInput)
    pub fn builder() -> crate::input::create_policy_version_input::Builder {
        crate::input::create_policy_version_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreatePolicyVersion {
    type Output = std::result::Result<
        crate::output::CreatePolicyVersionOutput,
        crate::error::CreatePolicyVersionError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_policy_version_error(response)
        } else {
            crate::operation_deser::parse_create_policy_version_response(response)
        }
    }
}

/// <p>Creates a new role for your Amazon Web Services account. For more information about roles, see
/// <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/WorkingWithRoles.html">IAM
/// roles</a>. For information about quotas for role names and the number of roles
/// you can create, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/reference_iam-quotas.html">IAM and STS quotas</a> in the
/// <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateRole {
    _private: (),
}
impl CreateRole {
    /// Creates a new builder-style object to manufacture [`CreateRoleInput`](crate::input::CreateRoleInput)
    pub fn builder() -> crate::input::create_role_input::Builder {
        crate::input::create_role_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateRole {
    type Output =
        std::result::Result<crate::output::CreateRoleOutput, crate::error::CreateRoleError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_role_error(response)
        } else {
            crate::operation_deser::parse_create_role_response(response)
        }
    }
}

/// <p>Creates an IAM resource that describes an identity provider (IdP) that supports SAML
/// 2.0.</p>
/// <p>The SAML provider resource that you create with this operation can be used as a
/// principal in an IAM role's trust policy. Such a policy can enable federated users who
/// sign in using the SAML IdP to assume the role. You can create an IAM role that
/// supports Web-based single sign-on (SSO) to the Amazon Web Services Management Console or one that supports API access
/// to Amazon Web Services.</p>
/// <p>When you create the SAML provider resource, you upload a SAML metadata document that
/// you get from your IdP. That document includes the issuer's name, expiration information,
/// and keys that can be used to validate the SAML authentication response (assertions) that
/// the IdP sends. You must generate the metadata document using the identity management
/// software that is used as your organization's IdP.</p>
/// <note>
/// <p> This operation requires <a href="https://docs.aws.amazon.com/general/latest/gr/signature-version-4.html">Signature Version 4</a>.</p>
/// </note>
/// <p> For more information, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_roles_providers_enable-console-saml.html">Enabling SAML 2.0
/// federated users to access the Amazon Web Services Management Console</a> and <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_roles_providers_saml.html">About SAML 2.0-based
/// federation</a> in the <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateSAMLProvider {
    _private: (),
}
impl CreateSAMLProvider {
    /// Creates a new builder-style object to manufacture [`CreateSamlProviderInput`](crate::input::CreateSamlProviderInput)
    pub fn builder() -> crate::input::create_saml_provider_input::Builder {
        crate::input::create_saml_provider_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateSAMLProvider {
    type Output = std::result::Result<
        crate::output::CreateSamlProviderOutput,
        crate::error::CreateSAMLProviderError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_saml_provider_error(response)
        } else {
            crate::operation_deser::parse_create_saml_provider_response(response)
        }
    }
}

/// <p>Creates an IAM role that is linked to a specific Amazon Web Services service. The service controls
/// the attached policies and when the role can be deleted. This helps ensure that the
/// service is not broken by an unexpectedly changed or deleted role, which could put your
/// Amazon Web Services resources into an unknown state. Allowing the service to control the role helps
/// improve service stability and proper cleanup when a service and its role are no longer
/// needed. For more information, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/using-service-linked-roles.html">Using service-linked
/// roles</a> in the <i>IAM User Guide</i>. </p>
/// <p>To attach a policy to this service-linked role, you must make the request using the
/// Amazon Web Services service that depends on this role.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateServiceLinkedRole {
    _private: (),
}
impl CreateServiceLinkedRole {
    /// Creates a new builder-style object to manufacture [`CreateServiceLinkedRoleInput`](crate::input::CreateServiceLinkedRoleInput)
    pub fn builder() -> crate::input::create_service_linked_role_input::Builder {
        crate::input::create_service_linked_role_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateServiceLinkedRole {
    type Output = std::result::Result<
        crate::output::CreateServiceLinkedRoleOutput,
        crate::error::CreateServiceLinkedRoleError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_service_linked_role_error(response)
        } else {
            crate::operation_deser::parse_create_service_linked_role_response(response)
        }
    }
}

/// <p>Generates a set of credentials consisting of a user name and password that can be used
/// to access the service specified in the request. These credentials are generated by
/// IAM, and can be used only for the specified service. </p>
/// <p>You can have a maximum of two sets of service-specific credentials for each supported
/// service per user.</p>
/// <p>You can create service-specific credentials for CodeCommit and Amazon Keyspaces (for Apache
/// Cassandra).</p>
/// <p>You can reset the password to a new service-generated value by calling <a>ResetServiceSpecificCredential</a>.</p>
/// <p>For more information about service-specific credentials, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_credentials_ssh-keys.html">Using IAM
/// with CodeCommit: Git credentials, SSH keys, and Amazon Web Services access keys</a> in the
/// <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateServiceSpecificCredential {
    _private: (),
}
impl CreateServiceSpecificCredential {
    /// Creates a new builder-style object to manufacture [`CreateServiceSpecificCredentialInput`](crate::input::CreateServiceSpecificCredentialInput)
    pub fn builder() -> crate::input::create_service_specific_credential_input::Builder {
        crate::input::create_service_specific_credential_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateServiceSpecificCredential {
    type Output = std::result::Result<
        crate::output::CreateServiceSpecificCredentialOutput,
        crate::error::CreateServiceSpecificCredentialError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_service_specific_credential_error(response)
        } else {
            crate::operation_deser::parse_create_service_specific_credential_response(response)
        }
    }
}

/// <p>Creates a new IAM user for your Amazon Web Services account.</p>
/// <p> For information about quotas for the number of IAM users you can create, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/reference_iam-quotas.html">IAM and STS
/// quotas</a> in the <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateUser {
    _private: (),
}
impl CreateUser {
    /// Creates a new builder-style object to manufacture [`CreateUserInput`](crate::input::CreateUserInput)
    pub fn builder() -> crate::input::create_user_input::Builder {
        crate::input::create_user_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateUser {
    type Output =
        std::result::Result<crate::output::CreateUserOutput, crate::error::CreateUserError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_user_error(response)
        } else {
            crate::operation_deser::parse_create_user_response(response)
        }
    }
}

/// <p>Creates a new virtual MFA device for the Amazon Web Services account. After creating the virtual
/// MFA, use <a>EnableMFADevice</a> to attach the MFA device to an IAM user.
/// For more information about creating and working with virtual MFA devices, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/Using_VirtualMFA.html">Using a virtual MFA
/// device</a> in the <i>IAM User Guide</i>.</p>
/// <p>For information about the maximum number of MFA devices you can create, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/reference_iam-quotas.html">IAM and STS
/// quotas</a> in the <i>IAM User Guide</i>.</p>
/// <important>
/// <p>The seed information contained in the QR code and the Base32 string should be
/// treated like any other secret access information. In other words, protect the seed
/// information as you would your Amazon Web Services access keys or your passwords. After you
/// provision your virtual device, you should ensure that the information is destroyed
/// following secure procedures.</p>
/// </important>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateVirtualMFADevice {
    _private: (),
}
impl CreateVirtualMFADevice {
    /// Creates a new builder-style object to manufacture [`CreateVirtualMfaDeviceInput`](crate::input::CreateVirtualMfaDeviceInput)
    pub fn builder() -> crate::input::create_virtual_mfa_device_input::Builder {
        crate::input::create_virtual_mfa_device_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateVirtualMFADevice {
    type Output = std::result::Result<
        crate::output::CreateVirtualMfaDeviceOutput,
        crate::error::CreateVirtualMFADeviceError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_virtual_mfa_device_error(response)
        } else {
            crate::operation_deser::parse_create_virtual_mfa_device_response(response)
        }
    }
}

/// <p>Deactivates the specified MFA device and removes it from association with the user
/// name for which it was originally enabled.</p>
/// <p>For more information about creating and working with virtual MFA devices, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/Using_VirtualMFA.html">Enabling a virtual
/// multi-factor authentication (MFA) device</a> in the
/// <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeactivateMFADevice {
    _private: (),
}
impl DeactivateMFADevice {
    /// Creates a new builder-style object to manufacture [`DeactivateMfaDeviceInput`](crate::input::DeactivateMfaDeviceInput)
    pub fn builder() -> crate::input::deactivate_mfa_device_input::Builder {
        crate::input::deactivate_mfa_device_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeactivateMFADevice {
    type Output = std::result::Result<
        crate::output::DeactivateMfaDeviceOutput,
        crate::error::DeactivateMFADeviceError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_deactivate_mfa_device_error(response)
        } else {
            crate::operation_deser::parse_deactivate_mfa_device_response(response)
        }
    }
}

/// <p>Deletes the access key pair associated with the specified IAM user.</p>
/// <p>If you do not specify a user name, IAM determines the user name implicitly based on
/// the Amazon Web Services access key ID signing the request. This operation works for access keys under
/// the Amazon Web Services account. Consequently, you can use this operation to manage Amazon Web Services account root
/// user credentials even if the Amazon Web Services account has no associated users.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteAccessKey {
    _private: (),
}
impl DeleteAccessKey {
    /// Creates a new builder-style object to manufacture [`DeleteAccessKeyInput`](crate::input::DeleteAccessKeyInput)
    pub fn builder() -> crate::input::delete_access_key_input::Builder {
        crate::input::delete_access_key_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteAccessKey {
    type Output = std::result::Result<
        crate::output::DeleteAccessKeyOutput,
        crate::error::DeleteAccessKeyError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_access_key_error(response)
        } else {
            crate::operation_deser::parse_delete_access_key_response(response)
        }
    }
}

/// <p> Deletes the specified Amazon Web Services account alias. For information about using an Amazon Web Services
/// account alias, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/AccountAlias.html">Using an alias for your Amazon Web Services account ID</a> in the
/// <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteAccountAlias {
    _private: (),
}
impl DeleteAccountAlias {
    /// Creates a new builder-style object to manufacture [`DeleteAccountAliasInput`](crate::input::DeleteAccountAliasInput)
    pub fn builder() -> crate::input::delete_account_alias_input::Builder {
        crate::input::delete_account_alias_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteAccountAlias {
    type Output = std::result::Result<
        crate::output::DeleteAccountAliasOutput,
        crate::error::DeleteAccountAliasError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_account_alias_error(response)
        } else {
            crate::operation_deser::parse_delete_account_alias_response(response)
        }
    }
}

/// <p>Deletes the password policy for the Amazon Web Services account. There are no parameters.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteAccountPasswordPolicy {
    _private: (),
}
impl DeleteAccountPasswordPolicy {
    /// Creates a new builder-style object to manufacture [`DeleteAccountPasswordPolicyInput`](crate::input::DeleteAccountPasswordPolicyInput)
    pub fn builder() -> crate::input::delete_account_password_policy_input::Builder {
        crate::input::delete_account_password_policy_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteAccountPasswordPolicy {
    type Output = std::result::Result<
        crate::output::DeleteAccountPasswordPolicyOutput,
        crate::error::DeleteAccountPasswordPolicyError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_account_password_policy_error(response)
        } else {
            crate::operation_deser::parse_delete_account_password_policy_response(response)
        }
    }
}

/// <p>Deletes the specified IAM group. The group must not contain any users or have any
/// attached policies.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteGroup {
    _private: (),
}
impl DeleteGroup {
    /// Creates a new builder-style object to manufacture [`DeleteGroupInput`](crate::input::DeleteGroupInput)
    pub fn builder() -> crate::input::delete_group_input::Builder {
        crate::input::delete_group_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteGroup {
    type Output =
        std::result::Result<crate::output::DeleteGroupOutput, crate::error::DeleteGroupError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_group_error(response)
        } else {
            crate::operation_deser::parse_delete_group_response(response)
        }
    }
}

/// <p>Deletes the specified inline policy that is embedded in the specified IAM
/// group.</p>
/// <p>A group can also have managed policies attached to it. To detach a managed policy from
/// a group, use <a>DetachGroupPolicy</a>. For more information about policies,
/// refer to <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/policies-managed-vs-inline.html">Managed policies and inline
/// policies</a> in the <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteGroupPolicy {
    _private: (),
}
impl DeleteGroupPolicy {
    /// Creates a new builder-style object to manufacture [`DeleteGroupPolicyInput`](crate::input::DeleteGroupPolicyInput)
    pub fn builder() -> crate::input::delete_group_policy_input::Builder {
        crate::input::delete_group_policy_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteGroupPolicy {
    type Output = std::result::Result<
        crate::output::DeleteGroupPolicyOutput,
        crate::error::DeleteGroupPolicyError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_group_policy_error(response)
        } else {
            crate::operation_deser::parse_delete_group_policy_response(response)
        }
    }
}

/// <p>Deletes the specified instance profile. The instance profile must not have an
/// associated role.</p>
/// <important>
/// <p>Make sure that you do not have any Amazon EC2 instances running with the instance
/// profile you are about to delete. Deleting a role or instance profile that is
/// associated with a running instance will break any applications running on the
/// instance.</p>
/// </important>
/// <p>For more information about instance profiles, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/AboutInstanceProfiles.html">About instance
/// profiles</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteInstanceProfile {
    _private: (),
}
impl DeleteInstanceProfile {
    /// Creates a new builder-style object to manufacture [`DeleteInstanceProfileInput`](crate::input::DeleteInstanceProfileInput)
    pub fn builder() -> crate::input::delete_instance_profile_input::Builder {
        crate::input::delete_instance_profile_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteInstanceProfile {
    type Output = std::result::Result<
        crate::output::DeleteInstanceProfileOutput,
        crate::error::DeleteInstanceProfileError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_instance_profile_error(response)
        } else {
            crate::operation_deser::parse_delete_instance_profile_response(response)
        }
    }
}

/// <p>Deletes the password for the specified IAM user, which terminates the user's ability
/// to access Amazon Web Services services through the Amazon Web Services Management Console.</p>
/// <p>You can use the CLI, the Amazon Web Services API, or the <b>Users</b> page in the IAM console to delete a password for any IAM user.
/// You can use <a>ChangePassword</a> to update, but not delete, your own
/// password in the <b>My Security Credentials</b> page in the
/// Amazon Web Services Management Console.</p>
/// <important>
/// <p> Deleting a user's password does not prevent a user from accessing Amazon Web Services through
/// the command line interface or the API. To prevent all user access, you must also
/// either make any access keys inactive or delete them. For more information about
/// making keys inactive or deleting them, see <a>UpdateAccessKey</a> and
/// <a>DeleteAccessKey</a>. </p>
/// </important>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteLoginProfile {
    _private: (),
}
impl DeleteLoginProfile {
    /// Creates a new builder-style object to manufacture [`DeleteLoginProfileInput`](crate::input::DeleteLoginProfileInput)
    pub fn builder() -> crate::input::delete_login_profile_input::Builder {
        crate::input::delete_login_profile_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteLoginProfile {
    type Output = std::result::Result<
        crate::output::DeleteLoginProfileOutput,
        crate::error::DeleteLoginProfileError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_login_profile_error(response)
        } else {
            crate::operation_deser::parse_delete_login_profile_response(response)
        }
    }
}

/// <p>Deletes an OpenID Connect identity provider (IdP) resource object in IAM.</p>
/// <p>Deleting an IAM OIDC provider resource does not update any roles that reference the
/// provider as a principal in their trust policies. Any attempt to assume a role that
/// references a deleted provider fails.</p>
/// <p>This operation is idempotent; it does not fail or return an error if you call the
/// operation for a provider that does not exist.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteOpenIDConnectProvider {
    _private: (),
}
impl DeleteOpenIDConnectProvider {
    /// Creates a new builder-style object to manufacture [`DeleteOpenIdConnectProviderInput`](crate::input::DeleteOpenIdConnectProviderInput)
    pub fn builder() -> crate::input::delete_open_id_connect_provider_input::Builder {
        crate::input::delete_open_id_connect_provider_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteOpenIDConnectProvider {
    type Output = std::result::Result<
        crate::output::DeleteOpenIdConnectProviderOutput,
        crate::error::DeleteOpenIDConnectProviderError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_open_id_connect_provider_error(response)
        } else {
            crate::operation_deser::parse_delete_open_id_connect_provider_response(response)
        }
    }
}

/// <p>Deletes the specified managed policy.</p>
/// <p>Before you can delete a managed policy, you must first detach the policy from all
/// users, groups, and roles that it is attached to. In addition, you must delete all the
/// policy's versions. The following steps describe the process for deleting a managed
/// policy:</p>
/// <ul>
/// <li>
/// <p>Detach the policy from all users, groups, and roles that the policy is
/// attached to, using <a>DetachUserPolicy</a>, <a>DetachGroupPolicy</a>, or <a>DetachRolePolicy</a>. To
/// list all the users, groups, and roles that a policy is attached to, use <a>ListEntitiesForPolicy</a>.</p>
/// </li>
/// <li>
/// <p>Delete all versions of the policy using <a>DeletePolicyVersion</a>.
/// To list the policy's versions, use <a>ListPolicyVersions</a>. You
/// cannot use <a>DeletePolicyVersion</a> to delete the version that is
/// marked as the default version. You delete the policy's default version in the
/// next step of the process.</p>
/// </li>
/// <li>
/// <p>Delete the policy (this automatically deletes the policy's default version)
/// using this operation.</p>
/// </li>
/// </ul>
/// <p>For information about managed policies, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/policies-managed-vs-inline.html">Managed policies and inline
/// policies</a> in the <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeletePolicy {
    _private: (),
}
impl DeletePolicy {
    /// Creates a new builder-style object to manufacture [`DeletePolicyInput`](crate::input::DeletePolicyInput)
    pub fn builder() -> crate::input::delete_policy_input::Builder {
        crate::input::delete_policy_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeletePolicy {
    type Output =
        std::result::Result<crate::output::DeletePolicyOutput, crate::error::DeletePolicyError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_policy_error(response)
        } else {
            crate::operation_deser::parse_delete_policy_response(response)
        }
    }
}

/// <p>Deletes the specified version from the specified managed policy.</p>
/// <p>You cannot delete the default version from a policy using this operation. To delete
/// the default version from a policy, use <a>DeletePolicy</a>. To find out which
/// version of a policy is marked as the default version, use <a>ListPolicyVersions</a>.</p>
/// <p>For information about versions for managed policies, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/policies-managed-versions.html">Versioning for managed
/// policies</a> in the <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeletePolicyVersion {
    _private: (),
}
impl DeletePolicyVersion {
    /// Creates a new builder-style object to manufacture [`DeletePolicyVersionInput`](crate::input::DeletePolicyVersionInput)
    pub fn builder() -> crate::input::delete_policy_version_input::Builder {
        crate::input::delete_policy_version_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeletePolicyVersion {
    type Output = std::result::Result<
        crate::output::DeletePolicyVersionOutput,
        crate::error::DeletePolicyVersionError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_policy_version_error(response)
        } else {
            crate::operation_deser::parse_delete_policy_version_response(response)
        }
    }
}

/// <p>Deletes the specified role. The role must not have any policies attached. For more
/// information about roles, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/WorkingWithRoles.html">Working with roles</a>.</p>
/// <important>
/// <p>Make sure that you do not have any Amazon EC2 instances running with the role you
/// are about to delete. Deleting a role or instance profile that is associated with a
/// running instance will break any applications running on the instance.</p>
/// </important>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteRole {
    _private: (),
}
impl DeleteRole {
    /// Creates a new builder-style object to manufacture [`DeleteRoleInput`](crate::input::DeleteRoleInput)
    pub fn builder() -> crate::input::delete_role_input::Builder {
        crate::input::delete_role_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteRole {
    type Output =
        std::result::Result<crate::output::DeleteRoleOutput, crate::error::DeleteRoleError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_role_error(response)
        } else {
            crate::operation_deser::parse_delete_role_response(response)
        }
    }
}

/// <p>Deletes the permissions boundary for the specified IAM role. </p>
/// <important>
/// <p>Deleting the permissions boundary for a role might increase its permissions. For
/// example, it might allow anyone who assumes the role to perform all the actions
/// granted in its permissions policies. </p>
/// </important>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteRolePermissionsBoundary {
    _private: (),
}
impl DeleteRolePermissionsBoundary {
    /// Creates a new builder-style object to manufacture [`DeleteRolePermissionsBoundaryInput`](crate::input::DeleteRolePermissionsBoundaryInput)
    pub fn builder() -> crate::input::delete_role_permissions_boundary_input::Builder {
        crate::input::delete_role_permissions_boundary_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteRolePermissionsBoundary {
    type Output = std::result::Result<
        crate::output::DeleteRolePermissionsBoundaryOutput,
        crate::error::DeleteRolePermissionsBoundaryError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_role_permissions_boundary_error(response)
        } else {
            crate::operation_deser::parse_delete_role_permissions_boundary_response(response)
        }
    }
}

/// <p>Deletes the specified inline policy that is embedded in the specified IAM
/// role.</p>
/// <p>A role can also have managed policies attached to it. To detach a managed policy from
/// a role, use <a>DetachRolePolicy</a>. For more information about policies,
/// refer to <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/policies-managed-vs-inline.html">Managed policies and inline
/// policies</a> in the <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteRolePolicy {
    _private: (),
}
impl DeleteRolePolicy {
    /// Creates a new builder-style object to manufacture [`DeleteRolePolicyInput`](crate::input::DeleteRolePolicyInput)
    pub fn builder() -> crate::input::delete_role_policy_input::Builder {
        crate::input::delete_role_policy_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteRolePolicy {
    type Output = std::result::Result<
        crate::output::DeleteRolePolicyOutput,
        crate::error::DeleteRolePolicyError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_role_policy_error(response)
        } else {
            crate::operation_deser::parse_delete_role_policy_response(response)
        }
    }
}

/// <p>Deletes a SAML provider resource in IAM.</p>
/// <p>Deleting the provider resource from IAM does not update any roles that reference the
/// SAML provider resource's ARN as a principal in their trust policies. Any attempt to
/// assume a role that references a non-existent provider resource ARN fails.</p>
/// <note>
/// <p> This operation requires <a href="https://docs.aws.amazon.com/general/latest/gr/signature-version-4.html">Signature Version 4</a>.</p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteSAMLProvider {
    _private: (),
}
impl DeleteSAMLProvider {
    /// Creates a new builder-style object to manufacture [`DeleteSamlProviderInput`](crate::input::DeleteSamlProviderInput)
    pub fn builder() -> crate::input::delete_saml_provider_input::Builder {
        crate::input::delete_saml_provider_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteSAMLProvider {
    type Output = std::result::Result<
        crate::output::DeleteSamlProviderOutput,
        crate::error::DeleteSAMLProviderError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_saml_provider_error(response)
        } else {
            crate::operation_deser::parse_delete_saml_provider_response(response)
        }
    }
}

/// <p>Deletes the specified server certificate.</p>
/// <p>For more information about working with server certificates, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_credentials_server-certs.html">Working
/// with server certificates</a> in the <i>IAM User Guide</i>. This
/// topic also includes a list of Amazon Web Services services that can use the server certificates that
/// you manage with IAM.</p>
/// <important>
/// <p> If you are using a server certificate with Elastic Load Balancing, deleting the
/// certificate could have implications for your application. If Elastic Load Balancing
/// doesn't detect the deletion of bound certificates, it may continue to use the
/// certificates. This could cause Elastic Load Balancing to stop accepting traffic. We
/// recommend that you remove the reference to the certificate from Elastic Load
/// Balancing before using this command to delete the certificate. For more information,
/// see <a href="https://docs.aws.amazon.com/ElasticLoadBalancing/latest/APIReference/API_DeleteLoadBalancerListeners.html">DeleteLoadBalancerListeners</a> in the <i>Elastic Load Balancing API
/// Reference</i>.</p>
/// </important>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteServerCertificate {
    _private: (),
}
impl DeleteServerCertificate {
    /// Creates a new builder-style object to manufacture [`DeleteServerCertificateInput`](crate::input::DeleteServerCertificateInput)
    pub fn builder() -> crate::input::delete_server_certificate_input::Builder {
        crate::input::delete_server_certificate_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteServerCertificate {
    type Output = std::result::Result<
        crate::output::DeleteServerCertificateOutput,
        crate::error::DeleteServerCertificateError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_server_certificate_error(response)
        } else {
            crate::operation_deser::parse_delete_server_certificate_response(response)
        }
    }
}

/// <p>Submits a service-linked role deletion request and returns a
/// <code>DeletionTaskId</code>, which you can use to check the status of the deletion.
/// Before you call this operation, confirm that the role has no active sessions and that
/// any resources used by the role in the linked service are deleted. If you call this
/// operation more than once for the same service-linked role and an earlier deletion task
/// is not complete, then the <code>DeletionTaskId</code> of the earlier request is
/// returned.</p>
/// <p>If you submit a deletion request for a service-linked role whose linked service is
/// still accessing a resource, then the deletion task fails. If it fails, the <a>GetServiceLinkedRoleDeletionStatus</a> operation returns the reason for the
/// failure, usually including the resources that must be deleted. To delete the
/// service-linked role, you must first remove those resources from the linked service and
/// then submit the deletion request again. Resources are specific to the service that is
/// linked to the role. For more information about removing resources from a service, see
/// the <a href="http://docs.aws.amazon.com/">Amazon Web Services documentation</a> for your
/// service.</p>
/// <p>For more information about service-linked roles, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_roles_terms-and-concepts.html#iam-term-service-linked-role">Roles terms and concepts: Amazon Web Services service-linked role</a> in the
/// <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteServiceLinkedRole {
    _private: (),
}
impl DeleteServiceLinkedRole {
    /// Creates a new builder-style object to manufacture [`DeleteServiceLinkedRoleInput`](crate::input::DeleteServiceLinkedRoleInput)
    pub fn builder() -> crate::input::delete_service_linked_role_input::Builder {
        crate::input::delete_service_linked_role_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteServiceLinkedRole {
    type Output = std::result::Result<
        crate::output::DeleteServiceLinkedRoleOutput,
        crate::error::DeleteServiceLinkedRoleError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_service_linked_role_error(response)
        } else {
            crate::operation_deser::parse_delete_service_linked_role_response(response)
        }
    }
}

/// <p>Deletes the specified service-specific credential.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteServiceSpecificCredential {
    _private: (),
}
impl DeleteServiceSpecificCredential {
    /// Creates a new builder-style object to manufacture [`DeleteServiceSpecificCredentialInput`](crate::input::DeleteServiceSpecificCredentialInput)
    pub fn builder() -> crate::input::delete_service_specific_credential_input::Builder {
        crate::input::delete_service_specific_credential_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteServiceSpecificCredential {
    type Output = std::result::Result<
        crate::output::DeleteServiceSpecificCredentialOutput,
        crate::error::DeleteServiceSpecificCredentialError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_service_specific_credential_error(response)
        } else {
            crate::operation_deser::parse_delete_service_specific_credential_response(response)
        }
    }
}

/// <p>Deletes a signing certificate associated with the specified IAM user.</p>
/// <p>If you do not specify a user name, IAM determines the user name implicitly based on
/// the Amazon Web Services access key ID signing the request. This operation works for access keys under
/// the Amazon Web Services account. Consequently, you can use this operation to manage Amazon Web Services account root
/// user credentials even if the Amazon Web Services account has no associated IAM users.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteSigningCertificate {
    _private: (),
}
impl DeleteSigningCertificate {
    /// Creates a new builder-style object to manufacture [`DeleteSigningCertificateInput`](crate::input::DeleteSigningCertificateInput)
    pub fn builder() -> crate::input::delete_signing_certificate_input::Builder {
        crate::input::delete_signing_certificate_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteSigningCertificate {
    type Output = std::result::Result<
        crate::output::DeleteSigningCertificateOutput,
        crate::error::DeleteSigningCertificateError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_signing_certificate_error(response)
        } else {
            crate::operation_deser::parse_delete_signing_certificate_response(response)
        }
    }
}

/// <p>Deletes the specified SSH public key.</p>
/// <p>The SSH public key deleted by this operation is used only for authenticating the
/// associated IAM user to an CodeCommit repository. For more information about using SSH keys
/// to authenticate to an CodeCommit repository, see <a href="https://docs.aws.amazon.com/codecommit/latest/userguide/setting-up-credentials-ssh.html">Set up CodeCommit for
/// SSH connections</a> in the <i>CodeCommit User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteSSHPublicKey {
    _private: (),
}
impl DeleteSSHPublicKey {
    /// Creates a new builder-style object to manufacture [`DeleteSshPublicKeyInput`](crate::input::DeleteSshPublicKeyInput)
    pub fn builder() -> crate::input::delete_ssh_public_key_input::Builder {
        crate::input::delete_ssh_public_key_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteSSHPublicKey {
    type Output = std::result::Result<
        crate::output::DeleteSshPublicKeyOutput,
        crate::error::DeleteSSHPublicKeyError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_ssh_public_key_error(response)
        } else {
            crate::operation_deser::parse_delete_ssh_public_key_response(response)
        }
    }
}

/// <p>Deletes the specified IAM user. Unlike the Amazon Web Services Management Console, when you delete a user
/// programmatically, you must delete the items attached to the user manually, or the
/// deletion fails. For more information, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_users_manage.html#id_users_deleting_cli">Deleting an IAM
/// user</a>. Before attempting to delete a user, remove the following items:</p>
/// <ul>
/// <li>
/// <p>Password (<a>DeleteLoginProfile</a>)</p>
/// </li>
/// <li>
/// <p>Access keys (<a>DeleteAccessKey</a>)</p>
/// </li>
/// <li>
/// <p>Signing certificate (<a>DeleteSigningCertificate</a>)</p>
/// </li>
/// <li>
/// <p>SSH public key (<a>DeleteSSHPublicKey</a>)</p>
/// </li>
/// <li>
/// <p>Git credentials (<a>DeleteServiceSpecificCredential</a>)</p>
/// </li>
/// <li>
/// <p>Multi-factor authentication (MFA) device (<a>DeactivateMFADevice</a>, <a>DeleteVirtualMFADevice</a>)</p>
/// </li>
/// <li>
/// <p>Inline policies (<a>DeleteUserPolicy</a>)</p>
/// </li>
/// <li>
/// <p>Attached managed policies (<a>DetachUserPolicy</a>)</p>
/// </li>
/// <li>
/// <p>Group memberships (<a>RemoveUserFromGroup</a>)</p>
/// </li>
/// </ul>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteUser {
    _private: (),
}
impl DeleteUser {
    /// Creates a new builder-style object to manufacture [`DeleteUserInput`](crate::input::DeleteUserInput)
    pub fn builder() -> crate::input::delete_user_input::Builder {
        crate::input::delete_user_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteUser {
    type Output =
        std::result::Result<crate::output::DeleteUserOutput, crate::error::DeleteUserError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_user_error(response)
        } else {
            crate::operation_deser::parse_delete_user_response(response)
        }
    }
}

/// <p>Deletes the permissions boundary for the specified IAM user.</p>
/// <important>
/// <p>Deleting the permissions boundary for a user might increase its permissions by
/// allowing the user to perform all the actions granted in its permissions policies.
/// </p>
/// </important>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteUserPermissionsBoundary {
    _private: (),
}
impl DeleteUserPermissionsBoundary {
    /// Creates a new builder-style object to manufacture [`DeleteUserPermissionsBoundaryInput`](crate::input::DeleteUserPermissionsBoundaryInput)
    pub fn builder() -> crate::input::delete_user_permissions_boundary_input::Builder {
        crate::input::delete_user_permissions_boundary_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteUserPermissionsBoundary {
    type Output = std::result::Result<
        crate::output::DeleteUserPermissionsBoundaryOutput,
        crate::error::DeleteUserPermissionsBoundaryError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_user_permissions_boundary_error(response)
        } else {
            crate::operation_deser::parse_delete_user_permissions_boundary_response(response)
        }
    }
}

/// <p>Deletes the specified inline policy that is embedded in the specified IAM
/// user.</p>
/// <p>A user can also have managed policies attached to it. To detach a managed policy from
/// a user, use <a>DetachUserPolicy</a>. For more information about policies,
/// refer to <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/policies-managed-vs-inline.html">Managed policies and inline
/// policies</a> in the <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteUserPolicy {
    _private: (),
}
impl DeleteUserPolicy {
    /// Creates a new builder-style object to manufacture [`DeleteUserPolicyInput`](crate::input::DeleteUserPolicyInput)
    pub fn builder() -> crate::input::delete_user_policy_input::Builder {
        crate::input::delete_user_policy_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteUserPolicy {
    type Output = std::result::Result<
        crate::output::DeleteUserPolicyOutput,
        crate::error::DeleteUserPolicyError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_user_policy_error(response)
        } else {
            crate::operation_deser::parse_delete_user_policy_response(response)
        }
    }
}

/// <p>Deletes a virtual MFA device.</p>
/// <note>
/// <p> You must deactivate a user's virtual MFA device before you can delete it. For
/// information about deactivating MFA devices, see <a>DeactivateMFADevice</a>. </p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteVirtualMFADevice {
    _private: (),
}
impl DeleteVirtualMFADevice {
    /// Creates a new builder-style object to manufacture [`DeleteVirtualMfaDeviceInput`](crate::input::DeleteVirtualMfaDeviceInput)
    pub fn builder() -> crate::input::delete_virtual_mfa_device_input::Builder {
        crate::input::delete_virtual_mfa_device_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteVirtualMFADevice {
    type Output = std::result::Result<
        crate::output::DeleteVirtualMfaDeviceOutput,
        crate::error::DeleteVirtualMFADeviceError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_virtual_mfa_device_error(response)
        } else {
            crate::operation_deser::parse_delete_virtual_mfa_device_response(response)
        }
    }
}

/// <p>Removes the specified managed policy from the specified IAM group.</p>
/// <p>A group can also have inline policies embedded with it. To delete an inline policy,
/// use <a>DeleteGroupPolicy</a>. For information about policies, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/policies-managed-vs-inline.html">Managed
/// policies and inline policies</a> in the
/// <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DetachGroupPolicy {
    _private: (),
}
impl DetachGroupPolicy {
    /// Creates a new builder-style object to manufacture [`DetachGroupPolicyInput`](crate::input::DetachGroupPolicyInput)
    pub fn builder() -> crate::input::detach_group_policy_input::Builder {
        crate::input::detach_group_policy_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DetachGroupPolicy {
    type Output = std::result::Result<
        crate::output::DetachGroupPolicyOutput,
        crate::error::DetachGroupPolicyError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_detach_group_policy_error(response)
        } else {
            crate::operation_deser::parse_detach_group_policy_response(response)
        }
    }
}

/// <p>Removes the specified managed policy from the specified role.</p>
/// <p>A role can also have inline policies embedded with it. To delete an inline policy, use
/// <a>DeleteRolePolicy</a>. For information about policies, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/policies-managed-vs-inline.html">Managed
/// policies and inline policies</a> in the
/// <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DetachRolePolicy {
    _private: (),
}
impl DetachRolePolicy {
    /// Creates a new builder-style object to manufacture [`DetachRolePolicyInput`](crate::input::DetachRolePolicyInput)
    pub fn builder() -> crate::input::detach_role_policy_input::Builder {
        crate::input::detach_role_policy_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DetachRolePolicy {
    type Output = std::result::Result<
        crate::output::DetachRolePolicyOutput,
        crate::error::DetachRolePolicyError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_detach_role_policy_error(response)
        } else {
            crate::operation_deser::parse_detach_role_policy_response(response)
        }
    }
}

/// <p>Removes the specified managed policy from the specified user.</p>
/// <p>A user can also have inline policies embedded with it. To delete an inline policy, use
/// <a>DeleteUserPolicy</a>. For information about policies, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/policies-managed-vs-inline.html">Managed
/// policies and inline policies</a> in the
/// <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DetachUserPolicy {
    _private: (),
}
impl DetachUserPolicy {
    /// Creates a new builder-style object to manufacture [`DetachUserPolicyInput`](crate::input::DetachUserPolicyInput)
    pub fn builder() -> crate::input::detach_user_policy_input::Builder {
        crate::input::detach_user_policy_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DetachUserPolicy {
    type Output = std::result::Result<
        crate::output::DetachUserPolicyOutput,
        crate::error::DetachUserPolicyError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_detach_user_policy_error(response)
        } else {
            crate::operation_deser::parse_detach_user_policy_response(response)
        }
    }
}

/// <p>Enables the specified MFA device and associates it with the specified IAM user. When
/// enabled, the MFA device is required for every subsequent login by the IAM user
/// associated with the device.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct EnableMFADevice {
    _private: (),
}
impl EnableMFADevice {
    /// Creates a new builder-style object to manufacture [`EnableMfaDeviceInput`](crate::input::EnableMfaDeviceInput)
    pub fn builder() -> crate::input::enable_mfa_device_input::Builder {
        crate::input::enable_mfa_device_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for EnableMFADevice {
    type Output = std::result::Result<
        crate::output::EnableMfaDeviceOutput,
        crate::error::EnableMFADeviceError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_enable_mfa_device_error(response)
        } else {
            crate::operation_deser::parse_enable_mfa_device_response(response)
        }
    }
}

/// <p> Generates a credential report for the Amazon Web Services account. For more information about the
/// credential report, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/credential-reports.html">Getting credential reports</a> in
/// the <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GenerateCredentialReport {
    _private: (),
}
impl GenerateCredentialReport {
    /// Creates a new builder-style object to manufacture [`GenerateCredentialReportInput`](crate::input::GenerateCredentialReportInput)
    pub fn builder() -> crate::input::generate_credential_report_input::Builder {
        crate::input::generate_credential_report_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GenerateCredentialReport {
    type Output = std::result::Result<
        crate::output::GenerateCredentialReportOutput,
        crate::error::GenerateCredentialReportError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_generate_credential_report_error(response)
        } else {
            crate::operation_deser::parse_generate_credential_report_response(response)
        }
    }
}

/// <p>Generates a report for service last accessed data for Organizations. You can generate a
/// report for any entities (organization root, organizational unit, or account) or policies
/// in your organization.</p>
/// <p>To call this operation, you must be signed in using your Organizations management account
/// credentials. You can use your long-term IAM user or root user credentials, or
/// temporary credentials from assuming an IAM role. SCPs must be enabled for your
/// organization root. You must have the required IAM and Organizations permissions. For more
/// information, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/access_policies_access-advisor.html">Refining permissions using
/// service last accessed data</a> in the
/// <i>IAM User Guide</i>.</p>
/// <p>You can generate a service last accessed data report for entities by specifying only
/// the entity's path. This data includes a list of services that are allowed by any service
/// control policies (SCPs) that apply to the entity.</p>
/// <p>You can generate a service last accessed data report for a policy by specifying an
/// entity's path and an optional Organizations policy ID. This data includes a list of services that
/// are allowed by the specified SCP.</p>
/// <p>For each service in both report types, the data includes the most recent account
/// activity that the policy allows to account principals in the entity or the entity's
/// children. For important information about the data, reporting period, permissions
/// required, troubleshooting, and supported Regions see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/access_policies_access-advisor.html">Reducing permissions using
/// service last accessed data</a> in the
/// <i>IAM User Guide</i>.</p>
/// <important>
/// <p>The data includes all attempts to access Amazon Web Services, not just the successful ones. This
/// includes all attempts that were made using the Amazon Web Services Management Console, the Amazon Web Services API through any
/// of the SDKs, or any of the command line tools. An unexpected entry in the service
/// last accessed data does not mean that an account has been compromised, because the
/// request might have been denied. Refer to your CloudTrail logs as the authoritative
/// source for information about all API calls and whether they were successful or
/// denied access. For more information, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/cloudtrail-integration.html">Logging IAM events with
/// CloudTrail</a> in the <i>IAM User Guide</i>.</p>
/// </important>
/// <p>This operation returns a <code>JobId</code>. Use this parameter in the <code>
/// <a>GetOrganizationsAccessReport</a>
/// </code> operation to check the status of
/// the report generation. To check the status of this request, use the <code>JobId</code>
/// parameter in the <code>
/// <a>GetOrganizationsAccessReport</a>
/// </code> operation
/// and test the <code>JobStatus</code> response parameter. When the job is complete, you
/// can retrieve the report.</p>
/// <p>To generate a service last accessed data report for entities, specify an entity path
/// without specifying the optional Organizations policy ID. The type of entity that you specify
/// determines the data returned in the report.</p>
/// <ul>
/// <li>
/// <p>
/// <b>Root</b> – When you specify the
/// organizations root as the entity, the resulting report lists all of the services
/// allowed by SCPs that are attached to your root. For each service, the report
/// includes data for all accounts in your organization except the
/// management account, because the management account is not limited by SCPs.</p>
/// </li>
/// <li>
/// <p>
/// <b>OU</b> – When you specify an
/// organizational unit (OU) as the entity, the resulting report lists all of the
/// services allowed by SCPs that are attached to the OU and its parents. For each
/// service, the report includes data for all accounts in the OU or its children.
/// This data excludes the management account, because the management account is not
/// limited by SCPs.</p>
/// </li>
/// <li>
/// <p>
/// <b>management account</b> – When you specify the
/// management account, the resulting report lists all Amazon Web Services services, because the
/// management account is not limited by SCPs. For each service, the report includes
/// data for only the management account.</p>
/// </li>
/// <li>
/// <p>
/// <b>Account</b> – When you specify another
/// account as the entity, the resulting report lists all of the services allowed by
/// SCPs that are attached to the account and its parents. For each service, the
/// report includes data for only the specified account.</p>
/// </li>
/// </ul>
/// <p>To generate a service last accessed data report for policies, specify an entity path
/// and the optional Organizations policy ID. The type of entity that you specify determines the data
/// returned for each service.</p>
/// <ul>
/// <li>
/// <p>
/// <b>Root</b> – When you specify the root
/// entity and a policy ID, the resulting report lists all of the services that are
/// allowed by the specified SCP. For each service, the report includes data for all
/// accounts in your organization to which the SCP applies. This data excludes the
/// management account, because the management account is not limited by SCPs. If the
/// SCP is not attached to any entities in the organization, then the report will
/// return a list of services with no data.</p>
/// </li>
/// <li>
/// <p>
/// <b>OU</b> – When you specify an OU entity and
/// a policy ID, the resulting report lists all of the services that are allowed by
/// the specified SCP. For each service, the report includes data for all accounts
/// in the OU or its children to which the SCP applies. This means that other
/// accounts outside the OU that are affected by the SCP might not be included in
/// the data. This data excludes the management account, because the
/// management account is not limited by SCPs. If the SCP is not attached to the OU
/// or one of its children, the report will return a list of services with no
/// data.</p>
/// </li>
/// <li>
/// <p>
/// <b>management account</b> – When you specify the
/// management account, the resulting report lists all Amazon Web Services services, because the
/// management account is not limited by SCPs. If you specify a policy ID in the CLI
/// or API, the policy is ignored. For each service, the report includes data for
/// only the management account.</p>
/// </li>
/// <li>
/// <p>
/// <b>Account</b> – When you specify another
/// account entity and a policy ID, the resulting report lists all of the services
/// that are allowed by the specified SCP. For each service, the report includes
/// data for only the specified account. This means that other accounts in the
/// organization that are affected by the SCP might not be included in the data. If
/// the SCP is not attached to the account, the report will return a list of
/// services with no data.</p>
/// </li>
/// </ul>
/// <note>
/// <p>Service last accessed data does not use other policy types when determining
/// whether a principal could access a service. These other policy types include
/// identity-based policies, resource-based policies, access control lists, IAM
/// permissions boundaries, and STS assume role policies. It only applies SCP logic.
/// For more about the evaluation of policy types, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/reference_policies_evaluation-logic.html#policy-eval-basics">Evaluating policies</a> in the
/// <i>IAM User Guide</i>.</p>
/// </note>
/// <p>For more information about service last accessed data, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/access_policies_access-advisor.html">Reducing policy scope by
/// viewing user activity</a> in the <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GenerateOrganizationsAccessReport {
    _private: (),
}
impl GenerateOrganizationsAccessReport {
    /// Creates a new builder-style object to manufacture [`GenerateOrganizationsAccessReportInput`](crate::input::GenerateOrganizationsAccessReportInput)
    pub fn builder() -> crate::input::generate_organizations_access_report_input::Builder {
        crate::input::generate_organizations_access_report_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GenerateOrganizationsAccessReport {
    type Output = std::result::Result<
        crate::output::GenerateOrganizationsAccessReportOutput,
        crate::error::GenerateOrganizationsAccessReportError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_generate_organizations_access_report_error(response)
        } else {
            crate::operation_deser::parse_generate_organizations_access_report_response(response)
        }
    }
}

/// <p>Generates a report that includes details about when an IAM resource (user, group,
/// role, or policy) was last used in an attempt to access Amazon Web Services services. Recent activity
/// usually appears within four hours. IAM reports activity for the last 365 days, or less
/// if your Region began supporting this feature within the last year. For more information,
/// see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/access_policies_access-advisor.html#access-advisor_tracking-period">Regions where data is tracked</a>.</p>
/// <important>
/// <p>The service last accessed data includes all attempts to access an Amazon Web Services API, not
/// just the successful ones. This includes all attempts that were made using the
/// Amazon Web Services Management Console, the Amazon Web Services API through any of the SDKs, or any of the command line tools.
/// An unexpected entry in the service last accessed data does not mean that your
/// account has been compromised, because the request might have been denied. Refer to
/// your CloudTrail logs as the authoritative source for information about all API calls
/// and whether they were successful or denied access. For more information, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/cloudtrail-integration.html">Logging
/// IAM events with CloudTrail</a> in the
/// <i>IAM User Guide</i>.</p>
/// </important>
/// <p>The <code>GenerateServiceLastAccessedDetails</code> operation returns a
/// <code>JobId</code>. Use this parameter in the following operations to retrieve the
/// following details from your report: </p>
/// <ul>
/// <li>
/// <p>
/// <a>GetServiceLastAccessedDetails</a> – Use this operation
/// for users, groups, roles, or policies to list every Amazon Web Services service that the
/// resource could access using permissions policies. For each service, the response
/// includes information about the most recent access attempt.</p>
/// <p>The <code>JobId</code> returned by
/// <code>GenerateServiceLastAccessedDetail</code> must be used by the same role
/// within a session, or by the same user when used to call
/// <code>GetServiceLastAccessedDetail</code>.</p>
/// </li>
/// <li>
/// <p>
/// <a>GetServiceLastAccessedDetailsWithEntities</a> – Use this
/// operation for groups and policies to list information about the associated
/// entities (users or roles) that attempted to access a specific Amazon Web Services service.
/// </p>
/// </li>
/// </ul>
/// <p>To check the status of the <code>GenerateServiceLastAccessedDetails</code> request,
/// use the <code>JobId</code> parameter in the same operations and test the
/// <code>JobStatus</code> response parameter.</p>
/// <p>For additional information about the permissions policies that allow an identity
/// (user, group, or role) to access specific services, use the <a>ListPoliciesGrantingServiceAccess</a> operation.</p>
/// <note>
/// <p>Service last accessed data does not use other policy types when determining
/// whether a resource could access a service. These other policy types include
/// resource-based policies, access control lists, Organizations policies, IAM
/// permissions boundaries, and STS assume role policies. It only applies
/// permissions policy logic. For more about the evaluation of policy types, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/reference_policies_evaluation-logic.html#policy-eval-basics">Evaluating policies</a> in the
/// <i>IAM User Guide</i>.</p>
/// </note>
/// <p>For more information about service and action last accessed data, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/access_policies_access-advisor.html">Reducing permissions using service last accessed data</a> in the
/// <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GenerateServiceLastAccessedDetails {
    _private: (),
}
impl GenerateServiceLastAccessedDetails {
    /// Creates a new builder-style object to manufacture [`GenerateServiceLastAccessedDetailsInput`](crate::input::GenerateServiceLastAccessedDetailsInput)
    pub fn builder() -> crate::input::generate_service_last_accessed_details_input::Builder {
        crate::input::generate_service_last_accessed_details_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GenerateServiceLastAccessedDetails {
    type Output = std::result::Result<
        crate::output::GenerateServiceLastAccessedDetailsOutput,
        crate::error::GenerateServiceLastAccessedDetailsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_generate_service_last_accessed_details_error(response)
        } else {
            crate::operation_deser::parse_generate_service_last_accessed_details_response(response)
        }
    }
}

/// <p>Retrieves information about when the specified access key was last used. The
/// information includes the date and time of last use, along with the Amazon Web Services service and
/// Region that were specified in the last request made with that key.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetAccessKeyLastUsed {
    _private: (),
}
impl GetAccessKeyLastUsed {
    /// Creates a new builder-style object to manufacture [`GetAccessKeyLastUsedInput`](crate::input::GetAccessKeyLastUsedInput)
    pub fn builder() -> crate::input::get_access_key_last_used_input::Builder {
        crate::input::get_access_key_last_used_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetAccessKeyLastUsed {
    type Output = std::result::Result<
        crate::output::GetAccessKeyLastUsedOutput,
        crate::error::GetAccessKeyLastUsedError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_access_key_last_used_error(response)
        } else {
            crate::operation_deser::parse_get_access_key_last_used_response(response)
        }
    }
}

/// <p>Retrieves information about all IAM users, groups, roles, and policies in your Amazon Web Services
/// account, including their relationships to one another. Use this operation to obtain a
/// snapshot of the configuration of IAM permissions (users, groups, roles, and policies)
/// in your account.</p>
/// <note>
/// <p>Policies returned by this operation are URL-encoded compliant
/// with <a href="https://tools.ietf.org/html/rfc3986">RFC 3986</a>. You can use a URL
/// decoding method to convert the policy back to plain JSON text. For example, if you use Java, you
/// can use the <code>decode</code> method of the <code>java.net.URLDecoder</code> utility class in
/// the Java SDK. Other languages and SDKs provide similar functionality.</p>
/// </note>
/// <p>You can optionally filter the results using the <code>Filter</code> parameter. You can
/// paginate the results using the <code>MaxItems</code> and <code>Marker</code>
/// parameters.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetAccountAuthorizationDetails {
    _private: (),
}
impl GetAccountAuthorizationDetails {
    /// Creates a new builder-style object to manufacture [`GetAccountAuthorizationDetailsInput`](crate::input::GetAccountAuthorizationDetailsInput)
    pub fn builder() -> crate::input::get_account_authorization_details_input::Builder {
        crate::input::get_account_authorization_details_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetAccountAuthorizationDetails {
    type Output = std::result::Result<
        crate::output::GetAccountAuthorizationDetailsOutput,
        crate::error::GetAccountAuthorizationDetailsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_account_authorization_details_error(response)
        } else {
            crate::operation_deser::parse_get_account_authorization_details_response(response)
        }
    }
}

/// <p>Retrieves the password policy for the Amazon Web Services account. This tells you the complexity
/// requirements and mandatory rotation periods for the IAM user passwords in your account.
/// For more information about using a password policy, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/Using_ManagingPasswordPolicies.html">Managing an IAM password
/// policy</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetAccountPasswordPolicy {
    _private: (),
}
impl GetAccountPasswordPolicy {
    /// Creates a new builder-style object to manufacture [`GetAccountPasswordPolicyInput`](crate::input::GetAccountPasswordPolicyInput)
    pub fn builder() -> crate::input::get_account_password_policy_input::Builder {
        crate::input::get_account_password_policy_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetAccountPasswordPolicy {
    type Output = std::result::Result<
        crate::output::GetAccountPasswordPolicyOutput,
        crate::error::GetAccountPasswordPolicyError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_account_password_policy_error(response)
        } else {
            crate::operation_deser::parse_get_account_password_policy_response(response)
        }
    }
}

/// <p>Retrieves information about IAM entity usage and IAM quotas in the Amazon Web Services
/// account.</p>
/// <p> For information about IAM quotas, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/reference_iam-quotas.html">IAM and STS quotas</a> in the
/// <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetAccountSummary {
    _private: (),
}
impl GetAccountSummary {
    /// Creates a new builder-style object to manufacture [`GetAccountSummaryInput`](crate::input::GetAccountSummaryInput)
    pub fn builder() -> crate::input::get_account_summary_input::Builder {
        crate::input::get_account_summary_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetAccountSummary {
    type Output = std::result::Result<
        crate::output::GetAccountSummaryOutput,
        crate::error::GetAccountSummaryError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_account_summary_error(response)
        } else {
            crate::operation_deser::parse_get_account_summary_response(response)
        }
    }
}

/// <p>Gets a list of all of the context keys referenced in the input policies. The policies
/// are supplied as a list of one or more strings. To get the context keys from policies
/// associated with an IAM user, group, or role, use <a>GetContextKeysForPrincipalPolicy</a>.</p>
/// <p>Context keys are variables maintained by Amazon Web Services and its services that provide details
/// about the context of an API query request. Context keys can be evaluated by testing
/// against a value specified in an IAM policy. Use
/// <code>GetContextKeysForCustomPolicy</code> to understand what key names and values
/// you must supply when you call <a>SimulateCustomPolicy</a>. Note that all
/// parameters are shown in unencoded form here for clarity but must be URL encoded to be
/// included as a part of a real HTML request.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetContextKeysForCustomPolicy {
    _private: (),
}
impl GetContextKeysForCustomPolicy {
    /// Creates a new builder-style object to manufacture [`GetContextKeysForCustomPolicyInput`](crate::input::GetContextKeysForCustomPolicyInput)
    pub fn builder() -> crate::input::get_context_keys_for_custom_policy_input::Builder {
        crate::input::get_context_keys_for_custom_policy_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetContextKeysForCustomPolicy {
    type Output = std::result::Result<
        crate::output::GetContextKeysForCustomPolicyOutput,
        crate::error::GetContextKeysForCustomPolicyError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_context_keys_for_custom_policy_error(response)
        } else {
            crate::operation_deser::parse_get_context_keys_for_custom_policy_response(response)
        }
    }
}

/// <p>Gets a list of all of the context keys referenced in all the IAM policies that are
/// attached to the specified IAM entity. The entity can be an IAM user, group, or role.
/// If you specify a user, then the request also includes all of the policies attached to
/// groups that the user is a member of.</p>
/// <p>You can optionally include a list of one or more additional policies, specified as
/// strings. If you want to include <i>only</i> a list of policies by string,
/// use <a>GetContextKeysForCustomPolicy</a> instead.</p>
/// <p>
/// <b>Note:</b> This operation discloses information about the
/// permissions granted to other users. If you do not want users to see other user's
/// permissions, then consider allowing them to use <a>GetContextKeysForCustomPolicy</a> instead.</p>
/// <p>Context keys are variables maintained by Amazon Web Services and its services that provide details
/// about the context of an API query request. Context keys can be evaluated by testing
/// against a value in an IAM policy. Use <a>GetContextKeysForPrincipalPolicy</a> to understand what key names and values you must supply when you call <a>SimulatePrincipalPolicy</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetContextKeysForPrincipalPolicy {
    _private: (),
}
impl GetContextKeysForPrincipalPolicy {
    /// Creates a new builder-style object to manufacture [`GetContextKeysForPrincipalPolicyInput`](crate::input::GetContextKeysForPrincipalPolicyInput)
    pub fn builder() -> crate::input::get_context_keys_for_principal_policy_input::Builder {
        crate::input::get_context_keys_for_principal_policy_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetContextKeysForPrincipalPolicy {
    type Output = std::result::Result<
        crate::output::GetContextKeysForPrincipalPolicyOutput,
        crate::error::GetContextKeysForPrincipalPolicyError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_context_keys_for_principal_policy_error(response)
        } else {
            crate::operation_deser::parse_get_context_keys_for_principal_policy_response(response)
        }
    }
}

/// <p> Retrieves a credential report for the Amazon Web Services account. For more information about the
/// credential report, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/credential-reports.html">Getting credential reports</a> in
/// the <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetCredentialReport {
    _private: (),
}
impl GetCredentialReport {
    /// Creates a new builder-style object to manufacture [`GetCredentialReportInput`](crate::input::GetCredentialReportInput)
    pub fn builder() -> crate::input::get_credential_report_input::Builder {
        crate::input::get_credential_report_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetCredentialReport {
    type Output = std::result::Result<
        crate::output::GetCredentialReportOutput,
        crate::error::GetCredentialReportError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_credential_report_error(response)
        } else {
            crate::operation_deser::parse_get_credential_report_response(response)
        }
    }
}

/// <p> Returns a list of IAM users that are in the specified IAM group. You can paginate
/// the results using the <code>MaxItems</code> and <code>Marker</code> parameters.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetGroup {
    _private: (),
}
impl GetGroup {
    /// Creates a new builder-style object to manufacture [`GetGroupInput`](crate::input::GetGroupInput)
    pub fn builder() -> crate::input::get_group_input::Builder {
        crate::input::get_group_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetGroup {
    type Output = std::result::Result<crate::output::GetGroupOutput, crate::error::GetGroupError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_group_error(response)
        } else {
            crate::operation_deser::parse_get_group_response(response)
        }
    }
}

/// <p>Retrieves the specified inline policy document that is embedded in the specified IAM
/// group.</p>
/// <note>
/// <p>Policies returned by this operation are URL-encoded compliant
/// with <a href="https://tools.ietf.org/html/rfc3986">RFC 3986</a>. You can use a URL
/// decoding method to convert the policy back to plain JSON text. For example, if you use Java, you
/// can use the <code>decode</code> method of the <code>java.net.URLDecoder</code> utility class in
/// the Java SDK. Other languages and SDKs provide similar functionality.</p>
/// </note>
/// <p>An IAM group can also have managed policies attached to it. To retrieve a managed
/// policy document that is attached to a group, use <a>GetPolicy</a> to
/// determine the policy's default version, then use <a>GetPolicyVersion</a> to
/// retrieve the policy document.</p>
/// <p>For more information about policies, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/policies-managed-vs-inline.html">Managed policies and inline
/// policies</a> in the <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetGroupPolicy {
    _private: (),
}
impl GetGroupPolicy {
    /// Creates a new builder-style object to manufacture [`GetGroupPolicyInput`](crate::input::GetGroupPolicyInput)
    pub fn builder() -> crate::input::get_group_policy_input::Builder {
        crate::input::get_group_policy_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetGroupPolicy {
    type Output =
        std::result::Result<crate::output::GetGroupPolicyOutput, crate::error::GetGroupPolicyError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_group_policy_error(response)
        } else {
            crate::operation_deser::parse_get_group_policy_response(response)
        }
    }
}

/// <p> Retrieves information about the specified instance profile, including the instance
/// profile's path, GUID, ARN, and role. For more information about instance profiles, see
/// <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/AboutInstanceProfiles.html">About
/// instance profiles</a> in the <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetInstanceProfile {
    _private: (),
}
impl GetInstanceProfile {
    /// Creates a new builder-style object to manufacture [`GetInstanceProfileInput`](crate::input::GetInstanceProfileInput)
    pub fn builder() -> crate::input::get_instance_profile_input::Builder {
        crate::input::get_instance_profile_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetInstanceProfile {
    type Output = std::result::Result<
        crate::output::GetInstanceProfileOutput,
        crate::error::GetInstanceProfileError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_instance_profile_error(response)
        } else {
            crate::operation_deser::parse_get_instance_profile_response(response)
        }
    }
}

/// <p>Retrieves the user name for the specified IAM user. A login profile is created when
/// you create a password for the user to access the Amazon Web Services Management Console. If the user does not exist
/// or does not have a password, the operation returns a 404 (<code>NoSuchEntity</code>)
/// error.</p>
/// <p>If you create an IAM user with access to the console, the <code>CreateDate</code>
/// reflects the date you created the initial password for the user.</p>
/// <p>If you create an IAM user with programmatic access, and then later add a password
/// for the user to access the Amazon Web Services Management Console, the <code>CreateDate</code> reflects the initial
/// password creation date. A user with programmatic access does not have a login profile
/// unless you create a password for the user to access the Amazon Web Services Management Console.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetLoginProfile {
    _private: (),
}
impl GetLoginProfile {
    /// Creates a new builder-style object to manufacture [`GetLoginProfileInput`](crate::input::GetLoginProfileInput)
    pub fn builder() -> crate::input::get_login_profile_input::Builder {
        crate::input::get_login_profile_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetLoginProfile {
    type Output = std::result::Result<
        crate::output::GetLoginProfileOutput,
        crate::error::GetLoginProfileError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_login_profile_error(response)
        } else {
            crate::operation_deser::parse_get_login_profile_response(response)
        }
    }
}

/// <p>Returns information about the specified OpenID Connect (OIDC) provider resource object
/// in IAM.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetOpenIDConnectProvider {
    _private: (),
}
impl GetOpenIDConnectProvider {
    /// Creates a new builder-style object to manufacture [`GetOpenIdConnectProviderInput`](crate::input::GetOpenIdConnectProviderInput)
    pub fn builder() -> crate::input::get_open_id_connect_provider_input::Builder {
        crate::input::get_open_id_connect_provider_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetOpenIDConnectProvider {
    type Output = std::result::Result<
        crate::output::GetOpenIdConnectProviderOutput,
        crate::error::GetOpenIDConnectProviderError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_open_id_connect_provider_error(response)
        } else {
            crate::operation_deser::parse_get_open_id_connect_provider_response(response)
        }
    }
}

/// <p>Retrieves the service last accessed data report for Organizations that was previously
/// generated using the <code>
/// <a>GenerateOrganizationsAccessReport</a>
/// </code>
/// operation. This operation retrieves the status of your report job and the report
/// contents.</p>
/// <p>Depending on the parameters that you passed when you generated the report, the data
/// returned could include different information. For details, see <a>GenerateOrganizationsAccessReport</a>.</p>
/// <p>To call this operation, you must be signed in to the management account in your
/// organization. SCPs must be enabled for your organization root. You must have permissions
/// to perform this operation. For more information, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/access_policies_access-advisor.html">Refining permissions using
/// service last accessed data</a> in the
/// <i>IAM User Guide</i>.</p>
/// <p>For each service that principals in an account (root users, IAM users, or IAM
/// roles) could access using SCPs, the operation returns details about the most recent
/// access attempt. If there was no attempt, the service is listed without details about the
/// most recent attempt to access the service. If the operation fails, it returns the reason
/// that it failed.</p>
/// <p>By default, the list is sorted by service namespace.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetOrganizationsAccessReport {
    _private: (),
}
impl GetOrganizationsAccessReport {
    /// Creates a new builder-style object to manufacture [`GetOrganizationsAccessReportInput`](crate::input::GetOrganizationsAccessReportInput)
    pub fn builder() -> crate::input::get_organizations_access_report_input::Builder {
        crate::input::get_organizations_access_report_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetOrganizationsAccessReport {
    type Output = std::result::Result<
        crate::output::GetOrganizationsAccessReportOutput,
        crate::error::GetOrganizationsAccessReportError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_organizations_access_report_error(response)
        } else {
            crate::operation_deser::parse_get_organizations_access_report_response(response)
        }
    }
}

/// <p>Retrieves information about the specified managed policy, including the policy's
/// default version and the total number of IAM users, groups, and roles to which the
/// policy is attached. To retrieve the list of the specific users, groups, and roles that
/// the policy is attached to, use <a>ListEntitiesForPolicy</a>. This operation
/// returns metadata about the policy. To retrieve the actual policy document for a specific
/// version of the policy, use <a>GetPolicyVersion</a>.</p>
/// <p>This operation retrieves information about managed policies. To retrieve information
/// about an inline policy that is embedded with an IAM user, group, or role, use <a>GetUserPolicy</a>, <a>GetGroupPolicy</a>, or <a>GetRolePolicy</a>.</p>
/// <p>For more information about policies, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/policies-managed-vs-inline.html">Managed policies and inline
/// policies</a> in the <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetPolicy {
    _private: (),
}
impl GetPolicy {
    /// Creates a new builder-style object to manufacture [`GetPolicyInput`](crate::input::GetPolicyInput)
    pub fn builder() -> crate::input::get_policy_input::Builder {
        crate::input::get_policy_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetPolicy {
    type Output = std::result::Result<crate::output::GetPolicyOutput, crate::error::GetPolicyError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_policy_error(response)
        } else {
            crate::operation_deser::parse_get_policy_response(response)
        }
    }
}

/// <p>Retrieves information about the specified version of the specified managed policy,
/// including the policy document.</p>
/// <note>
/// <p>Policies returned by this operation are URL-encoded compliant
/// with <a href="https://tools.ietf.org/html/rfc3986">RFC 3986</a>. You can use a URL
/// decoding method to convert the policy back to plain JSON text. For example, if you use Java, you
/// can use the <code>decode</code> method of the <code>java.net.URLDecoder</code> utility class in
/// the Java SDK. Other languages and SDKs provide similar functionality.</p>
/// </note>
/// <p>To list the available versions for a policy, use <a>ListPolicyVersions</a>.</p>
/// <p>This operation retrieves information about managed policies. To retrieve information
/// about an inline policy that is embedded in a user, group, or role, use <a>GetUserPolicy</a>, <a>GetGroupPolicy</a>, or <a>GetRolePolicy</a>.</p>
/// <p>For more information about the types of policies, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/policies-managed-vs-inline.html">Managed policies and inline
/// policies</a> in the <i>IAM User Guide</i>.</p>
/// <p>For more information about managed policy versions, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/policies-managed-versions.html">Versioning for managed
/// policies</a> in the <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetPolicyVersion {
    _private: (),
}
impl GetPolicyVersion {
    /// Creates a new builder-style object to manufacture [`GetPolicyVersionInput`](crate::input::GetPolicyVersionInput)
    pub fn builder() -> crate::input::get_policy_version_input::Builder {
        crate::input::get_policy_version_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetPolicyVersion {
    type Output = std::result::Result<
        crate::output::GetPolicyVersionOutput,
        crate::error::GetPolicyVersionError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_policy_version_error(response)
        } else {
            crate::operation_deser::parse_get_policy_version_response(response)
        }
    }
}

/// <p>Retrieves information about the specified role, including the role's path, GUID, ARN,
/// and the role's trust policy that grants permission to assume the role. For more
/// information about roles, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/WorkingWithRoles.html">Working with roles</a>.</p>
/// <note>
/// <p>Policies returned by this operation are URL-encoded compliant
/// with <a href="https://tools.ietf.org/html/rfc3986">RFC 3986</a>. You can use a URL
/// decoding method to convert the policy back to plain JSON text. For example, if you use Java, you
/// can use the <code>decode</code> method of the <code>java.net.URLDecoder</code> utility class in
/// the Java SDK. Other languages and SDKs provide similar functionality.</p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetRole {
    _private: (),
}
impl GetRole {
    /// Creates a new builder-style object to manufacture [`GetRoleInput`](crate::input::GetRoleInput)
    pub fn builder() -> crate::input::get_role_input::Builder {
        crate::input::get_role_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetRole {
    type Output = std::result::Result<crate::output::GetRoleOutput, crate::error::GetRoleError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_role_error(response)
        } else {
            crate::operation_deser::parse_get_role_response(response)
        }
    }
}

/// <p>Retrieves the specified inline policy document that is embedded with the specified
/// IAM role.</p>
/// <note>
/// <p>Policies returned by this operation are URL-encoded compliant
/// with <a href="https://tools.ietf.org/html/rfc3986">RFC 3986</a>. You can use a URL
/// decoding method to convert the policy back to plain JSON text. For example, if you use Java, you
/// can use the <code>decode</code> method of the <code>java.net.URLDecoder</code> utility class in
/// the Java SDK. Other languages and SDKs provide similar functionality.</p>
/// </note>
/// <p>An IAM role can also have managed policies attached to it. To retrieve a managed
/// policy document that is attached to a role, use <a>GetPolicy</a> to determine
/// the policy's default version, then use <a>GetPolicyVersion</a> to retrieve
/// the policy document.</p>
/// <p>For more information about policies, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/policies-managed-vs-inline.html">Managed policies and inline
/// policies</a> in the <i>IAM User Guide</i>.</p>
/// <p>For more information about roles, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/roles-toplevel.html">Using roles to delegate permissions and
/// federate identities</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetRolePolicy {
    _private: (),
}
impl GetRolePolicy {
    /// Creates a new builder-style object to manufacture [`GetRolePolicyInput`](crate::input::GetRolePolicyInput)
    pub fn builder() -> crate::input::get_role_policy_input::Builder {
        crate::input::get_role_policy_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetRolePolicy {
    type Output =
        std::result::Result<crate::output::GetRolePolicyOutput, crate::error::GetRolePolicyError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_role_policy_error(response)
        } else {
            crate::operation_deser::parse_get_role_policy_response(response)
        }
    }
}

/// <p>Returns the SAML provider metadocument that was uploaded when the IAM SAML provider
/// resource object was created or updated.</p>
/// <note>
/// <p>This operation requires <a href="https://docs.aws.amazon.com/general/latest/gr/signature-version-4.html">Signature Version 4</a>.</p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetSAMLProvider {
    _private: (),
}
impl GetSAMLProvider {
    /// Creates a new builder-style object to manufacture [`GetSamlProviderInput`](crate::input::GetSamlProviderInput)
    pub fn builder() -> crate::input::get_saml_provider_input::Builder {
        crate::input::get_saml_provider_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetSAMLProvider {
    type Output = std::result::Result<
        crate::output::GetSamlProviderOutput,
        crate::error::GetSAMLProviderError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_saml_provider_error(response)
        } else {
            crate::operation_deser::parse_get_saml_provider_response(response)
        }
    }
}

/// <p>Retrieves information about the specified server certificate stored in IAM.</p>
/// <p>For more information about working with server certificates, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_credentials_server-certs.html">Working
/// with server certificates</a> in the <i>IAM User Guide</i>. This
/// topic includes a list of Amazon Web Services services that can use the server certificates that you
/// manage with IAM.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetServerCertificate {
    _private: (),
}
impl GetServerCertificate {
    /// Creates a new builder-style object to manufacture [`GetServerCertificateInput`](crate::input::GetServerCertificateInput)
    pub fn builder() -> crate::input::get_server_certificate_input::Builder {
        crate::input::get_server_certificate_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetServerCertificate {
    type Output = std::result::Result<
        crate::output::GetServerCertificateOutput,
        crate::error::GetServerCertificateError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_server_certificate_error(response)
        } else {
            crate::operation_deser::parse_get_server_certificate_response(response)
        }
    }
}

/// <p>Retrieves a service last accessed report that was created using the
/// <code>GenerateServiceLastAccessedDetails</code> operation. You can use the
/// <code>JobId</code> parameter in <code>GetServiceLastAccessedDetails</code> to
/// retrieve the status of your report job. When the report is complete, you can retrieve
/// the generated report. The report includes a list of Amazon Web Services services that the resource
/// (user, group, role, or managed policy) can access.</p>
/// <note>
/// <p>Service last accessed data does not use other policy types when determining
/// whether a resource could access a service. These other policy types include
/// resource-based policies, access control lists, Organizations policies, IAM
/// permissions boundaries, and STS assume role policies. It only applies
/// permissions policy logic. For more about the evaluation of policy types, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/reference_policies_evaluation-logic.html#policy-eval-basics">Evaluating policies</a> in the
/// <i>IAM User Guide</i>.</p>
/// </note>
/// <p>For each service that the resource could access using permissions policies, the
/// operation returns details about the most recent access attempt. If there was no attempt,
/// the service is listed without details about the most recent attempt to access the
/// service. If the operation fails, the <code>GetServiceLastAccessedDetails</code>
/// operation returns the reason that it failed.</p>
/// <p>The <code>GetServiceLastAccessedDetails</code> operation returns a list of services.
/// This list includes the number of entities that have attempted to access the service and
/// the date and time of the last attempt. It also returns the ARN of the following entity,
/// depending on the resource ARN that you used to generate the report:</p>
/// <ul>
/// <li>
/// <p>
/// <b>User</b> – Returns the user ARN that you
/// used to generate the report</p>
/// </li>
/// <li>
/// <p>
/// <b>Group</b> – Returns the ARN of the group
/// member (user) that last attempted to access the service</p>
/// </li>
/// <li>
/// <p>
/// <b>Role</b> – Returns the role ARN that you
/// used to generate the report</p>
/// </li>
/// <li>
/// <p>
/// <b>Policy</b> – Returns the ARN of the user
/// or role that last used the policy to attempt to access the service</p>
/// </li>
/// </ul>
/// <p>By default, the list is sorted by service namespace.</p>
/// <p>If you specified <code>ACTION_LEVEL</code> granularity when you generated the report,
/// this operation returns service and action last accessed data. This includes the most
/// recent access attempt for each tracked action within a service. Otherwise, this
/// operation returns only service data.</p>
/// <p>For more information about service and action last accessed data, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/access_policies_access-advisor.html">Reducing permissions using service last accessed data</a> in the
/// <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetServiceLastAccessedDetails {
    _private: (),
}
impl GetServiceLastAccessedDetails {
    /// Creates a new builder-style object to manufacture [`GetServiceLastAccessedDetailsInput`](crate::input::GetServiceLastAccessedDetailsInput)
    pub fn builder() -> crate::input::get_service_last_accessed_details_input::Builder {
        crate::input::get_service_last_accessed_details_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetServiceLastAccessedDetails {
    type Output = std::result::Result<
        crate::output::GetServiceLastAccessedDetailsOutput,
        crate::error::GetServiceLastAccessedDetailsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_service_last_accessed_details_error(response)
        } else {
            crate::operation_deser::parse_get_service_last_accessed_details_response(response)
        }
    }
}

/// <p>After you generate a group or policy report using the
/// <code>GenerateServiceLastAccessedDetails</code> operation, you can use the
/// <code>JobId</code> parameter in
/// <code>GetServiceLastAccessedDetailsWithEntities</code>. This operation retrieves the
/// status of your report job and a list of entities that could have used group or policy
/// permissions to access the specified service.</p>
/// <ul>
/// <li>
/// <p>
/// <b>Group</b> – For a group report, this
/// operation returns a list of users in the group that could have used the group’s
/// policies in an attempt to access the service.</p>
/// </li>
/// <li>
/// <p>
/// <b>Policy</b> – For a policy report, this
/// operation returns a list of entities (users or roles) that could have used the
/// policy in an attempt to access the service.</p>
/// </li>
/// </ul>
/// <p>You can also use this operation for user or role reports to retrieve details about
/// those entities.</p>
/// <p>If the operation fails, the <code>GetServiceLastAccessedDetailsWithEntities</code>
/// operation returns the reason that it failed.</p>
/// <p>By default, the list of associated entities is sorted by date, with the most recent
/// access listed first.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetServiceLastAccessedDetailsWithEntities {
    _private: (),
}
impl GetServiceLastAccessedDetailsWithEntities {
    /// Creates a new builder-style object to manufacture [`GetServiceLastAccessedDetailsWithEntitiesInput`](crate::input::GetServiceLastAccessedDetailsWithEntitiesInput)
    pub fn builder() -> crate::input::get_service_last_accessed_details_with_entities_input::Builder
    {
        crate::input::get_service_last_accessed_details_with_entities_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetServiceLastAccessedDetailsWithEntities {
    type Output = std::result::Result<
        crate::output::GetServiceLastAccessedDetailsWithEntitiesOutput,
        crate::error::GetServiceLastAccessedDetailsWithEntitiesError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_service_last_accessed_details_with_entities_error(
                response,
            )
        } else {
            crate::operation_deser::parse_get_service_last_accessed_details_with_entities_response(
                response,
            )
        }
    }
}

/// <p>Retrieves the status of your service-linked role deletion. After you use <a>DeleteServiceLinkedRole</a> to submit a service-linked role for deletion,
/// you can use the <code>DeletionTaskId</code> parameter in
/// <code>GetServiceLinkedRoleDeletionStatus</code> to check the status of the deletion.
/// If the deletion fails, this operation returns the reason that it failed, if that
/// information is returned by the service.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetServiceLinkedRoleDeletionStatus {
    _private: (),
}
impl GetServiceLinkedRoleDeletionStatus {
    /// Creates a new builder-style object to manufacture [`GetServiceLinkedRoleDeletionStatusInput`](crate::input::GetServiceLinkedRoleDeletionStatusInput)
    pub fn builder() -> crate::input::get_service_linked_role_deletion_status_input::Builder {
        crate::input::get_service_linked_role_deletion_status_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetServiceLinkedRoleDeletionStatus {
    type Output = std::result::Result<
        crate::output::GetServiceLinkedRoleDeletionStatusOutput,
        crate::error::GetServiceLinkedRoleDeletionStatusError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_service_linked_role_deletion_status_error(response)
        } else {
            crate::operation_deser::parse_get_service_linked_role_deletion_status_response(response)
        }
    }
}

/// <p>Retrieves the specified SSH public key, including metadata about the key.</p>
/// <p>The SSH public key retrieved by this operation is used only for authenticating the
/// associated IAM user to an CodeCommit repository. For more information about using SSH keys
/// to authenticate to an CodeCommit repository, see <a href="https://docs.aws.amazon.com/codecommit/latest/userguide/setting-up-credentials-ssh.html">Set up CodeCommit for SSH
/// connections</a> in the <i>CodeCommit User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetSSHPublicKey {
    _private: (),
}
impl GetSSHPublicKey {
    /// Creates a new builder-style object to manufacture [`GetSshPublicKeyInput`](crate::input::GetSshPublicKeyInput)
    pub fn builder() -> crate::input::get_ssh_public_key_input::Builder {
        crate::input::get_ssh_public_key_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetSSHPublicKey {
    type Output = std::result::Result<
        crate::output::GetSshPublicKeyOutput,
        crate::error::GetSSHPublicKeyError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_ssh_public_key_error(response)
        } else {
            crate::operation_deser::parse_get_ssh_public_key_response(response)
        }
    }
}

/// <p>Retrieves information about the specified IAM user, including the user's creation
/// date, path, unique ID, and ARN.</p>
/// <p>If you do not specify a user name, IAM determines the user name implicitly based on
/// the Amazon Web Services access key ID used to sign the request to this operation.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetUser {
    _private: (),
}
impl GetUser {
    /// Creates a new builder-style object to manufacture [`GetUserInput`](crate::input::GetUserInput)
    pub fn builder() -> crate::input::get_user_input::Builder {
        crate::input::get_user_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetUser {
    type Output = std::result::Result<crate::output::GetUserOutput, crate::error::GetUserError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_user_error(response)
        } else {
            crate::operation_deser::parse_get_user_response(response)
        }
    }
}

/// <p>Retrieves the specified inline policy document that is embedded in the specified IAM
/// user.</p>
/// <note>
/// <p>Policies returned by this operation are URL-encoded compliant
/// with <a href="https://tools.ietf.org/html/rfc3986">RFC 3986</a>. You can use a URL
/// decoding method to convert the policy back to plain JSON text. For example, if you use Java, you
/// can use the <code>decode</code> method of the <code>java.net.URLDecoder</code> utility class in
/// the Java SDK. Other languages and SDKs provide similar functionality.</p>
/// </note>
/// <p>An IAM user can also have managed policies attached to it. To retrieve a managed
/// policy document that is attached to a user, use <a>GetPolicy</a> to determine
/// the policy's default version. Then use <a>GetPolicyVersion</a> to retrieve
/// the policy document.</p>
/// <p>For more information about policies, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/policies-managed-vs-inline.html">Managed policies and inline
/// policies</a> in the <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetUserPolicy {
    _private: (),
}
impl GetUserPolicy {
    /// Creates a new builder-style object to manufacture [`GetUserPolicyInput`](crate::input::GetUserPolicyInput)
    pub fn builder() -> crate::input::get_user_policy_input::Builder {
        crate::input::get_user_policy_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetUserPolicy {
    type Output =
        std::result::Result<crate::output::GetUserPolicyOutput, crate::error::GetUserPolicyError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_user_policy_error(response)
        } else {
            crate::operation_deser::parse_get_user_policy_response(response)
        }
    }
}

/// <p>Returns information about the access key IDs associated with the specified IAM user.
/// If there is none, the operation returns an empty list.</p>
/// <p>Although each user is limited to a small number of keys, you can still paginate the
/// results using the <code>MaxItems</code> and <code>Marker</code> parameters.</p>
/// <p>If the <code>UserName</code> field is not specified, the user name is determined
/// implicitly based on the Amazon Web Services access key ID used to sign the request. This operation
/// works for access keys under the Amazon Web Services account. Consequently, you can use this operation
/// to manage Amazon Web Services account root user credentials even if the Amazon Web Services account has no
/// associated users.</p>
/// <note>
/// <p>To ensure the security of your Amazon Web Services account, the secret access key is accessible
/// only during key and user creation.</p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListAccessKeys {
    _private: (),
}
impl ListAccessKeys {
    /// Creates a new builder-style object to manufacture [`ListAccessKeysInput`](crate::input::ListAccessKeysInput)
    pub fn builder() -> crate::input::list_access_keys_input::Builder {
        crate::input::list_access_keys_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListAccessKeys {
    type Output =
        std::result::Result<crate::output::ListAccessKeysOutput, crate::error::ListAccessKeysError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_access_keys_error(response)
        } else {
            crate::operation_deser::parse_list_access_keys_response(response)
        }
    }
}

/// <p>Lists the account alias associated with the Amazon Web Services account (Note: you can have only
/// one). For information about using an Amazon Web Services account alias, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/AccountAlias.html">Using an alias for your
/// Amazon Web Services account ID</a> in the <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListAccountAliases {
    _private: (),
}
impl ListAccountAliases {
    /// Creates a new builder-style object to manufacture [`ListAccountAliasesInput`](crate::input::ListAccountAliasesInput)
    pub fn builder() -> crate::input::list_account_aliases_input::Builder {
        crate::input::list_account_aliases_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListAccountAliases {
    type Output = std::result::Result<
        crate::output::ListAccountAliasesOutput,
        crate::error::ListAccountAliasesError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_account_aliases_error(response)
        } else {
            crate::operation_deser::parse_list_account_aliases_response(response)
        }
    }
}

/// <p>Lists all managed policies that are attached to the specified IAM group.</p>
/// <p>An IAM group can also have inline policies embedded with it. To list the inline
/// policies for a group, use <a>ListGroupPolicies</a>. For information about
/// policies, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/policies-managed-vs-inline.html">Managed policies and inline
/// policies</a> in the <i>IAM User Guide</i>.</p>
/// <p>You can paginate the results using the <code>MaxItems</code> and <code>Marker</code>
/// parameters. You can use the <code>PathPrefix</code> parameter to limit the list of
/// policies to only those matching the specified path prefix. If there are no policies
/// attached to the specified group (or none that match the specified path prefix), the
/// operation returns an empty list.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListAttachedGroupPolicies {
    _private: (),
}
impl ListAttachedGroupPolicies {
    /// Creates a new builder-style object to manufacture [`ListAttachedGroupPoliciesInput`](crate::input::ListAttachedGroupPoliciesInput)
    pub fn builder() -> crate::input::list_attached_group_policies_input::Builder {
        crate::input::list_attached_group_policies_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListAttachedGroupPolicies {
    type Output = std::result::Result<
        crate::output::ListAttachedGroupPoliciesOutput,
        crate::error::ListAttachedGroupPoliciesError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_attached_group_policies_error(response)
        } else {
            crate::operation_deser::parse_list_attached_group_policies_response(response)
        }
    }
}

/// <p>Lists all managed policies that are attached to the specified IAM role.</p>
/// <p>An IAM role can also have inline policies embedded with it. To list the inline
/// policies for a role, use <a>ListRolePolicies</a>. For information about
/// policies, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/policies-managed-vs-inline.html">Managed policies and inline
/// policies</a> in the <i>IAM User Guide</i>.</p>
/// <p>You can paginate the results using the <code>MaxItems</code> and <code>Marker</code>
/// parameters. You can use the <code>PathPrefix</code> parameter to limit the list of
/// policies to only those matching the specified path prefix. If there are no policies
/// attached to the specified role (or none that match the specified path prefix), the
/// operation returns an empty list.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListAttachedRolePolicies {
    _private: (),
}
impl ListAttachedRolePolicies {
    /// Creates a new builder-style object to manufacture [`ListAttachedRolePoliciesInput`](crate::input::ListAttachedRolePoliciesInput)
    pub fn builder() -> crate::input::list_attached_role_policies_input::Builder {
        crate::input::list_attached_role_policies_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListAttachedRolePolicies {
    type Output = std::result::Result<
        crate::output::ListAttachedRolePoliciesOutput,
        crate::error::ListAttachedRolePoliciesError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_attached_role_policies_error(response)
        } else {
            crate::operation_deser::parse_list_attached_role_policies_response(response)
        }
    }
}

/// <p>Lists all managed policies that are attached to the specified IAM user.</p>
/// <p>An IAM user can also have inline policies embedded with it. To list the inline
/// policies for a user, use <a>ListUserPolicies</a>. For information about
/// policies, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/policies-managed-vs-inline.html">Managed policies and inline
/// policies</a> in the <i>IAM User Guide</i>.</p>
/// <p>You can paginate the results using the <code>MaxItems</code> and <code>Marker</code>
/// parameters. You can use the <code>PathPrefix</code> parameter to limit the list of
/// policies to only those matching the specified path prefix. If there are no policies
/// attached to the specified group (or none that match the specified path prefix), the
/// operation returns an empty list.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListAttachedUserPolicies {
    _private: (),
}
impl ListAttachedUserPolicies {
    /// Creates a new builder-style object to manufacture [`ListAttachedUserPoliciesInput`](crate::input::ListAttachedUserPoliciesInput)
    pub fn builder() -> crate::input::list_attached_user_policies_input::Builder {
        crate::input::list_attached_user_policies_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListAttachedUserPolicies {
    type Output = std::result::Result<
        crate::output::ListAttachedUserPoliciesOutput,
        crate::error::ListAttachedUserPoliciesError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_attached_user_policies_error(response)
        } else {
            crate::operation_deser::parse_list_attached_user_policies_response(response)
        }
    }
}

/// <p>Lists all IAM users, groups, and roles that the specified managed policy is attached
/// to.</p>
/// <p>You can use the optional <code>EntityFilter</code> parameter to limit the results to a
/// particular type of entity (users, groups, or roles). For example, to list only the roles
/// that are attached to the specified policy, set <code>EntityFilter</code> to
/// <code>Role</code>.</p>
/// <p>You can paginate the results using the <code>MaxItems</code> and <code>Marker</code>
/// parameters.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListEntitiesForPolicy {
    _private: (),
}
impl ListEntitiesForPolicy {
    /// Creates a new builder-style object to manufacture [`ListEntitiesForPolicyInput`](crate::input::ListEntitiesForPolicyInput)
    pub fn builder() -> crate::input::list_entities_for_policy_input::Builder {
        crate::input::list_entities_for_policy_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListEntitiesForPolicy {
    type Output = std::result::Result<
        crate::output::ListEntitiesForPolicyOutput,
        crate::error::ListEntitiesForPolicyError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_entities_for_policy_error(response)
        } else {
            crate::operation_deser::parse_list_entities_for_policy_response(response)
        }
    }
}

/// <p>Lists the names of the inline policies that are embedded in the specified IAM
/// group.</p>
/// <p>An IAM group can also have managed policies attached to it. To list the managed
/// policies that are attached to a group, use <a>ListAttachedGroupPolicies</a>.
/// For more information about policies, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/policies-managed-vs-inline.html">Managed policies and inline
/// policies</a> in the <i>IAM User Guide</i>.</p>
/// <p>You can paginate the results using the <code>MaxItems</code> and <code>Marker</code>
/// parameters. If there are no inline policies embedded with the specified group, the
/// operation returns an empty list.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListGroupPolicies {
    _private: (),
}
impl ListGroupPolicies {
    /// Creates a new builder-style object to manufacture [`ListGroupPoliciesInput`](crate::input::ListGroupPoliciesInput)
    pub fn builder() -> crate::input::list_group_policies_input::Builder {
        crate::input::list_group_policies_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListGroupPolicies {
    type Output = std::result::Result<
        crate::output::ListGroupPoliciesOutput,
        crate::error::ListGroupPoliciesError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_group_policies_error(response)
        } else {
            crate::operation_deser::parse_list_group_policies_response(response)
        }
    }
}

/// <p>Lists the IAM groups that have the specified path prefix.</p>
/// <p> You can paginate the results using the <code>MaxItems</code> and <code>Marker</code>
/// parameters.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListGroups {
    _private: (),
}
impl ListGroups {
    /// Creates a new builder-style object to manufacture [`ListGroupsInput`](crate::input::ListGroupsInput)
    pub fn builder() -> crate::input::list_groups_input::Builder {
        crate::input::list_groups_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListGroups {
    type Output =
        std::result::Result<crate::output::ListGroupsOutput, crate::error::ListGroupsError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_groups_error(response)
        } else {
            crate::operation_deser::parse_list_groups_response(response)
        }
    }
}

/// <p>Lists the IAM groups that the specified IAM user belongs to.</p>
/// <p>You can paginate the results using the <code>MaxItems</code> and <code>Marker</code>
/// parameters.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListGroupsForUser {
    _private: (),
}
impl ListGroupsForUser {
    /// Creates a new builder-style object to manufacture [`ListGroupsForUserInput`](crate::input::ListGroupsForUserInput)
    pub fn builder() -> crate::input::list_groups_for_user_input::Builder {
        crate::input::list_groups_for_user_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListGroupsForUser {
    type Output = std::result::Result<
        crate::output::ListGroupsForUserOutput,
        crate::error::ListGroupsForUserError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_groups_for_user_error(response)
        } else {
            crate::operation_deser::parse_list_groups_for_user_response(response)
        }
    }
}

/// <p>Lists the instance profiles that have the specified path prefix. If there are none,
/// the operation returns an empty list. For more information about instance profiles, see
/// <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/AboutInstanceProfiles.html">About
/// instance profiles</a>.</p>
/// <note>
/// <p>IAM resource-listing operations return a subset of the available
/// attributes for the resource. For example, this operation does not return tags, even though they are an attribute of the returned object. To view all of the information for an instance profile, see <a>GetInstanceProfile</a>.</p>
/// </note>
/// <p>You can paginate the results using the <code>MaxItems</code> and <code>Marker</code>
/// parameters.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListInstanceProfiles {
    _private: (),
}
impl ListInstanceProfiles {
    /// Creates a new builder-style object to manufacture [`ListInstanceProfilesInput`](crate::input::ListInstanceProfilesInput)
    pub fn builder() -> crate::input::list_instance_profiles_input::Builder {
        crate::input::list_instance_profiles_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListInstanceProfiles {
    type Output = std::result::Result<
        crate::output::ListInstanceProfilesOutput,
        crate::error::ListInstanceProfilesError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_instance_profiles_error(response)
        } else {
            crate::operation_deser::parse_list_instance_profiles_response(response)
        }
    }
}

/// <p>Lists the instance profiles that have the specified associated IAM role. If there
/// are none, the operation returns an empty list. For more information about instance
/// profiles, go to <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/AboutInstanceProfiles.html">About instance
/// profiles</a>.</p>
/// <p>You can paginate the results using the <code>MaxItems</code> and <code>Marker</code>
/// parameters.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListInstanceProfilesForRole {
    _private: (),
}
impl ListInstanceProfilesForRole {
    /// Creates a new builder-style object to manufacture [`ListInstanceProfilesForRoleInput`](crate::input::ListInstanceProfilesForRoleInput)
    pub fn builder() -> crate::input::list_instance_profiles_for_role_input::Builder {
        crate::input::list_instance_profiles_for_role_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListInstanceProfilesForRole {
    type Output = std::result::Result<
        crate::output::ListInstanceProfilesForRoleOutput,
        crate::error::ListInstanceProfilesForRoleError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_instance_profiles_for_role_error(response)
        } else {
            crate::operation_deser::parse_list_instance_profiles_for_role_response(response)
        }
    }
}

/// <p>Lists the tags that are attached to the specified IAM instance profile. The returned list of tags is sorted by tag key.
/// For more information about tagging, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_tags.html">Tagging IAM resources</a> in the
/// <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListInstanceProfileTags {
    _private: (),
}
impl ListInstanceProfileTags {
    /// Creates a new builder-style object to manufacture [`ListInstanceProfileTagsInput`](crate::input::ListInstanceProfileTagsInput)
    pub fn builder() -> crate::input::list_instance_profile_tags_input::Builder {
        crate::input::list_instance_profile_tags_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListInstanceProfileTags {
    type Output = std::result::Result<
        crate::output::ListInstanceProfileTagsOutput,
        crate::error::ListInstanceProfileTagsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_instance_profile_tags_error(response)
        } else {
            crate::operation_deser::parse_list_instance_profile_tags_response(response)
        }
    }
}

/// <p>Lists the MFA devices for an IAM user. If the request includes a IAM user name,
/// then this operation lists all the MFA devices associated with the specified user. If you
/// do not specify a user name, IAM determines the user name implicitly based on the Amazon Web Services
/// access key ID signing the request for this operation.</p>
/// <p>You can paginate the results using the <code>MaxItems</code> and <code>Marker</code>
/// parameters.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListMFADevices {
    _private: (),
}
impl ListMFADevices {
    /// Creates a new builder-style object to manufacture [`ListMfaDevicesInput`](crate::input::ListMfaDevicesInput)
    pub fn builder() -> crate::input::list_mfa_devices_input::Builder {
        crate::input::list_mfa_devices_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListMFADevices {
    type Output =
        std::result::Result<crate::output::ListMfaDevicesOutput, crate::error::ListMFADevicesError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_mfa_devices_error(response)
        } else {
            crate::operation_deser::parse_list_mfa_devices_response(response)
        }
    }
}

/// <p>Lists the tags that are attached to the specified IAM virtual multi-factor authentication (MFA) device. The returned list of tags is
/// sorted by tag key. For more information about tagging, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_tags.html">Tagging IAM resources</a> in the
/// <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListMFADeviceTags {
    _private: (),
}
impl ListMFADeviceTags {
    /// Creates a new builder-style object to manufacture [`ListMfaDeviceTagsInput`](crate::input::ListMfaDeviceTagsInput)
    pub fn builder() -> crate::input::list_mfa_device_tags_input::Builder {
        crate::input::list_mfa_device_tags_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListMFADeviceTags {
    type Output = std::result::Result<
        crate::output::ListMfaDeviceTagsOutput,
        crate::error::ListMFADeviceTagsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_mfa_device_tags_error(response)
        } else {
            crate::operation_deser::parse_list_mfa_device_tags_response(response)
        }
    }
}

/// <p>Lists information about the IAM OpenID Connect (OIDC) provider resource objects
/// defined in the Amazon Web Services account.</p>
/// <note>
/// <p>IAM resource-listing operations return a subset of the available
/// attributes for the resource. For example, this operation does not return tags, even though they are an attribute of the returned object. To view all of the information for an OIDC provider, see <a>GetOpenIDConnectProvider</a>.</p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListOpenIDConnectProviders {
    _private: (),
}
impl ListOpenIDConnectProviders {
    /// Creates a new builder-style object to manufacture [`ListOpenIdConnectProvidersInput`](crate::input::ListOpenIdConnectProvidersInput)
    pub fn builder() -> crate::input::list_open_id_connect_providers_input::Builder {
        crate::input::list_open_id_connect_providers_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListOpenIDConnectProviders {
    type Output = std::result::Result<
        crate::output::ListOpenIdConnectProvidersOutput,
        crate::error::ListOpenIDConnectProvidersError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_open_id_connect_providers_error(response)
        } else {
            crate::operation_deser::parse_list_open_id_connect_providers_response(response)
        }
    }
}

/// <p>Lists the tags that are attached to the specified OpenID Connect (OIDC)-compatible
/// identity provider. The returned list of tags is sorted by tag key. For more information, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_roles_providers_oidc.html">About web identity
/// federation</a>.</p>
/// <p>For more information about tagging, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_tags.html">Tagging IAM resources</a> in the
/// <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListOpenIDConnectProviderTags {
    _private: (),
}
impl ListOpenIDConnectProviderTags {
    /// Creates a new builder-style object to manufacture [`ListOpenIdConnectProviderTagsInput`](crate::input::ListOpenIdConnectProviderTagsInput)
    pub fn builder() -> crate::input::list_open_id_connect_provider_tags_input::Builder {
        crate::input::list_open_id_connect_provider_tags_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListOpenIDConnectProviderTags {
    type Output = std::result::Result<
        crate::output::ListOpenIdConnectProviderTagsOutput,
        crate::error::ListOpenIDConnectProviderTagsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_open_id_connect_provider_tags_error(response)
        } else {
            crate::operation_deser::parse_list_open_id_connect_provider_tags_response(response)
        }
    }
}

/// <p>Lists all the managed policies that are available in your Amazon Web Services account, including
/// your own customer-defined managed policies and all Amazon Web Services managed policies.</p>
/// <p>You can filter the list of policies that is returned using the optional
/// <code>OnlyAttached</code>, <code>Scope</code>, and <code>PathPrefix</code>
/// parameters. For example, to list only the customer managed policies in your Amazon Web Services
/// account, set <code>Scope</code> to <code>Local</code>. To list only Amazon Web Services managed
/// policies, set <code>Scope</code> to <code>AWS</code>.</p>
/// <p>You can paginate the results using the <code>MaxItems</code> and <code>Marker</code>
/// parameters.</p>
/// <p>For more information about managed policies, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/policies-managed-vs-inline.html">Managed policies and inline
/// policies</a> in the <i>IAM User Guide</i>.</p>
/// <note>
/// <p>IAM resource-listing operations return a subset of the available
/// attributes for the resource. For example, this operation does not return tags, even though they are an attribute of the returned object. To view all of the information for a customer manged policy, see
/// <a>GetPolicy</a>.</p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListPolicies {
    _private: (),
}
impl ListPolicies {
    /// Creates a new builder-style object to manufacture [`ListPoliciesInput`](crate::input::ListPoliciesInput)
    pub fn builder() -> crate::input::list_policies_input::Builder {
        crate::input::list_policies_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListPolicies {
    type Output =
        std::result::Result<crate::output::ListPoliciesOutput, crate::error::ListPoliciesError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_policies_error(response)
        } else {
            crate::operation_deser::parse_list_policies_response(response)
        }
    }
}

/// <p>Retrieves a list of policies that the IAM identity (user, group, or role) can use to
/// access each specified service.</p>
/// <note>
/// <p>This operation does not use other policy types when determining whether a resource
/// could access a service. These other policy types include resource-based policies,
/// access control lists, Organizations policies, IAM permissions boundaries, and
/// STS assume role policies. It only applies permissions policy logic. For more
/// about the evaluation of policy types, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/reference_policies_evaluation-logic.html#policy-eval-basics">Evaluating policies</a> in the
/// <i>IAM User Guide</i>.</p>
/// </note>
/// <p>The list of policies returned by the operation depends on the ARN of the identity that
/// you provide.</p>
/// <ul>
/// <li>
/// <p>
/// <b>User</b> – The list of policies includes
/// the managed and inline policies that are attached to the user directly. The list
/// also includes any additional managed and inline policies that are attached to
/// the group to which the user belongs. </p>
/// </li>
/// <li>
/// <p>
/// <b>Group</b> – The list of policies includes
/// only the managed and inline policies that are attached to the group directly.
/// Policies that are attached to the group’s user are not included.</p>
/// </li>
/// <li>
/// <p>
/// <b>Role</b> – The list of policies includes
/// only the managed and inline policies that are attached to the role.</p>
/// </li>
/// </ul>
/// <p>For each managed policy, this operation returns the ARN and policy name. For each
/// inline policy, it returns the policy name and the entity to which it is attached. Inline
/// policies do not have an ARN. For more information about these policy types, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/access_policies_managed-vs-inline.html">Managed policies and inline policies</a> in the
/// <i>IAM User Guide</i>.</p>
/// <p>Policies that are attached to users and roles as permissions boundaries are not
/// returned. To view which managed policy is currently used to set the permissions boundary
/// for a user or role, use the <a>GetUser</a> or <a>GetRole</a>
/// operations.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListPoliciesGrantingServiceAccess {
    _private: (),
}
impl ListPoliciesGrantingServiceAccess {
    /// Creates a new builder-style object to manufacture [`ListPoliciesGrantingServiceAccessInput`](crate::input::ListPoliciesGrantingServiceAccessInput)
    pub fn builder() -> crate::input::list_policies_granting_service_access_input::Builder {
        crate::input::list_policies_granting_service_access_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListPoliciesGrantingServiceAccess {
    type Output = std::result::Result<
        crate::output::ListPoliciesGrantingServiceAccessOutput,
        crate::error::ListPoliciesGrantingServiceAccessError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_policies_granting_service_access_error(response)
        } else {
            crate::operation_deser::parse_list_policies_granting_service_access_response(response)
        }
    }
}

/// <p>Lists the tags that are attached to the specified IAM customer managed policy.
/// The returned list of tags is sorted by tag key. For more information about tagging, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_tags.html">Tagging IAM resources</a> in the
/// <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListPolicyTags {
    _private: (),
}
impl ListPolicyTags {
    /// Creates a new builder-style object to manufacture [`ListPolicyTagsInput`](crate::input::ListPolicyTagsInput)
    pub fn builder() -> crate::input::list_policy_tags_input::Builder {
        crate::input::list_policy_tags_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListPolicyTags {
    type Output =
        std::result::Result<crate::output::ListPolicyTagsOutput, crate::error::ListPolicyTagsError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_policy_tags_error(response)
        } else {
            crate::operation_deser::parse_list_policy_tags_response(response)
        }
    }
}

/// <p>Lists information about the versions of the specified managed policy, including the
/// version that is currently set as the policy's default version.</p>
/// <p>For more information about managed policies, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/policies-managed-vs-inline.html">Managed policies and inline
/// policies</a> in the <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListPolicyVersions {
    _private: (),
}
impl ListPolicyVersions {
    /// Creates a new builder-style object to manufacture [`ListPolicyVersionsInput`](crate::input::ListPolicyVersionsInput)
    pub fn builder() -> crate::input::list_policy_versions_input::Builder {
        crate::input::list_policy_versions_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListPolicyVersions {
    type Output = std::result::Result<
        crate::output::ListPolicyVersionsOutput,
        crate::error::ListPolicyVersionsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_policy_versions_error(response)
        } else {
            crate::operation_deser::parse_list_policy_versions_response(response)
        }
    }
}

/// <p>Lists the names of the inline policies that are embedded in the specified IAM
/// role.</p>
/// <p>An IAM role can also have managed policies attached to it. To list the managed
/// policies that are attached to a role, use <a>ListAttachedRolePolicies</a>.
/// For more information about policies, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/policies-managed-vs-inline.html">Managed policies and inline
/// policies</a> in the <i>IAM User Guide</i>.</p>
/// <p>You can paginate the results using the <code>MaxItems</code> and <code>Marker</code>
/// parameters. If there are no inline policies embedded with the specified role, the
/// operation returns an empty list.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListRolePolicies {
    _private: (),
}
impl ListRolePolicies {
    /// Creates a new builder-style object to manufacture [`ListRolePoliciesInput`](crate::input::ListRolePoliciesInput)
    pub fn builder() -> crate::input::list_role_policies_input::Builder {
        crate::input::list_role_policies_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListRolePolicies {
    type Output = std::result::Result<
        crate::output::ListRolePoliciesOutput,
        crate::error::ListRolePoliciesError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_role_policies_error(response)
        } else {
            crate::operation_deser::parse_list_role_policies_response(response)
        }
    }
}

/// <p>Lists the IAM roles that have the specified path prefix. If there are none, the
/// operation returns an empty list. For more information about roles, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/WorkingWithRoles.html">Working with
/// roles</a>.</p>
/// <note>
/// <p>IAM resource-listing operations return a subset of the available
/// attributes for the resource. For example, this operation does not return tags, even though they are an attribute of the returned object. To view all of the information for a role, see <a>GetRole</a>.</p>
/// </note>
/// <p>You can paginate the results using the <code>MaxItems</code> and <code>Marker</code>
/// parameters.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListRoles {
    _private: (),
}
impl ListRoles {
    /// Creates a new builder-style object to manufacture [`ListRolesInput`](crate::input::ListRolesInput)
    pub fn builder() -> crate::input::list_roles_input::Builder {
        crate::input::list_roles_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListRoles {
    type Output = std::result::Result<crate::output::ListRolesOutput, crate::error::ListRolesError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_roles_error(response)
        } else {
            crate::operation_deser::parse_list_roles_response(response)
        }
    }
}

/// <p>Lists the tags that are attached to the specified role. The returned list of tags is
/// sorted by tag key. For more information about tagging, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_tags.html">Tagging IAM resources</a> in the
/// <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListRoleTags {
    _private: (),
}
impl ListRoleTags {
    /// Creates a new builder-style object to manufacture [`ListRoleTagsInput`](crate::input::ListRoleTagsInput)
    pub fn builder() -> crate::input::list_role_tags_input::Builder {
        crate::input::list_role_tags_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListRoleTags {
    type Output =
        std::result::Result<crate::output::ListRoleTagsOutput, crate::error::ListRoleTagsError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_role_tags_error(response)
        } else {
            crate::operation_deser::parse_list_role_tags_response(response)
        }
    }
}

/// <p>Lists the SAML provider resource objects defined in IAM in the account.
/// IAM resource-listing operations return a subset of the available
/// attributes for the resource. For example, this operation does not return tags, even though they are an attribute of the returned object. To view all of the information for a SAML provider, see <a>GetSAMLProvider</a>.</p>
/// <important>
/// <p> This operation requires <a href="https://docs.aws.amazon.com/general/latest/gr/signature-version-4.html">Signature Version 4</a>.</p>
/// </important>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListSAMLProviders {
    _private: (),
}
impl ListSAMLProviders {
    /// Creates a new builder-style object to manufacture [`ListSamlProvidersInput`](crate::input::ListSamlProvidersInput)
    pub fn builder() -> crate::input::list_saml_providers_input::Builder {
        crate::input::list_saml_providers_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListSAMLProviders {
    type Output = std::result::Result<
        crate::output::ListSamlProvidersOutput,
        crate::error::ListSAMLProvidersError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_saml_providers_error(response)
        } else {
            crate::operation_deser::parse_list_saml_providers_response(response)
        }
    }
}

/// <p>Lists the tags that are attached to the specified Security Assertion Markup Language
/// (SAML) identity provider. The returned list of tags is sorted by tag key. For more information, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_roles_providers_saml.html">About SAML 2.0-based
/// federation</a>.</p>
/// <p>For more information about tagging, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_tags.html">Tagging IAM resources</a> in the
/// <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListSAMLProviderTags {
    _private: (),
}
impl ListSAMLProviderTags {
    /// Creates a new builder-style object to manufacture [`ListSamlProviderTagsInput`](crate::input::ListSamlProviderTagsInput)
    pub fn builder() -> crate::input::list_saml_provider_tags_input::Builder {
        crate::input::list_saml_provider_tags_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListSAMLProviderTags {
    type Output = std::result::Result<
        crate::output::ListSamlProviderTagsOutput,
        crate::error::ListSAMLProviderTagsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_saml_provider_tags_error(response)
        } else {
            crate::operation_deser::parse_list_saml_provider_tags_response(response)
        }
    }
}

/// <p>Lists the server certificates stored in IAM that have the specified path prefix. If
/// none exist, the operation returns an empty list.</p>
/// <p> You can paginate the results using the <code>MaxItems</code> and <code>Marker</code>
/// parameters.</p>
/// <p>For more information about working with server certificates, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_credentials_server-certs.html">Working
/// with server certificates</a> in the <i>IAM User Guide</i>. This
/// topic also includes a list of Amazon Web Services services that can use the server certificates that
/// you manage with IAM.</p>
/// <note>
/// <p>IAM resource-listing operations return a subset of the available
/// attributes for the resource. For example, this operation does not return tags, even though they are an attribute of the returned object. To view all of the information for a servercertificate, see <a>GetServerCertificate</a>.</p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListServerCertificates {
    _private: (),
}
impl ListServerCertificates {
    /// Creates a new builder-style object to manufacture [`ListServerCertificatesInput`](crate::input::ListServerCertificatesInput)
    pub fn builder() -> crate::input::list_server_certificates_input::Builder {
        crate::input::list_server_certificates_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListServerCertificates {
    type Output = std::result::Result<
        crate::output::ListServerCertificatesOutput,
        crate::error::ListServerCertificatesError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_server_certificates_error(response)
        } else {
            crate::operation_deser::parse_list_server_certificates_response(response)
        }
    }
}

/// <p>Lists the tags that are attached to the specified IAM server certificate. The
/// returned list of tags is sorted by tag key. For more information about tagging, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_tags.html">Tagging IAM resources</a> in the
/// <i>IAM User Guide</i>.</p>
/// <note>
/// <p>For certificates in a Region supported by Certificate Manager (ACM), we
/// recommend that you don't use IAM server certificates. Instead, use ACM to provision,
/// manage, and deploy your server certificates. For more information about IAM server
/// certificates, <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_credentials_server-certs.html">Working with server
/// certificates</a> in the <i>IAM User Guide</i>.</p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListServerCertificateTags {
    _private: (),
}
impl ListServerCertificateTags {
    /// Creates a new builder-style object to manufacture [`ListServerCertificateTagsInput`](crate::input::ListServerCertificateTagsInput)
    pub fn builder() -> crate::input::list_server_certificate_tags_input::Builder {
        crate::input::list_server_certificate_tags_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListServerCertificateTags {
    type Output = std::result::Result<
        crate::output::ListServerCertificateTagsOutput,
        crate::error::ListServerCertificateTagsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_server_certificate_tags_error(response)
        } else {
            crate::operation_deser::parse_list_server_certificate_tags_response(response)
        }
    }
}

/// <p>Returns information about the service-specific credentials associated with the
/// specified IAM user. If none exists, the operation returns an empty list. The
/// service-specific credentials returned by this operation are used only for authenticating
/// the IAM user to a specific service. For more information about using service-specific
/// credentials to authenticate to an Amazon Web Services service, see <a href="https://docs.aws.amazon.com/codecommit/latest/userguide/setting-up-gc.html">Set up service-specific credentials</a>
/// in the CodeCommit User Guide.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListServiceSpecificCredentials {
    _private: (),
}
impl ListServiceSpecificCredentials {
    /// Creates a new builder-style object to manufacture [`ListServiceSpecificCredentialsInput`](crate::input::ListServiceSpecificCredentialsInput)
    pub fn builder() -> crate::input::list_service_specific_credentials_input::Builder {
        crate::input::list_service_specific_credentials_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListServiceSpecificCredentials {
    type Output = std::result::Result<
        crate::output::ListServiceSpecificCredentialsOutput,
        crate::error::ListServiceSpecificCredentialsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_service_specific_credentials_error(response)
        } else {
            crate::operation_deser::parse_list_service_specific_credentials_response(response)
        }
    }
}

/// <p>Returns information about the signing certificates associated with the specified IAM
/// user. If none exists, the operation returns an empty list.</p>
/// <p>Although each user is limited to a small number of signing certificates, you can still
/// paginate the results using the <code>MaxItems</code> and <code>Marker</code>
/// parameters.</p>
/// <p>If the <code>UserName</code> field is not specified, the user name is determined
/// implicitly based on the Amazon Web Services access key ID used to sign the request for this operation.
/// This operation works for access keys under the Amazon Web Services account. Consequently, you can use
/// this operation to manage Amazon Web Services account root user credentials even if the Amazon Web Services account
/// has no associated users.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListSigningCertificates {
    _private: (),
}
impl ListSigningCertificates {
    /// Creates a new builder-style object to manufacture [`ListSigningCertificatesInput`](crate::input::ListSigningCertificatesInput)
    pub fn builder() -> crate::input::list_signing_certificates_input::Builder {
        crate::input::list_signing_certificates_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListSigningCertificates {
    type Output = std::result::Result<
        crate::output::ListSigningCertificatesOutput,
        crate::error::ListSigningCertificatesError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_signing_certificates_error(response)
        } else {
            crate::operation_deser::parse_list_signing_certificates_response(response)
        }
    }
}

/// <p>Returns information about the SSH public keys associated with the specified IAM
/// user. If none exists, the operation returns an empty list.</p>
/// <p>The SSH public keys returned by this operation are used only for authenticating the
/// IAM user to an CodeCommit repository. For more information about using SSH keys to
/// authenticate to an CodeCommit repository, see <a href="https://docs.aws.amazon.com/codecommit/latest/userguide/setting-up-credentials-ssh.html">Set up CodeCommit for
/// SSH connections</a> in the <i>CodeCommit User Guide</i>.</p>
/// <p>Although each user is limited to a small number of keys, you can still paginate the
/// results using the <code>MaxItems</code> and <code>Marker</code> parameters.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListSSHPublicKeys {
    _private: (),
}
impl ListSSHPublicKeys {
    /// Creates a new builder-style object to manufacture [`ListSshPublicKeysInput`](crate::input::ListSshPublicKeysInput)
    pub fn builder() -> crate::input::list_ssh_public_keys_input::Builder {
        crate::input::list_ssh_public_keys_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListSSHPublicKeys {
    type Output = std::result::Result<
        crate::output::ListSshPublicKeysOutput,
        crate::error::ListSSHPublicKeysError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_ssh_public_keys_error(response)
        } else {
            crate::operation_deser::parse_list_ssh_public_keys_response(response)
        }
    }
}

/// <p>Lists the names of the inline policies embedded in the specified IAM user.</p>
/// <p>An IAM user can also have managed policies attached to it. To list the managed
/// policies that are attached to a user, use <a>ListAttachedUserPolicies</a>.
/// For more information about policies, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/policies-managed-vs-inline.html">Managed policies and inline
/// policies</a> in the <i>IAM User Guide</i>.</p>
/// <p>You can paginate the results using the <code>MaxItems</code> and <code>Marker</code>
/// parameters. If there are no inline policies embedded with the specified user, the
/// operation returns an empty list.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListUserPolicies {
    _private: (),
}
impl ListUserPolicies {
    /// Creates a new builder-style object to manufacture [`ListUserPoliciesInput`](crate::input::ListUserPoliciesInput)
    pub fn builder() -> crate::input::list_user_policies_input::Builder {
        crate::input::list_user_policies_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListUserPolicies {
    type Output = std::result::Result<
        crate::output::ListUserPoliciesOutput,
        crate::error::ListUserPoliciesError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_user_policies_error(response)
        } else {
            crate::operation_deser::parse_list_user_policies_response(response)
        }
    }
}

/// <p>Lists the IAM users that have the specified path prefix. If no path prefix is
/// specified, the operation returns all users in the Amazon Web Services account. If there are none, the
/// operation returns an empty list.</p>
/// <note>
/// <p>IAM resource-listing operations return a subset of the available
/// attributes for the resource. For example, this operation does not return tags, even though they are an attribute of the returned object. To view all of the information for a user, see <a>GetUser</a>.</p>
/// </note>
/// <p>You can paginate the results using the <code>MaxItems</code> and <code>Marker</code>
/// parameters.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListUsers {
    _private: (),
}
impl ListUsers {
    /// Creates a new builder-style object to manufacture [`ListUsersInput`](crate::input::ListUsersInput)
    pub fn builder() -> crate::input::list_users_input::Builder {
        crate::input::list_users_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListUsers {
    type Output = std::result::Result<crate::output::ListUsersOutput, crate::error::ListUsersError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_users_error(response)
        } else {
            crate::operation_deser::parse_list_users_response(response)
        }
    }
}

/// <p>Lists the tags that are attached to the specified IAM user. The returned list of tags is sorted by tag key. For more information about tagging, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_tags.html">Tagging IAM resources</a> in the
/// <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListUserTags {
    _private: (),
}
impl ListUserTags {
    /// Creates a new builder-style object to manufacture [`ListUserTagsInput`](crate::input::ListUserTagsInput)
    pub fn builder() -> crate::input::list_user_tags_input::Builder {
        crate::input::list_user_tags_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListUserTags {
    type Output =
        std::result::Result<crate::output::ListUserTagsOutput, crate::error::ListUserTagsError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_user_tags_error(response)
        } else {
            crate::operation_deser::parse_list_user_tags_response(response)
        }
    }
}

/// <p>Lists the virtual MFA devices defined in the Amazon Web Services account by assignment status. If
/// you do not specify an assignment status, the operation returns a list of all virtual MFA
/// devices. Assignment status can be <code>Assigned</code>, <code>Unassigned</code>, or
/// <code>Any</code>.</p>
/// <note>
/// <p>IAM resource-listing operations return a subset of the available
/// attributes for the resource. For example, this operation does not return tags, even though they are an attribute of the returned object. To view all of the information for a virtual MFA device, see
/// <a>ListVirtualMFADevices</a>.</p>
/// </note>
/// <p>You can paginate the results using the <code>MaxItems</code> and <code>Marker</code>
/// parameters.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListVirtualMFADevices {
    _private: (),
}
impl ListVirtualMFADevices {
    /// Creates a new builder-style object to manufacture [`ListVirtualMfaDevicesInput`](crate::input::ListVirtualMfaDevicesInput)
    pub fn builder() -> crate::input::list_virtual_mfa_devices_input::Builder {
        crate::input::list_virtual_mfa_devices_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListVirtualMFADevices {
    type Output = std::result::Result<
        crate::output::ListVirtualMfaDevicesOutput,
        crate::error::ListVirtualMFADevicesError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_virtual_mfa_devices_error(response)
        } else {
            crate::operation_deser::parse_list_virtual_mfa_devices_response(response)
        }
    }
}

/// <p>Adds or updates an inline policy document that is embedded in the specified IAM
/// group.</p>
/// <p>A user can also have managed policies attached to it. To attach a managed policy to a
/// group, use <a>AttachGroupPolicy</a>. To create a new managed policy, use
/// <a>CreatePolicy</a>. For information about policies, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/policies-managed-vs-inline.html">Managed
/// policies and inline policies</a> in the
/// <i>IAM User Guide</i>.</p>
/// <p>For information about the maximum number of inline policies that you can embed in a
/// group, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/reference_iam-quotas.html">IAM and STS quotas</a> in the <i>IAM User Guide</i>.</p>
/// <note>
/// <p>Because policy documents can be large, you should use POST rather than GET when
/// calling <code>PutGroupPolicy</code>. For general information about using the Query
/// API with IAM, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/IAM_UsingQueryAPI.html">Making query requests</a> in the
/// <i>IAM User Guide</i>.</p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct PutGroupPolicy {
    _private: (),
}
impl PutGroupPolicy {
    /// Creates a new builder-style object to manufacture [`PutGroupPolicyInput`](crate::input::PutGroupPolicyInput)
    pub fn builder() -> crate::input::put_group_policy_input::Builder {
        crate::input::put_group_policy_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for PutGroupPolicy {
    type Output =
        std::result::Result<crate::output::PutGroupPolicyOutput, crate::error::PutGroupPolicyError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_put_group_policy_error(response)
        } else {
            crate::operation_deser::parse_put_group_policy_response(response)
        }
    }
}

/// <p>Adds or updates the policy that is specified as the IAM role's permissions boundary.
/// You can use an Amazon Web Services managed policy or a customer managed policy to set the boundary for
/// a role. Use the boundary to control the maximum permissions that the role can have.
/// Setting a permissions boundary is an advanced feature that can affect the permissions
/// for the role.</p>
/// <p>You cannot set the boundary for a service-linked role. </p>
/// <important>
/// <p>Policies used as permissions boundaries do not provide permissions. You must also
/// attach a permissions policy to the role. To learn how the effective permissions for
/// a role are evaluated, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/reference_policies_evaluation-logic.html">IAM JSON policy
/// evaluation logic</a> in the IAM User Guide. </p>
/// </important>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct PutRolePermissionsBoundary {
    _private: (),
}
impl PutRolePermissionsBoundary {
    /// Creates a new builder-style object to manufacture [`PutRolePermissionsBoundaryInput`](crate::input::PutRolePermissionsBoundaryInput)
    pub fn builder() -> crate::input::put_role_permissions_boundary_input::Builder {
        crate::input::put_role_permissions_boundary_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for PutRolePermissionsBoundary {
    type Output = std::result::Result<
        crate::output::PutRolePermissionsBoundaryOutput,
        crate::error::PutRolePermissionsBoundaryError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_put_role_permissions_boundary_error(response)
        } else {
            crate::operation_deser::parse_put_role_permissions_boundary_response(response)
        }
    }
}

/// <p>Adds or updates an inline policy document that is embedded in the specified IAM
/// role.</p>
/// <p>When you embed an inline policy in a role, the inline policy is used as part of the
/// role's access (permissions) policy. The role's trust policy is created at the same time
/// as the role, using <a>CreateRole</a>. You can update a role's trust policy
/// using <a>UpdateAssumeRolePolicy</a>. For more information about IAM roles,
/// see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/roles-toplevel.html">Using roles to
/// delegate permissions and federate identities</a>.</p>
/// <p>A role can also have a managed policy attached to it. To attach a managed policy to a
/// role, use <a>AttachRolePolicy</a>. To create a new managed policy, use <a>CreatePolicy</a>. For information about policies, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/policies-managed-vs-inline.html">Managed
/// policies and inline policies</a> in the
/// <i>IAM User Guide</i>.</p>
/// <p>For information about the maximum number of inline policies that you can embed with a
/// role, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/reference_iam-quotas.html">IAM and STS quotas</a> in the <i>IAM User Guide</i>.</p>
/// <note>
/// <p>Because policy documents can be large, you should use POST rather than GET when
/// calling <code>PutRolePolicy</code>. For general information about using the Query
/// API with IAM, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/IAM_UsingQueryAPI.html">Making query requests</a> in the
/// <i>IAM User Guide</i>.</p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct PutRolePolicy {
    _private: (),
}
impl PutRolePolicy {
    /// Creates a new builder-style object to manufacture [`PutRolePolicyInput`](crate::input::PutRolePolicyInput)
    pub fn builder() -> crate::input::put_role_policy_input::Builder {
        crate::input::put_role_policy_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for PutRolePolicy {
    type Output =
        std::result::Result<crate::output::PutRolePolicyOutput, crate::error::PutRolePolicyError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_put_role_policy_error(response)
        } else {
            crate::operation_deser::parse_put_role_policy_response(response)
        }
    }
}

/// <p>Adds or updates the policy that is specified as the IAM user's permissions boundary.
/// You can use an Amazon Web Services managed policy or a customer managed policy to set the boundary for
/// a user. Use the boundary to control the maximum permissions that the user can have.
/// Setting a permissions boundary is an advanced feature that can affect the permissions
/// for the user.</p>
/// <important>
/// <p>Policies that are used as permissions boundaries do not provide permissions. You
/// must also attach a permissions policy to the user. To learn how the effective
/// permissions for a user are evaluated, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/reference_policies_evaluation-logic.html">IAM JSON policy
/// evaluation logic</a> in the IAM User Guide. </p>
/// </important>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct PutUserPermissionsBoundary {
    _private: (),
}
impl PutUserPermissionsBoundary {
    /// Creates a new builder-style object to manufacture [`PutUserPermissionsBoundaryInput`](crate::input::PutUserPermissionsBoundaryInput)
    pub fn builder() -> crate::input::put_user_permissions_boundary_input::Builder {
        crate::input::put_user_permissions_boundary_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for PutUserPermissionsBoundary {
    type Output = std::result::Result<
        crate::output::PutUserPermissionsBoundaryOutput,
        crate::error::PutUserPermissionsBoundaryError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_put_user_permissions_boundary_error(response)
        } else {
            crate::operation_deser::parse_put_user_permissions_boundary_response(response)
        }
    }
}

/// <p>Adds or updates an inline policy document that is embedded in the specified IAM
/// user.</p>
/// <p>An IAM user can also have a managed policy attached to it. To attach a managed
/// policy to a user, use <a>AttachUserPolicy</a>. To create a new managed
/// policy, use <a>CreatePolicy</a>. For information about policies, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/policies-managed-vs-inline.html">Managed
/// policies and inline policies</a> in the
/// <i>IAM User Guide</i>.</p>
/// <p>For information about the maximum number of inline policies that you can embed in a
/// user, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/reference_iam-quotas.html">IAM and STS quotas</a> in the <i>IAM User Guide</i>.</p>
/// <note>
/// <p>Because policy documents can be large, you should use POST rather than GET when
/// calling <code>PutUserPolicy</code>. For general information about using the Query
/// API with IAM, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/IAM_UsingQueryAPI.html">Making query requests</a> in the
/// <i>IAM User Guide</i>.</p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct PutUserPolicy {
    _private: (),
}
impl PutUserPolicy {
    /// Creates a new builder-style object to manufacture [`PutUserPolicyInput`](crate::input::PutUserPolicyInput)
    pub fn builder() -> crate::input::put_user_policy_input::Builder {
        crate::input::put_user_policy_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for PutUserPolicy {
    type Output =
        std::result::Result<crate::output::PutUserPolicyOutput, crate::error::PutUserPolicyError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_put_user_policy_error(response)
        } else {
            crate::operation_deser::parse_put_user_policy_response(response)
        }
    }
}

/// <p>Removes the specified client ID (also known as audience) from the list of client IDs
/// registered for the specified IAM OpenID Connect (OIDC) provider resource
/// object.</p>
/// <p>This operation is idempotent; it does not fail or return an error if you try to remove
/// a client ID that does not exist.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct RemoveClientIDFromOpenIDConnectProvider {
    _private: (),
}
impl RemoveClientIDFromOpenIDConnectProvider {
    /// Creates a new builder-style object to manufacture [`RemoveClientIdFromOpenIdConnectProviderInput`](crate::input::RemoveClientIdFromOpenIdConnectProviderInput)
    pub fn builder() -> crate::input::remove_client_id_from_open_id_connect_provider_input::Builder
    {
        crate::input::remove_client_id_from_open_id_connect_provider_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for RemoveClientIDFromOpenIDConnectProvider {
    type Output = std::result::Result<
        crate::output::RemoveClientIdFromOpenIdConnectProviderOutput,
        crate::error::RemoveClientIDFromOpenIDConnectProviderError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_remove_client_id_from_open_id_connect_provider_error(
                response,
            )
        } else {
            crate::operation_deser::parse_remove_client_id_from_open_id_connect_provider_response(
                response,
            )
        }
    }
}

/// <p>Removes the specified IAM role from the specified EC2 instance profile.</p>
/// <important>
/// <p>Make sure that you do not have any Amazon EC2 instances running with the role you
/// are about to remove from the instance profile. Removing a role from an instance
/// profile that is associated with a running instance might break any applications
/// running on the instance.</p>
/// </important>
/// <p> For more information about IAM roles, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/WorkingWithRoles.html">Working with roles</a>. For more
/// information about instance profiles, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/AboutInstanceProfiles.html">About instance
/// profiles</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct RemoveRoleFromInstanceProfile {
    _private: (),
}
impl RemoveRoleFromInstanceProfile {
    /// Creates a new builder-style object to manufacture [`RemoveRoleFromInstanceProfileInput`](crate::input::RemoveRoleFromInstanceProfileInput)
    pub fn builder() -> crate::input::remove_role_from_instance_profile_input::Builder {
        crate::input::remove_role_from_instance_profile_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for RemoveRoleFromInstanceProfile {
    type Output = std::result::Result<
        crate::output::RemoveRoleFromInstanceProfileOutput,
        crate::error::RemoveRoleFromInstanceProfileError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_remove_role_from_instance_profile_error(response)
        } else {
            crate::operation_deser::parse_remove_role_from_instance_profile_response(response)
        }
    }
}

/// <p>Removes the specified user from the specified group.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct RemoveUserFromGroup {
    _private: (),
}
impl RemoveUserFromGroup {
    /// Creates a new builder-style object to manufacture [`RemoveUserFromGroupInput`](crate::input::RemoveUserFromGroupInput)
    pub fn builder() -> crate::input::remove_user_from_group_input::Builder {
        crate::input::remove_user_from_group_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for RemoveUserFromGroup {
    type Output = std::result::Result<
        crate::output::RemoveUserFromGroupOutput,
        crate::error::RemoveUserFromGroupError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_remove_user_from_group_error(response)
        } else {
            crate::operation_deser::parse_remove_user_from_group_response(response)
        }
    }
}

/// <p>Resets the password for a service-specific credential. The new password is Amazon Web Services
/// generated and cryptographically strong. It cannot be configured by the user. Resetting
/// the password immediately invalidates the previous password associated with this
/// user.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ResetServiceSpecificCredential {
    _private: (),
}
impl ResetServiceSpecificCredential {
    /// Creates a new builder-style object to manufacture [`ResetServiceSpecificCredentialInput`](crate::input::ResetServiceSpecificCredentialInput)
    pub fn builder() -> crate::input::reset_service_specific_credential_input::Builder {
        crate::input::reset_service_specific_credential_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ResetServiceSpecificCredential {
    type Output = std::result::Result<
        crate::output::ResetServiceSpecificCredentialOutput,
        crate::error::ResetServiceSpecificCredentialError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_reset_service_specific_credential_error(response)
        } else {
            crate::operation_deser::parse_reset_service_specific_credential_response(response)
        }
    }
}

/// <p>Synchronizes the specified MFA device with its IAM resource object on the Amazon Web Services
/// servers.</p>
/// <p>For more information about creating and working with virtual MFA devices, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/Using_VirtualMFA.html">Using a virtual MFA
/// device</a> in the <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ResyncMFADevice {
    _private: (),
}
impl ResyncMFADevice {
    /// Creates a new builder-style object to manufacture [`ResyncMfaDeviceInput`](crate::input::ResyncMfaDeviceInput)
    pub fn builder() -> crate::input::resync_mfa_device_input::Builder {
        crate::input::resync_mfa_device_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ResyncMFADevice {
    type Output = std::result::Result<
        crate::output::ResyncMfaDeviceOutput,
        crate::error::ResyncMFADeviceError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_resync_mfa_device_error(response)
        } else {
            crate::operation_deser::parse_resync_mfa_device_response(response)
        }
    }
}

/// <p>Sets the specified version of the specified policy as the policy's default (operative)
/// version.</p>
/// <p>This operation affects all users, groups, and roles that the policy is attached to. To
/// list the users, groups, and roles that the policy is attached to, use <a>ListEntitiesForPolicy</a>.</p>
/// <p>For information about managed policies, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/policies-managed-vs-inline.html">Managed policies and inline
/// policies</a> in the <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct SetDefaultPolicyVersion {
    _private: (),
}
impl SetDefaultPolicyVersion {
    /// Creates a new builder-style object to manufacture [`SetDefaultPolicyVersionInput`](crate::input::SetDefaultPolicyVersionInput)
    pub fn builder() -> crate::input::set_default_policy_version_input::Builder {
        crate::input::set_default_policy_version_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for SetDefaultPolicyVersion {
    type Output = std::result::Result<
        crate::output::SetDefaultPolicyVersionOutput,
        crate::error::SetDefaultPolicyVersionError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_set_default_policy_version_error(response)
        } else {
            crate::operation_deser::parse_set_default_policy_version_response(response)
        }
    }
}

/// <p>Sets the specified version of the global endpoint token as the token version used for
/// the Amazon Web Services account.</p>
/// <p>By default, Security Token Service (STS) is available as a global service, and all STS requests
/// go to a single endpoint at <code>https://sts.amazonaws.com</code>. Amazon Web Services recommends
/// using Regional STS endpoints to reduce latency, build in redundancy, and increase
/// session token availability. For information about Regional endpoints for STS, see
/// <a href="https://docs.aws.amazon.com/general/latest/gr/sts.html">Security Token Service
/// endpoints and quotas</a> in the <i>Amazon Web Services General Reference</i>.</p>
/// <p>If you make an STS call to the global endpoint, the resulting session tokens might
/// be valid in some Regions but not others. It depends on the version that is set in this
/// operation. Version 1 tokens are valid only in Amazon Web Services Regions that are
/// available by default. These tokens do not work in manually enabled Regions, such as Asia
/// Pacific (Hong Kong). Version 2 tokens are valid in all Regions. However, version 2
/// tokens are longer and might affect systems where you temporarily store tokens. For
/// information, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_credentials_temp_enable-regions.html">Activating and
/// deactivating STS in an Amazon Web Services Region</a> in the
/// <i>IAM User Guide</i>.</p>
/// <p>To view the current session token version, see the
/// <code>GlobalEndpointTokenVersion</code> entry in the response of the <a>GetAccountSummary</a> operation.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct SetSecurityTokenServicePreferences {
    _private: (),
}
impl SetSecurityTokenServicePreferences {
    /// Creates a new builder-style object to manufacture [`SetSecurityTokenServicePreferencesInput`](crate::input::SetSecurityTokenServicePreferencesInput)
    pub fn builder() -> crate::input::set_security_token_service_preferences_input::Builder {
        crate::input::set_security_token_service_preferences_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for SetSecurityTokenServicePreferences {
    type Output = std::result::Result<
        crate::output::SetSecurityTokenServicePreferencesOutput,
        crate::error::SetSecurityTokenServicePreferencesError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_set_security_token_service_preferences_error(response)
        } else {
            crate::operation_deser::parse_set_security_token_service_preferences_response(response)
        }
    }
}

/// <p>Simulate how a set of IAM policies and optionally a resource-based policy works with
/// a list of API operations and Amazon Web Services resources to determine the policies' effective
/// permissions. The policies are provided as strings.</p>
/// <p>The simulation does not perform the API operations; it only checks the authorization
/// to determine if the simulated policies allow or deny the operations. You can simulate
/// resources that don't exist in your account.</p>
/// <p>If you want to simulate existing policies that are attached to an IAM user, group,
/// or role, use <a>SimulatePrincipalPolicy</a> instead.</p>
/// <p>Context keys are variables that are maintained by Amazon Web Services and its services and which
/// provide details about the context of an API query request. You can use the
/// <code>Condition</code> element of an IAM policy to evaluate context keys. To get
/// the list of context keys that the policies require for correct simulation, use <a>GetContextKeysForCustomPolicy</a>.</p>
/// <p>If the output is long, you can use <code>MaxItems</code> and <code>Marker</code>
/// parameters to paginate the results.</p>
/// <p>For more information about using the policy simulator, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/access_policies_testing-policies.html">Testing IAM policies
/// with the IAM policy simulator </a>in the
/// <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct SimulateCustomPolicy {
    _private: (),
}
impl SimulateCustomPolicy {
    /// Creates a new builder-style object to manufacture [`SimulateCustomPolicyInput`](crate::input::SimulateCustomPolicyInput)
    pub fn builder() -> crate::input::simulate_custom_policy_input::Builder {
        crate::input::simulate_custom_policy_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for SimulateCustomPolicy {
    type Output = std::result::Result<
        crate::output::SimulateCustomPolicyOutput,
        crate::error::SimulateCustomPolicyError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_simulate_custom_policy_error(response)
        } else {
            crate::operation_deser::parse_simulate_custom_policy_response(response)
        }
    }
}

/// <p>Simulate how a set of IAM policies attached to an IAM entity works with a list of
/// API operations and Amazon Web Services resources to determine the policies' effective permissions. The
/// entity can be an IAM user, group, or role. If you specify a user, then the simulation
/// also includes all of the policies that are attached to groups that the user belongs to.
/// You can simulate resources that don't exist in your account.</p>
/// <p>You can optionally include a list of one or more additional policies specified as
/// strings to include in the simulation. If you want to simulate only policies specified as
/// strings, use <a>SimulateCustomPolicy</a> instead.</p>
/// <p>You can also optionally include one resource-based policy to be evaluated with each of
/// the resources included in the simulation.</p>
/// <p>The simulation does not perform the API operations; it only checks the authorization
/// to determine if the simulated policies allow or deny the operations.</p>
/// <p>
/// <b>Note:</b> This operation discloses information about the
/// permissions granted to other users. If you do not want users to see other user's
/// permissions, then consider allowing them to use <a>SimulateCustomPolicy</a>
/// instead.</p>
/// <p>Context keys are variables maintained by Amazon Web Services and its services that provide details
/// about the context of an API query request. You can use the <code>Condition</code>
/// element of an IAM policy to evaluate context keys. To get the list of context keys
/// that the policies require for correct simulation, use <a>GetContextKeysForPrincipalPolicy</a>.</p>
/// <p>If the output is long, you can use the <code>MaxItems</code> and <code>Marker</code>
/// parameters to paginate the results.</p>
/// <p>For more information about using the policy simulator, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/access_policies_testing-policies.html">Testing IAM policies
/// with the IAM policy simulator </a>in the
/// <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct SimulatePrincipalPolicy {
    _private: (),
}
impl SimulatePrincipalPolicy {
    /// Creates a new builder-style object to manufacture [`SimulatePrincipalPolicyInput`](crate::input::SimulatePrincipalPolicyInput)
    pub fn builder() -> crate::input::simulate_principal_policy_input::Builder {
        crate::input::simulate_principal_policy_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for SimulatePrincipalPolicy {
    type Output = std::result::Result<
        crate::output::SimulatePrincipalPolicyOutput,
        crate::error::SimulatePrincipalPolicyError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_simulate_principal_policy_error(response)
        } else {
            crate::operation_deser::parse_simulate_principal_policy_response(response)
        }
    }
}

/// <p>Adds one or more tags to an IAM instance profile. If a tag with the same key name
/// already exists, then that tag is overwritten with the new value.</p>
/// <p>Each tag consists of a key name and an associated value. By assigning tags to your resources, you can do the
/// following:</p>
/// <ul>
/// <li>
/// <p>
/// <b>Administrative grouping and discovery</b> - Attach
/// tags to resources to aid in organization and search. For example, you could search for all
/// resources with the key name <i>Project</i> and the value
/// <i>MyImportantProject</i>. Or search for all resources with the key name
/// <i>Cost Center</i> and the value <i>41200</i>. </p>
/// </li>
/// <li>
/// <p>
/// <b>Access control</b> - Include tags in IAM user-based
/// and resource-based policies. You can use tags to restrict access to only an IAM instance
/// profile that has a specified tag attached. For examples of policies that show how to use
/// tags to control access, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/access_tags.html">Control access using IAM tags</a> in the
/// <i>IAM User Guide</i>.</p>
/// </li>
/// </ul>
/// <note>
/// <ul>
/// <li>
/// <p>If any one of the tags is invalid or if you exceed the allowed maximum number of tags, then the entire request
/// fails and the resource is not created. For more information about tagging, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_tags.html">Tagging IAM resources</a> in the
/// <i>IAM User Guide</i>.</p>
/// </li>
/// <li>
/// <p>Amazon Web Services always interprets the tag <code>Value</code> as a single string. If you
/// need to store an array, you can store comma-separated values in the string. However, you
/// must interpret the value in your code.</p>
/// </li>
/// </ul>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct TagInstanceProfile {
    _private: (),
}
impl TagInstanceProfile {
    /// Creates a new builder-style object to manufacture [`TagInstanceProfileInput`](crate::input::TagInstanceProfileInput)
    pub fn builder() -> crate::input::tag_instance_profile_input::Builder {
        crate::input::tag_instance_profile_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for TagInstanceProfile {
    type Output = std::result::Result<
        crate::output::TagInstanceProfileOutput,
        crate::error::TagInstanceProfileError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_tag_instance_profile_error(response)
        } else {
            crate::operation_deser::parse_tag_instance_profile_response(response)
        }
    }
}

/// <p>Adds one or more tags to an IAM virtual multi-factor authentication (MFA) device. If
/// a tag with the same key name already exists, then that tag is overwritten with the new
/// value.</p>
/// <p>A tag consists of a key name and an associated value. By assigning tags to your
/// resources, you can do the following:</p>
/// <ul>
/// <li>
/// <p>
/// <b>Administrative grouping and discovery</b> - Attach
/// tags to resources to aid in organization and search. For example, you could search for all
/// resources with the key name <i>Project</i> and the value
/// <i>MyImportantProject</i>. Or search for all resources with the key name
/// <i>Cost Center</i> and the value <i>41200</i>. </p>
/// </li>
/// <li>
/// <p>
/// <b>Access control</b> - Include tags in IAM user-based
/// and resource-based policies. You can use tags to restrict access to only an IAM virtual
/// MFA device that has a specified tag attached. For examples of policies that show how to
/// use tags to control access, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/access_tags.html">Control access using IAM tags</a> in the
/// <i>IAM User Guide</i>.</p>
/// </li>
/// </ul>
/// <note>
/// <ul>
/// <li>
/// <p>If any one of the tags is invalid or if you exceed the allowed maximum number of tags, then the entire request
/// fails and the resource is not created. For more information about tagging, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_tags.html">Tagging IAM resources</a> in the
/// <i>IAM User Guide</i>.</p>
/// </li>
/// <li>
/// <p>Amazon Web Services always interprets the tag <code>Value</code> as a single string. If you
/// need to store an array, you can store comma-separated values in the string. However, you
/// must interpret the value in your code.</p>
/// </li>
/// </ul>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct TagMFADevice {
    _private: (),
}
impl TagMFADevice {
    /// Creates a new builder-style object to manufacture [`TagMfaDeviceInput`](crate::input::TagMfaDeviceInput)
    pub fn builder() -> crate::input::tag_mfa_device_input::Builder {
        crate::input::tag_mfa_device_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for TagMFADevice {
    type Output =
        std::result::Result<crate::output::TagMfaDeviceOutput, crate::error::TagMFADeviceError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_tag_mfa_device_error(response)
        } else {
            crate::operation_deser::parse_tag_mfa_device_response(response)
        }
    }
}

/// <p>Adds one or more tags to an OpenID Connect (OIDC)-compatible identity provider. For
/// more information about these providers, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_roles_providers_oidc.html">About web identity federation</a>. If
/// a tag with the same key name already exists, then that tag is overwritten with the new
/// value.</p>
/// <p>A tag consists of a key name and an associated value. By assigning tags to your
/// resources, you can do the following:</p>
/// <ul>
/// <li>
/// <p>
/// <b>Administrative grouping and discovery</b> - Attach
/// tags to resources to aid in organization and search. For example, you could search for all
/// resources with the key name <i>Project</i> and the value
/// <i>MyImportantProject</i>. Or search for all resources with the key name
/// <i>Cost Center</i> and the value <i>41200</i>. </p>
/// </li>
/// <li>
/// <p>
/// <b>Access control</b> - Include tags in IAM user-based
/// and resource-based policies. You can use tags to restrict access to only an OIDC provider
/// that has a specified tag attached. For examples of policies that show how to use tags to
/// control access, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/access_tags.html">Control access using IAM tags</a> in the
/// <i>IAM User Guide</i>.</p>
/// </li>
/// </ul>
/// <note>
/// <ul>
/// <li>
/// <p>If any one of the tags is invalid or if you exceed the allowed maximum number of tags, then the entire request
/// fails and the resource is not created. For more information about tagging, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_tags.html">Tagging IAM resources</a> in the
/// <i>IAM User Guide</i>.</p>
/// </li>
/// <li>
/// <p>Amazon Web Services always interprets the tag <code>Value</code> as a single string. If you
/// need to store an array, you can store comma-separated values in the string. However, you
/// must interpret the value in your code.</p>
/// </li>
/// </ul>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct TagOpenIDConnectProvider {
    _private: (),
}
impl TagOpenIDConnectProvider {
    /// Creates a new builder-style object to manufacture [`TagOpenIdConnectProviderInput`](crate::input::TagOpenIdConnectProviderInput)
    pub fn builder() -> crate::input::tag_open_id_connect_provider_input::Builder {
        crate::input::tag_open_id_connect_provider_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for TagOpenIDConnectProvider {
    type Output = std::result::Result<
        crate::output::TagOpenIdConnectProviderOutput,
        crate::error::TagOpenIDConnectProviderError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_tag_open_id_connect_provider_error(response)
        } else {
            crate::operation_deser::parse_tag_open_id_connect_provider_response(response)
        }
    }
}

/// <p>Adds one or more tags to an IAM customer managed policy. If a tag with the same key
/// name already exists, then that tag is overwritten with the new value.</p>
/// <p>A tag consists of a key name and an associated value. By assigning tags to your
/// resources, you can do the following:</p>
/// <ul>
/// <li>
/// <p>
/// <b>Administrative grouping and discovery</b> - Attach
/// tags to resources to aid in organization and search. For example, you could search for all
/// resources with the key name <i>Project</i> and the value
/// <i>MyImportantProject</i>. Or search for all resources with the key name
/// <i>Cost Center</i> and the value <i>41200</i>. </p>
/// </li>
/// <li>
/// <p>
/// <b>Access control</b> - Include tags in IAM user-based
/// and resource-based policies. You can use tags to restrict access to only an IAM customer
/// managed policy that has a specified tag attached. For examples of policies that show how
/// to use tags to control access, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/access_tags.html">Control access using IAM tags</a> in the
/// <i>IAM User Guide</i>.</p>
/// </li>
/// </ul>
/// <note>
/// <ul>
/// <li>
/// <p>If any one of the tags is invalid or if you exceed the allowed maximum number of tags, then the entire request
/// fails and the resource is not created. For more information about tagging, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_tags.html">Tagging IAM resources</a> in the
/// <i>IAM User Guide</i>.</p>
/// </li>
/// <li>
/// <p>Amazon Web Services always interprets the tag <code>Value</code> as a single string. If you
/// need to store an array, you can store comma-separated values in the string. However, you
/// must interpret the value in your code.</p>
/// </li>
/// </ul>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct TagPolicy {
    _private: (),
}
impl TagPolicy {
    /// Creates a new builder-style object to manufacture [`TagPolicyInput`](crate::input::TagPolicyInput)
    pub fn builder() -> crate::input::tag_policy_input::Builder {
        crate::input::tag_policy_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for TagPolicy {
    type Output = std::result::Result<crate::output::TagPolicyOutput, crate::error::TagPolicyError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_tag_policy_error(response)
        } else {
            crate::operation_deser::parse_tag_policy_response(response)
        }
    }
}

/// <p>Adds one or more tags to an IAM role. The role can be a regular role or a
/// service-linked role. If a tag with the same key name already exists, then that tag is
/// overwritten with the new value.</p>
/// <p>A tag consists of a key name and an associated value. By assigning tags to your
/// resources, you can do the following:</p>
/// <ul>
/// <li>
/// <p>
/// <b>Administrative grouping and discovery</b> - Attach
/// tags to resources to aid in organization and search. For example, you could search for all
/// resources with the key name <i>Project</i> and the value
/// <i>MyImportantProject</i>. Or search for all resources with the key name
/// <i>Cost Center</i> and the value <i>41200</i>. </p>
/// </li>
/// <li>
/// <p>
/// <b>Access control</b> - Include tags in IAM user-based
/// and resource-based policies. You can use tags to restrict access to only an IAM role
/// that has a specified tag attached. You can also restrict access to only those resources
/// that have a certain tag attached. For examples of policies that show how to use tags to
/// control access, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/access_tags.html">Control access using IAM tags</a> in the
/// <i>IAM User Guide</i>.</p>
/// </li>
/// <li>
/// <p>
/// <b>Cost allocation</b> - Use tags to help track which
/// individuals and teams are using which Amazon Web Services resources.</p>
/// </li>
/// </ul>
/// <note>
/// <ul>
/// <li>
/// <p>If any one of the tags is invalid or if you exceed the allowed maximum number of tags, then the entire request
/// fails and the resource is not created. For more information about tagging, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_tags.html">Tagging IAM resources</a> in the
/// <i>IAM User Guide</i>.</p>
/// </li>
/// <li>
/// <p>Amazon Web Services always interprets the tag <code>Value</code> as a single string. If you
/// need to store an array, you can store comma-separated values in the string. However, you
/// must interpret the value in your code.</p>
/// </li>
/// </ul>
/// </note>
/// <p>For more information about tagging, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_tags.html">Tagging IAM identities</a> in the
/// <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct TagRole {
    _private: (),
}
impl TagRole {
    /// Creates a new builder-style object to manufacture [`TagRoleInput`](crate::input::TagRoleInput)
    pub fn builder() -> crate::input::tag_role_input::Builder {
        crate::input::tag_role_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for TagRole {
    type Output = std::result::Result<crate::output::TagRoleOutput, crate::error::TagRoleError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_tag_role_error(response)
        } else {
            crate::operation_deser::parse_tag_role_response(response)
        }
    }
}

/// <p>Adds one or more tags to a Security Assertion Markup Language (SAML) identity provider.
/// For more information about these providers, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_roles_providers_saml.html">About SAML 2.0-based federation </a>.
/// If a tag with the same key name already exists, then that tag is overwritten with the new
/// value.</p>
/// <p>A tag consists of a key name and an associated value. By assigning tags to your
/// resources, you can do the following:</p>
/// <ul>
/// <li>
/// <p>
/// <b>Administrative grouping and discovery</b> - Attach
/// tags to resources to aid in organization and search. For example, you could search for all
/// resources with the key name <i>Project</i> and the value
/// <i>MyImportantProject</i>. Or search for all resources with the key name
/// <i>Cost Center</i> and the value <i>41200</i>. </p>
/// </li>
/// <li>
/// <p>
/// <b>Access control</b> - Include tags in IAM user-based
/// and resource-based policies. You can use tags to restrict access to only a SAML identity
/// provider that has a specified tag attached. For examples of policies that show how to use
/// tags to control access, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/access_tags.html">Control access using IAM tags</a> in the
/// <i>IAM User Guide</i>.</p>
/// </li>
/// </ul>
/// <note>
/// <ul>
/// <li>
/// <p>If any one of the tags is invalid or if you exceed the allowed maximum number of tags, then the entire request
/// fails and the resource is not created. For more information about tagging, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_tags.html">Tagging IAM resources</a> in the
/// <i>IAM User Guide</i>.</p>
/// </li>
/// <li>
/// <p>Amazon Web Services always interprets the tag <code>Value</code> as a single string. If you
/// need to store an array, you can store comma-separated values in the string. However, you
/// must interpret the value in your code.</p>
/// </li>
/// </ul>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct TagSAMLProvider {
    _private: (),
}
impl TagSAMLProvider {
    /// Creates a new builder-style object to manufacture [`TagSamlProviderInput`](crate::input::TagSamlProviderInput)
    pub fn builder() -> crate::input::tag_saml_provider_input::Builder {
        crate::input::tag_saml_provider_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for TagSAMLProvider {
    type Output = std::result::Result<
        crate::output::TagSamlProviderOutput,
        crate::error::TagSAMLProviderError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_tag_saml_provider_error(response)
        } else {
            crate::operation_deser::parse_tag_saml_provider_response(response)
        }
    }
}

/// <p>Adds one or more tags to an IAM server certificate. If a tag with the same key name
/// already exists, then that tag is overwritten with the new value.</p>
/// <note>
/// <p>For certificates in a Region supported by Certificate Manager (ACM), we
/// recommend that you don't use IAM server certificates. Instead, use ACM to provision,
/// manage, and deploy your server certificates. For more information about IAM server
/// certificates, <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_credentials_server-certs.html">Working with server
/// certificates</a> in the <i>IAM User Guide</i>.</p>
/// </note>
/// <p>A tag consists of a key name and an associated value. By assigning tags to your
/// resources, you can do the following:</p>
/// <ul>
/// <li>
/// <p>
/// <b>Administrative grouping and discovery</b> - Attach
/// tags to resources to aid in organization and search. For example, you could search for all
/// resources with the key name <i>Project</i> and the value
/// <i>MyImportantProject</i>. Or search for all resources with the key name
/// <i>Cost Center</i> and the value <i>41200</i>. </p>
/// </li>
/// <li>
/// <p>
/// <b>Access control</b> - Include tags in IAM user-based
/// and resource-based policies. You can use tags to restrict access to only a server
/// certificate that has a specified tag attached. For examples of policies that show how to
/// use tags to control access, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/access_tags.html">Control access using IAM tags</a> in the
/// <i>IAM User Guide</i>.</p>
/// </li>
/// <li>
/// <p>
/// <b>Cost allocation</b> - Use tags to help track which
/// individuals and teams are using which Amazon Web Services resources.</p>
/// </li>
/// </ul>
/// <note>
/// <ul>
/// <li>
/// <p>If any one of the tags is invalid or if you exceed the allowed maximum number of tags, then the entire request
/// fails and the resource is not created. For more information about tagging, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_tags.html">Tagging IAM resources</a> in the
/// <i>IAM User Guide</i>.</p>
/// </li>
/// <li>
/// <p>Amazon Web Services always interprets the tag <code>Value</code> as a single string. If you
/// need to store an array, you can store comma-separated values in the string. However, you
/// must interpret the value in your code.</p>
/// </li>
/// </ul>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct TagServerCertificate {
    _private: (),
}
impl TagServerCertificate {
    /// Creates a new builder-style object to manufacture [`TagServerCertificateInput`](crate::input::TagServerCertificateInput)
    pub fn builder() -> crate::input::tag_server_certificate_input::Builder {
        crate::input::tag_server_certificate_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for TagServerCertificate {
    type Output = std::result::Result<
        crate::output::TagServerCertificateOutput,
        crate::error::TagServerCertificateError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_tag_server_certificate_error(response)
        } else {
            crate::operation_deser::parse_tag_server_certificate_response(response)
        }
    }
}

/// <p>Adds one or more tags to an IAM user. If a tag with the same key name already exists,
/// then that tag is overwritten with the new value.</p>
/// <p>A tag consists of a key name and an associated value. By assigning tags to your
/// resources, you can do the following:</p>
/// <ul>
/// <li>
/// <p>
/// <b>Administrative grouping and discovery</b> - Attach
/// tags to resources to aid in organization and search. For example, you could search for all
/// resources with the key name <i>Project</i> and the value
/// <i>MyImportantProject</i>. Or search for all resources with the key name
/// <i>Cost Center</i> and the value <i>41200</i>. </p>
/// </li>
/// <li>
/// <p>
/// <b>Access control</b> - Include tags in IAM user-based
/// and resource-based policies. You can use tags to restrict access to only an IAM
/// requesting user that has a specified tag attached. You can also restrict access to only
/// those resources that have a certain tag attached. For examples of policies that show how
/// to use tags to control access, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/access_tags.html">Control access using IAM tags</a> in the
/// <i>IAM User Guide</i>.</p>
/// </li>
/// <li>
/// <p>
/// <b>Cost allocation</b> - Use tags to help track which
/// individuals and teams are using which Amazon Web Services resources.</p>
/// </li>
/// </ul>
/// <note>
/// <ul>
/// <li>
/// <p>If any one of the tags is invalid or if you exceed the allowed maximum number of tags, then the entire request
/// fails and the resource is not created. For more information about tagging, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_tags.html">Tagging IAM resources</a> in the
/// <i>IAM User Guide</i>.</p>
/// </li>
/// <li>
/// <p>Amazon Web Services always interprets the tag <code>Value</code> as a single string. If you
/// need to store an array, you can store comma-separated values in the string. However, you
/// must interpret the value in your code.</p>
/// </li>
/// </ul>
/// </note>
/// <p>For more information about tagging, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_tags.html">Tagging IAM identities</a> in the
/// <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct TagUser {
    _private: (),
}
impl TagUser {
    /// Creates a new builder-style object to manufacture [`TagUserInput`](crate::input::TagUserInput)
    pub fn builder() -> crate::input::tag_user_input::Builder {
        crate::input::tag_user_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for TagUser {
    type Output = std::result::Result<crate::output::TagUserOutput, crate::error::TagUserError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_tag_user_error(response)
        } else {
            crate::operation_deser::parse_tag_user_response(response)
        }
    }
}

/// <p>Removes the specified tags from the IAM instance profile. For more information about tagging, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_tags.html">Tagging IAM resources</a> in the
/// <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UntagInstanceProfile {
    _private: (),
}
impl UntagInstanceProfile {
    /// Creates a new builder-style object to manufacture [`UntagInstanceProfileInput`](crate::input::UntagInstanceProfileInput)
    pub fn builder() -> crate::input::untag_instance_profile_input::Builder {
        crate::input::untag_instance_profile_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UntagInstanceProfile {
    type Output = std::result::Result<
        crate::output::UntagInstanceProfileOutput,
        crate::error::UntagInstanceProfileError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_untag_instance_profile_error(response)
        } else {
            crate::operation_deser::parse_untag_instance_profile_response(response)
        }
    }
}

/// <p>Removes the specified tags from the IAM virtual multi-factor authentication (MFA)
/// device. For more information about tagging, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_tags.html">Tagging IAM resources</a> in the
/// <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UntagMFADevice {
    _private: (),
}
impl UntagMFADevice {
    /// Creates a new builder-style object to manufacture [`UntagMfaDeviceInput`](crate::input::UntagMfaDeviceInput)
    pub fn builder() -> crate::input::untag_mfa_device_input::Builder {
        crate::input::untag_mfa_device_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UntagMFADevice {
    type Output =
        std::result::Result<crate::output::UntagMfaDeviceOutput, crate::error::UntagMFADeviceError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_untag_mfa_device_error(response)
        } else {
            crate::operation_deser::parse_untag_mfa_device_response(response)
        }
    }
}

/// <p>Removes the specified tags from the specified OpenID Connect (OIDC)-compatible identity
/// provider in IAM. For more information about OIDC providers, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_roles_providers_oidc.html">About web identity federation</a>.
/// For more information about tagging, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_tags.html">Tagging IAM resources</a> in the
/// <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UntagOpenIDConnectProvider {
    _private: (),
}
impl UntagOpenIDConnectProvider {
    /// Creates a new builder-style object to manufacture [`UntagOpenIdConnectProviderInput`](crate::input::UntagOpenIdConnectProviderInput)
    pub fn builder() -> crate::input::untag_open_id_connect_provider_input::Builder {
        crate::input::untag_open_id_connect_provider_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UntagOpenIDConnectProvider {
    type Output = std::result::Result<
        crate::output::UntagOpenIdConnectProviderOutput,
        crate::error::UntagOpenIDConnectProviderError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_untag_open_id_connect_provider_error(response)
        } else {
            crate::operation_deser::parse_untag_open_id_connect_provider_response(response)
        }
    }
}

/// <p>Removes the specified tags from the customer managed policy. For more information about tagging, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_tags.html">Tagging IAM resources</a> in the
/// <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UntagPolicy {
    _private: (),
}
impl UntagPolicy {
    /// Creates a new builder-style object to manufacture [`UntagPolicyInput`](crate::input::UntagPolicyInput)
    pub fn builder() -> crate::input::untag_policy_input::Builder {
        crate::input::untag_policy_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UntagPolicy {
    type Output =
        std::result::Result<crate::output::UntagPolicyOutput, crate::error::UntagPolicyError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_untag_policy_error(response)
        } else {
            crate::operation_deser::parse_untag_policy_response(response)
        }
    }
}

/// <p>Removes the specified tags from the role. For more information about tagging, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_tags.html">Tagging IAM resources</a> in the
/// <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UntagRole {
    _private: (),
}
impl UntagRole {
    /// Creates a new builder-style object to manufacture [`UntagRoleInput`](crate::input::UntagRoleInput)
    pub fn builder() -> crate::input::untag_role_input::Builder {
        crate::input::untag_role_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UntagRole {
    type Output = std::result::Result<crate::output::UntagRoleOutput, crate::error::UntagRoleError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_untag_role_error(response)
        } else {
            crate::operation_deser::parse_untag_role_response(response)
        }
    }
}

/// <p>Removes the specified tags from the specified Security Assertion Markup Language (SAML)
/// identity provider in IAM. For more information about these providers, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_roles_providers_oidc.html">About web identity
/// federation</a>. For more information about tagging, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_tags.html">Tagging IAM resources</a> in the
/// <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UntagSAMLProvider {
    _private: (),
}
impl UntagSAMLProvider {
    /// Creates a new builder-style object to manufacture [`UntagSamlProviderInput`](crate::input::UntagSamlProviderInput)
    pub fn builder() -> crate::input::untag_saml_provider_input::Builder {
        crate::input::untag_saml_provider_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UntagSAMLProvider {
    type Output = std::result::Result<
        crate::output::UntagSamlProviderOutput,
        crate::error::UntagSAMLProviderError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_untag_saml_provider_error(response)
        } else {
            crate::operation_deser::parse_untag_saml_provider_response(response)
        }
    }
}

/// <p>Removes the specified tags from the IAM server certificate.
/// For more information about tagging, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_tags.html">Tagging IAM resources</a> in the
/// <i>IAM User Guide</i>.</p>
/// <note>
/// <p>For certificates in a Region supported by Certificate Manager (ACM), we
/// recommend that you don't use IAM server certificates. Instead, use ACM to provision,
/// manage, and deploy your server certificates. For more information about IAM server
/// certificates, <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_credentials_server-certs.html">Working with server
/// certificates</a> in the <i>IAM User Guide</i>.</p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UntagServerCertificate {
    _private: (),
}
impl UntagServerCertificate {
    /// Creates a new builder-style object to manufacture [`UntagServerCertificateInput`](crate::input::UntagServerCertificateInput)
    pub fn builder() -> crate::input::untag_server_certificate_input::Builder {
        crate::input::untag_server_certificate_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UntagServerCertificate {
    type Output = std::result::Result<
        crate::output::UntagServerCertificateOutput,
        crate::error::UntagServerCertificateError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_untag_server_certificate_error(response)
        } else {
            crate::operation_deser::parse_untag_server_certificate_response(response)
        }
    }
}

/// <p>Removes the specified tags from the user. For more information about tagging, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_tags.html">Tagging IAM resources</a> in the
/// <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UntagUser {
    _private: (),
}
impl UntagUser {
    /// Creates a new builder-style object to manufacture [`UntagUserInput`](crate::input::UntagUserInput)
    pub fn builder() -> crate::input::untag_user_input::Builder {
        crate::input::untag_user_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UntagUser {
    type Output = std::result::Result<crate::output::UntagUserOutput, crate::error::UntagUserError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_untag_user_error(response)
        } else {
            crate::operation_deser::parse_untag_user_response(response)
        }
    }
}

/// <p>Changes the status of the specified access key from Active to Inactive, or vice versa.
/// This operation can be used to disable a user's key as part of a key rotation
/// workflow.</p>
/// <p>If the <code>UserName</code> is not specified, the user name is determined implicitly
/// based on the Amazon Web Services access key ID used to sign the request. This operation works for
/// access keys under the Amazon Web Services account. Consequently, you can use this operation to manage
/// Amazon Web Services account root user credentials even if the Amazon Web Services account has no associated
/// users.</p>
/// <p>For information about rotating keys, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/ManagingCredentials.html">Managing keys and certificates</a>
/// in the <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UpdateAccessKey {
    _private: (),
}
impl UpdateAccessKey {
    /// Creates a new builder-style object to manufacture [`UpdateAccessKeyInput`](crate::input::UpdateAccessKeyInput)
    pub fn builder() -> crate::input::update_access_key_input::Builder {
        crate::input::update_access_key_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UpdateAccessKey {
    type Output = std::result::Result<
        crate::output::UpdateAccessKeyOutput,
        crate::error::UpdateAccessKeyError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_update_access_key_error(response)
        } else {
            crate::operation_deser::parse_update_access_key_response(response)
        }
    }
}

/// <p>Updates the password policy settings for the Amazon Web Services account.</p>
/// <note>
/// <ul>
/// <li>
/// <p>This operation does not support partial updates. No parameters are
/// required, but if you do not specify a parameter, that parameter's value
/// reverts to its default value. See the <b>Request
/// Parameters</b> section for each parameter's default value. Also
/// note that some parameters do not allow the default parameter to be
/// explicitly set. Instead, to invoke the default value, do not include that
/// parameter when you invoke the operation.</p>
/// </li>
/// </ul>
/// </note>
/// <p> For more information about using a password policy, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/Using_ManagingPasswordPolicies.html">Managing an IAM password
/// policy</a> in the <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UpdateAccountPasswordPolicy {
    _private: (),
}
impl UpdateAccountPasswordPolicy {
    /// Creates a new builder-style object to manufacture [`UpdateAccountPasswordPolicyInput`](crate::input::UpdateAccountPasswordPolicyInput)
    pub fn builder() -> crate::input::update_account_password_policy_input::Builder {
        crate::input::update_account_password_policy_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UpdateAccountPasswordPolicy {
    type Output = std::result::Result<
        crate::output::UpdateAccountPasswordPolicyOutput,
        crate::error::UpdateAccountPasswordPolicyError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_update_account_password_policy_error(response)
        } else {
            crate::operation_deser::parse_update_account_password_policy_response(response)
        }
    }
}

/// <p>Updates the policy that grants an IAM entity permission to assume a role. This is
/// typically referred to as the "role trust policy". For more information about roles, see
/// <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/roles-toplevel.html">Using roles to
/// delegate permissions and federate identities</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UpdateAssumeRolePolicy {
    _private: (),
}
impl UpdateAssumeRolePolicy {
    /// Creates a new builder-style object to manufacture [`UpdateAssumeRolePolicyInput`](crate::input::UpdateAssumeRolePolicyInput)
    pub fn builder() -> crate::input::update_assume_role_policy_input::Builder {
        crate::input::update_assume_role_policy_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UpdateAssumeRolePolicy {
    type Output = std::result::Result<
        crate::output::UpdateAssumeRolePolicyOutput,
        crate::error::UpdateAssumeRolePolicyError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_update_assume_role_policy_error(response)
        } else {
            crate::operation_deser::parse_update_assume_role_policy_response(response)
        }
    }
}

/// <p>Updates the name and/or the path of the specified IAM group.</p>
/// <important>
/// <p> You should understand the implications of changing a group's path or name. For
/// more information, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/Using_WorkingWithGroupsAndUsers.html">Renaming users and
/// groups</a> in the <i>IAM User Guide</i>.</p>
/// </important>
/// <note>
/// <p>The person making the request (the principal), must have permission to change the
/// role group with the old name and the new name. For example, to change the group
/// named <code>Managers</code> to <code>MGRs</code>, the principal must have a policy
/// that allows them to update both groups. If the principal has permission to update
/// the <code>Managers</code> group, but not the <code>MGRs</code> group, then the
/// update fails. For more information about permissions, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/access.html">Access management</a>.
/// </p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UpdateGroup {
    _private: (),
}
impl UpdateGroup {
    /// Creates a new builder-style object to manufacture [`UpdateGroupInput`](crate::input::UpdateGroupInput)
    pub fn builder() -> crate::input::update_group_input::Builder {
        crate::input::update_group_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UpdateGroup {
    type Output =
        std::result::Result<crate::output::UpdateGroupOutput, crate::error::UpdateGroupError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_update_group_error(response)
        } else {
            crate::operation_deser::parse_update_group_response(response)
        }
    }
}

/// <p>Changes the password for the specified IAM user. You can use the CLI,
/// the Amazon Web Services API, or the <b>Users</b> page in the IAM console
/// to change the password for any IAM user. Use <a>ChangePassword</a> to
/// change your own password in the <b>My Security Credentials</b>
/// page in the Amazon Web Services Management Console.</p>
/// <p>For more information about modifying passwords, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/Using_ManagingLogins.html">Managing passwords</a> in the
/// <i>IAM User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UpdateLoginProfile {
    _private: (),
}
impl UpdateLoginProfile {
    /// Creates a new builder-style object to manufacture [`UpdateLoginProfileInput`](crate::input::UpdateLoginProfileInput)
    pub fn builder() -> crate::input::update_login_profile_input::Builder {
        crate::input::update_login_profile_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UpdateLoginProfile {
    type Output = std::result::Result<
        crate::output::UpdateLoginProfileOutput,
        crate::error::UpdateLoginProfileError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_update_login_profile_error(response)
        } else {
            crate::operation_deser::parse_update_login_profile_response(response)
        }
    }
}

/// <p>Replaces the existing list of server certificate thumbprints associated with an OpenID
/// Connect (OIDC) provider resource object with a new list of thumbprints.</p>
/// <p>The list that you pass with this operation completely replaces the existing list of
/// thumbprints. (The lists are not merged.)</p>
/// <p>Typically, you need to update a thumbprint only when the identity provider
/// certificate changes, which occurs rarely. However, if the provider's certificate
/// <i>does</i> change, any attempt to assume an IAM role that specifies
/// the OIDC provider as a principal fails until the certificate thumbprint is
/// updated.</p>
/// <note>
/// <p>Amazon Web Services secures communication with some OIDC identity providers (IdPs) through our
/// library of trusted certificate authorities (CAs) instead of using a certificate
/// thumbprint to verify your IdP server certificate. These OIDC IdPs include Google, and
/// those that use an Amazon S3 bucket to host a JSON Web Key Set (JWKS) endpoint. In these
/// cases, your legacy thumbprint remains in your configuration, but is no longer used for validation.</p>
/// </note>
/// <note>
/// <p>Trust for the OIDC provider is derived from the provider certificate and is
/// validated by the thumbprint. Therefore, it is best to limit access to the
/// <code>UpdateOpenIDConnectProviderThumbprint</code> operation to highly
/// privileged users.</p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UpdateOpenIDConnectProviderThumbprint {
    _private: (),
}
impl UpdateOpenIDConnectProviderThumbprint {
    /// Creates a new builder-style object to manufacture [`UpdateOpenIdConnectProviderThumbprintInput`](crate::input::UpdateOpenIdConnectProviderThumbprintInput)
    pub fn builder() -> crate::input::update_open_id_connect_provider_thumbprint_input::Builder {
        crate::input::update_open_id_connect_provider_thumbprint_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UpdateOpenIDConnectProviderThumbprint {
    type Output = std::result::Result<
        crate::output::UpdateOpenIdConnectProviderThumbprintOutput,
        crate::error::UpdateOpenIDConnectProviderThumbprintError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_update_open_id_connect_provider_thumbprint_error(response)
        } else {
            crate::operation_deser::parse_update_open_id_connect_provider_thumbprint_response(
                response,
            )
        }
    }
}

/// <p>Updates the description or maximum session duration setting of a role.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UpdateRole {
    _private: (),
}
impl UpdateRole {
    /// Creates a new builder-style object to manufacture [`UpdateRoleInput`](crate::input::UpdateRoleInput)
    pub fn builder() -> crate::input::update_role_input::Builder {
        crate::input::update_role_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UpdateRole {
    type Output =
        std::result::Result<crate::output::UpdateRoleOutput, crate::error::UpdateRoleError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_update_role_error(response)
        } else {
            crate::operation_deser::parse_update_role_response(response)
        }
    }
}

/// <p>Use <a>UpdateRole</a> instead.</p>
/// <p>Modifies only the description of a role. This operation performs the same function as
/// the <code>Description</code> parameter in the <code>UpdateRole</code> operation.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UpdateRoleDescription {
    _private: (),
}
impl UpdateRoleDescription {
    /// Creates a new builder-style object to manufacture [`UpdateRoleDescriptionInput`](crate::input::UpdateRoleDescriptionInput)
    pub fn builder() -> crate::input::update_role_description_input::Builder {
        crate::input::update_role_description_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UpdateRoleDescription {
    type Output = std::result::Result<
        crate::output::UpdateRoleDescriptionOutput,
        crate::error::UpdateRoleDescriptionError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_update_role_description_error(response)
        } else {
            crate::operation_deser::parse_update_role_description_response(response)
        }
    }
}

/// <p>Updates the metadata document for an existing SAML provider resource object.</p>
/// <note>
/// <p>This operation requires <a href="https://docs.aws.amazon.com/general/latest/gr/signature-version-4.html">Signature Version 4</a>.</p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UpdateSAMLProvider {
    _private: (),
}
impl UpdateSAMLProvider {
    /// Creates a new builder-style object to manufacture [`UpdateSamlProviderInput`](crate::input::UpdateSamlProviderInput)
    pub fn builder() -> crate::input::update_saml_provider_input::Builder {
        crate::input::update_saml_provider_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UpdateSAMLProvider {
    type Output = std::result::Result<
        crate::output::UpdateSamlProviderOutput,
        crate::error::UpdateSAMLProviderError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_update_saml_provider_error(response)
        } else {
            crate::operation_deser::parse_update_saml_provider_response(response)
        }
    }
}

/// <p>Updates the name and/or the path of the specified server certificate stored in
/// IAM.</p>
/// <p>For more information about working with server certificates, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_credentials_server-certs.html">Working
/// with server certificates</a> in the <i>IAM User Guide</i>. This
/// topic also includes a list of Amazon Web Services services that can use the server certificates that
/// you manage with IAM.</p>
/// <important>
/// <p>You should understand the implications of changing a server certificate's path or
/// name. For more information, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_credentials_server-certs_manage.html#RenamingServerCerts">Renaming a server certificate</a> in the
/// <i>IAM User Guide</i>.</p>
/// </important>
/// <note>
/// <p>The person making the request (the principal), must have permission to change the
/// server certificate with the old name and the new name. For example, to change the
/// certificate named <code>ProductionCert</code> to <code>ProdCert</code>, the
/// principal must have a policy that allows them to update both certificates. If the
/// principal has permission to update the <code>ProductionCert</code> group, but not
/// the <code>ProdCert</code> certificate, then the update fails. For more information
/// about permissions, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/access.html">Access management</a> in the <i>IAM User Guide</i>.</p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UpdateServerCertificate {
    _private: (),
}
impl UpdateServerCertificate {
    /// Creates a new builder-style object to manufacture [`UpdateServerCertificateInput`](crate::input::UpdateServerCertificateInput)
    pub fn builder() -> crate::input::update_server_certificate_input::Builder {
        crate::input::update_server_certificate_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UpdateServerCertificate {
    type Output = std::result::Result<
        crate::output::UpdateServerCertificateOutput,
        crate::error::UpdateServerCertificateError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_update_server_certificate_error(response)
        } else {
            crate::operation_deser::parse_update_server_certificate_response(response)
        }
    }
}

/// <p>Sets the status of a service-specific credential to <code>Active</code> or
/// <code>Inactive</code>. Service-specific credentials that are inactive cannot be used
/// for authentication to the service. This operation can be used to disable a user's
/// service-specific credential as part of a credential rotation work flow.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UpdateServiceSpecificCredential {
    _private: (),
}
impl UpdateServiceSpecificCredential {
    /// Creates a new builder-style object to manufacture [`UpdateServiceSpecificCredentialInput`](crate::input::UpdateServiceSpecificCredentialInput)
    pub fn builder() -> crate::input::update_service_specific_credential_input::Builder {
        crate::input::update_service_specific_credential_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UpdateServiceSpecificCredential {
    type Output = std::result::Result<
        crate::output::UpdateServiceSpecificCredentialOutput,
        crate::error::UpdateServiceSpecificCredentialError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_update_service_specific_credential_error(response)
        } else {
            crate::operation_deser::parse_update_service_specific_credential_response(response)
        }
    }
}

/// <p>Changes the status of the specified user signing certificate from active to disabled,
/// or vice versa. This operation can be used to disable an IAM user's signing certificate
/// as part of a certificate rotation work flow.</p>
/// <p>If the <code>UserName</code> field is not specified, the user name is determined
/// implicitly based on the Amazon Web Services access key ID used to sign the request. This operation
/// works for access keys under the Amazon Web Services account. Consequently, you can use this operation
/// to manage Amazon Web Services account root user credentials even if the Amazon Web Services account has no
/// associated users.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UpdateSigningCertificate {
    _private: (),
}
impl UpdateSigningCertificate {
    /// Creates a new builder-style object to manufacture [`UpdateSigningCertificateInput`](crate::input::UpdateSigningCertificateInput)
    pub fn builder() -> crate::input::update_signing_certificate_input::Builder {
        crate::input::update_signing_certificate_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UpdateSigningCertificate {
    type Output = std::result::Result<
        crate::output::UpdateSigningCertificateOutput,
        crate::error::UpdateSigningCertificateError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_update_signing_certificate_error(response)
        } else {
            crate::operation_deser::parse_update_signing_certificate_response(response)
        }
    }
}

/// <p>Sets the status of an IAM user's SSH public key to active or inactive. SSH public
/// keys that are inactive cannot be used for authentication. This operation can be used to
/// disable a user's SSH public key as part of a key rotation work flow.</p>
/// <p>The SSH public key affected by this operation is used only for authenticating the
/// associated IAM user to an CodeCommit repository. For more information about using SSH keys
/// to authenticate to an CodeCommit repository, see <a href="https://docs.aws.amazon.com/codecommit/latest/userguide/setting-up-credentials-ssh.html">Set up CodeCommit for
/// SSH connections</a> in the <i>CodeCommit User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UpdateSSHPublicKey {
    _private: (),
}
impl UpdateSSHPublicKey {
    /// Creates a new builder-style object to manufacture [`UpdateSshPublicKeyInput`](crate::input::UpdateSshPublicKeyInput)
    pub fn builder() -> crate::input::update_ssh_public_key_input::Builder {
        crate::input::update_ssh_public_key_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UpdateSSHPublicKey {
    type Output = std::result::Result<
        crate::output::UpdateSshPublicKeyOutput,
        crate::error::UpdateSSHPublicKeyError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_update_ssh_public_key_error(response)
        } else {
            crate::operation_deser::parse_update_ssh_public_key_response(response)
        }
    }
}

/// <p>Updates the name and/or the path of the specified IAM user.</p>
/// <important>
/// <p> You should understand the implications of changing an IAM user's path or name.
/// For more information, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_users_manage.html#id_users_renaming">Renaming an IAM
/// user</a> and <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_groups_manage_rename.html">Renaming an IAM
/// group</a> in the <i>IAM User Guide</i>.</p>
/// </important>
/// <note>
/// <p> To change a user name, the requester must have appropriate permissions on both
/// the source object and the target object. For example, to change Bob to Robert, the
/// entity making the request must have permission on Bob and Robert, or must have
/// permission on all (*). For more information about permissions, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/PermissionsAndPolicies.html">Permissions and policies</a>. </p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UpdateUser {
    _private: (),
}
impl UpdateUser {
    /// Creates a new builder-style object to manufacture [`UpdateUserInput`](crate::input::UpdateUserInput)
    pub fn builder() -> crate::input::update_user_input::Builder {
        crate::input::update_user_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UpdateUser {
    type Output =
        std::result::Result<crate::output::UpdateUserOutput, crate::error::UpdateUserError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_update_user_error(response)
        } else {
            crate::operation_deser::parse_update_user_response(response)
        }
    }
}

/// <p>Uploads a server certificate entity for the Amazon Web Services account. The server certificate
/// entity includes a public key certificate, a private key, and an optional certificate
/// chain, which should all be PEM-encoded.</p>
/// <p>We recommend that you use <a href="https://docs.aws.amazon.com/acm/">Certificate Manager</a> to provision, manage, and deploy your server certificates. With ACM
/// you can request a certificate, deploy it to Amazon Web Services resources, and let ACM handle
/// certificate renewals for you. Certificates provided by ACM are free. For more
/// information about using ACM, see the <a href="https://docs.aws.amazon.com/acm/latest/userguide/">Certificate Manager User Guide</a>.</p>
/// <p>For more information about working with server certificates, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_credentials_server-certs.html">Working
/// with server certificates</a> in the <i>IAM User Guide</i>. This
/// topic includes a list of Amazon Web Services services that can use the server certificates that you
/// manage with IAM.</p>
/// <p>For information about the number of server certificates you can upload, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/reference_iam-quotas.html">IAM and STS
/// quotas</a> in the <i>IAM User Guide</i>.</p>
/// <note>
/// <p>Because the body of the public key certificate, private key, and the certificate
/// chain can be large, you should use POST rather than GET when calling
/// <code>UploadServerCertificate</code>. For information about setting up
/// signatures and authorization through the API, see <a href="https://docs.aws.amazon.com/general/latest/gr/signing_aws_api_requests.html">Signing Amazon Web Services API
/// requests</a> in the <i>Amazon Web Services General Reference</i>. For general
/// information about using the Query API with IAM, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/programming.html">Calling the API by making HTTP query
/// requests</a> in the <i>IAM User Guide</i>.</p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UploadServerCertificate {
    _private: (),
}
impl UploadServerCertificate {
    /// Creates a new builder-style object to manufacture [`UploadServerCertificateInput`](crate::input::UploadServerCertificateInput)
    pub fn builder() -> crate::input::upload_server_certificate_input::Builder {
        crate::input::upload_server_certificate_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UploadServerCertificate {
    type Output = std::result::Result<
        crate::output::UploadServerCertificateOutput,
        crate::error::UploadServerCertificateError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_upload_server_certificate_error(response)
        } else {
            crate::operation_deser::parse_upload_server_certificate_response(response)
        }
    }
}

/// <p>Uploads an X.509 signing certificate and associates it with the specified IAM user.
/// Some Amazon Web Services services require you to use certificates to validate requests that are signed
/// with a corresponding private key. When you upload the certificate, its default status is
/// <code>Active</code>.</p>
/// <p>For information about when you would use an X.509 signing certificate, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_credentials_server-certs.html">Managing
/// server certificates in IAM</a> in the
/// <i>IAM User Guide</i>.</p>
/// <p>If the <code>UserName</code> is not specified, the IAM user name is determined
/// implicitly based on the Amazon Web Services access key ID used to sign the request. This operation
/// works for access keys under the Amazon Web Services account. Consequently, you can use this operation
/// to manage Amazon Web Services account root user credentials even if the Amazon Web Services account has no
/// associated users.</p>
/// <note>
/// <p>Because the body of an X.509 certificate can be large, you should use POST rather
/// than GET when calling <code>UploadSigningCertificate</code>. For information about
/// setting up signatures and authorization through the API, see <a href="https://docs.aws.amazon.com/general/latest/gr/signing_aws_api_requests.html">Signing
/// Amazon Web Services API requests</a> in the <i>Amazon Web Services General Reference</i>. For
/// general information about using the Query API with IAM, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/IAM_UsingQueryAPI.html">Making query
/// requests</a> in the <i>IAM User Guide</i>.</p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UploadSigningCertificate {
    _private: (),
}
impl UploadSigningCertificate {
    /// Creates a new builder-style object to manufacture [`UploadSigningCertificateInput`](crate::input::UploadSigningCertificateInput)
    pub fn builder() -> crate::input::upload_signing_certificate_input::Builder {
        crate::input::upload_signing_certificate_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UploadSigningCertificate {
    type Output = std::result::Result<
        crate::output::UploadSigningCertificateOutput,
        crate::error::UploadSigningCertificateError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_upload_signing_certificate_error(response)
        } else {
            crate::operation_deser::parse_upload_signing_certificate_response(response)
        }
    }
}

/// <p>Uploads an SSH public key and associates it with the specified IAM user.</p>
/// <p>The SSH public key uploaded by this operation can be used only for authenticating the
/// associated IAM user to an CodeCommit repository. For more information about using SSH keys
/// to authenticate to an CodeCommit repository, see <a href="https://docs.aws.amazon.com/codecommit/latest/userguide/setting-up-credentials-ssh.html">Set up CodeCommit for
/// SSH connections</a> in the <i>CodeCommit User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UploadSSHPublicKey {
    _private: (),
}
impl UploadSSHPublicKey {
    /// Creates a new builder-style object to manufacture [`UploadSshPublicKeyInput`](crate::input::UploadSshPublicKeyInput)
    pub fn builder() -> crate::input::upload_ssh_public_key_input::Builder {
        crate::input::upload_ssh_public_key_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UploadSSHPublicKey {
    type Output = std::result::Result<
        crate::output::UploadSshPublicKeyOutput,
        crate::error::UploadSSHPublicKeyError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_upload_ssh_public_key_error(response)
        } else {
            crate::operation_deser::parse_upload_ssh_public_key_response(response)
        }
    }
}
